package com.persagy.fm.sop.mapper;

import com.persagy.fm.sop.model.dto.Profile;
import com.persagy.fm.sop.model.dto.Sop;
import com.persagy.fm.sop.model.dto.SopEdit;
import com.persagy.fm.sop.model.dto.SopHis;
import com.persagy.fm.sop.model.vo.SaveSopEditVo;
import com.persagy.fm.sop.model.vo.SaveSopVo;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.factory.Mappers;

@Mapper
public interface SopMapper {

    SopMapper INSTANCE = Mappers.getMapper(SopMapper.class );

    @Mapping(source = "sop_id" ,target ="sopId" )
    @Mapping(source = "project_id" ,target ="projectId" )
    @Mapping(source = "extend_field" ,target ="extendField" )
    @Mapping(source = "operator" ,target ="operator" )
    @Mapping(source = "sop_name" ,target ="sopName" )
    //@Mapping(source = "sop_type" ,target ="sopType" )
    @Mapping(source = "no_obj" ,target ="noObj" )
    @Mapping(source = "domains" ,target ="domains" )
    @Mapping(source = "order_type" ,target ="orderType" )
    @Mapping(source = "tools" ,target ="tools" )
    @Mapping(source = "fit_objs" ,target ="fitObjs" )
    @Mapping(source = "equip_model_ids" ,target ="equipModelIds" )
    @Mapping(source = "labels" ,target ="labels" )
    //@Mapping(source = "steps_version" ,target ="stepsVersion" )
    @Mapping(source = "steps" ,target ="steps" )
    @Mapping(source = "related_data" ,target ="relatedData" )
    //@Mapping(source = "sop_status" ,target ="sopStatus" )
    //@Mapping(source = "publish_status" ,target ="publishStatus" )
    //@Mapping(source = "ref_sop_ids" ,target ="refSopIds" )
    //@Mapping(source = "version" ,target ="version" )
    //@Mapping(source = "version_count" ,target ="versionCount" )
    //@Mapping(source = "version_explain" ,target ="versionExplain" )
    //@Mapping(source = "version_exp" ,target ="versionExp" )
    //@Mapping(source = "valid" ,target ="valid" )
    //@Mapping(source = "update_time" ,target ="updateTime" )
    Sop SaveSopVoToSop(SaveSopVo saveSopVo);

    @Mapping(source = "sop_edit_id" ,target ="sopEditId" )
    @Mapping(source = "sop_id" ,target ="sopId" )
    @Mapping(source = "project_id" ,target ="projectId" )
    @Mapping(source = "extend_field" ,target ="extendField" )
    @Mapping(source = "operator" ,target ="operator" )
    @Mapping(source = "sop_name" ,target ="sopName" )
    //@Mapping(source = "sop_type" ,target ="sopType" )
    @Mapping(source = "no_obj" ,target ="noObj" )
    @Mapping(source = "domains" ,target ="domains" )
    @Mapping(source = "order_type" ,target ="orderType" )
    @Mapping(source = "tools" ,target ="tools" )
    @Mapping(source = "fit_objs" ,target ="fitObjs" )
    @Mapping(source = "equip_model_ids" ,target ="equipModelIds" )
    @Mapping(source = "labels" ,target ="labels" )
    //@Mapping(source = "steps_version" ,target ="stepsVersion" )
    @Mapping(source = "steps" ,target ="steps" )
    @Mapping(source = "related_data" ,target ="relatedData" )
        //@Mapping(source = "sop_status" ,target ="sopStatus" )
        //@Mapping(source = "publish_status" ,target ="publishStatus" )
        //@Mapping(source = "ref_sop_ids" ,target ="refSopIds" )
        //@Mapping(source = "version" ,target ="version" )
        //@Mapping(source = "version_count" ,target ="versionCount" )
        //@Mapping(source = "version_explain" ,target ="versionExplain" )
        //@Mapping(source = "version_exp" ,target ="versionExp" )
        //@Mapping(source = "valid" ,target ="valid" )
        //@Mapping(source = "update_time" ,target ="updateTime" )
    SopEdit SaveSopEditVoToSopEdit(SaveSopEditVo saveSopEditVo);


    @Mapping(target = "sop_edit_id" ,source ="sopEditId" )
    @Mapping(target = "sop_id" ,source ="sopId" )
    @Mapping(target = "project_id" ,source ="projectId" )
    @Mapping(target = "extend_field" ,source ="extendField" )
    @Mapping(target = "operator" ,source ="operator" )
    @Mapping(target = "sop_name" ,source ="sopName" )
    //@Mapping(source = "sop_type" ,source ="sopType" )
    @Mapping(target = "no_obj" ,source ="noObj" )
    @Mapping(target = "domains" ,source ="domains" )
    @Mapping(target = "order_type" ,source ="orderType" )
    @Mapping(target = "tools" ,source ="tools" )
    @Mapping(target = "fit_objs" ,source ="fitObjs" )
    @Mapping(target = "equip_model_ids" ,source ="equipModelIds" )
    @Mapping(target = "labels" ,source ="labels" )
    //@Mapping(target = "steps_version" ,source ="stepsVersion" )
    @Mapping(target = "steps" ,source ="steps" )
    @Mapping(target = "related_data" ,source ="relatedData" )
        //@Mapping(source = "sop_status" ,source ="sopStatus" )
        //@Mapping(source = "publish_status" ,source ="publishStatus" )
        //@Mapping(source = "ref_sop_ids" ,source ="refSopIds" )
        //@Mapping(source = "version" ,source ="version" )
        //@Mapping(source = "version_count" ,source ="versionCount" )
        //@Mapping(source = "version_explain" ,source ="versionExplain" )
        //@Mapping(source = "version_exp" ,source ="versionExp" )
        //@Mapping(source = "valid" ,source ="valid" )
        //@Mapping(source = "update_time" ,source ="updateTime" )
    SaveSopEditVo  SopEditToSaveSopEditVo(SopEdit sopEdit);


    @Mapping(target = "ref_sop_id" ,source ="sop_id" )
    @Mapping(target = "ref_sop_name" ,source ="sop_name" )
    @Mapping(target = "version" ,source ="version" )
    @Mapping(target = "stauts_explain" ,source ="stauts_explain" )
    @Mapping(target = "update_time" ,source ="update_time" )
    @Mapping(target = "step_count" ,source ="step_count" )
    SopHis.RefedSopBean profileToRefedSopBean(Profile profile);




}
