package com.persagy.fm.sop.model.dto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * <p>
 * 
 * </p>
 *
 * @author weijinhao
 * @since 2021-03-17
 */
public class SopEdit extends Model<SopEdit> {
    /**
     * 主键
     */
    @TableId(value = "sop_edit_id", type = IdType.ASSIGN_UUID)
    private String sopEditId;

    private String sopId;

    private String projectId;
    private String extendField;
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private OperatorBean operator;
    private String sopName;
    private String sopType;

    private String noObj;
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private List<String> domains;
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private List<String> orderType;
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private List<ToolsBean> tools;
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private List<FitObjsBean> fitObjs;
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private List<String> equipModelIds;
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private List<String> labels;
    private String stepsVersion;
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private List<SopStepsBean> steps;
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private List<RelatedDataBean> relatedData;

    /**
     * 1-已发布、2-已作废
     */
    private String sopStatus;

    /**
     * 1-正常、2-待修订、3-修订中
     */
    private String publishStatus;

    /**
     * id的数组[sop_id,sop_id]
     *
     */
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private List<String> refSopIds;

    private String version;

    private Integer versionCount;

    private String versionExplain;
    /**
     * 是否有效
     */
    private Boolean valid;

    private String updateTime;

    private String createTime;

    public String getSopEditId() {
        return sopEditId;
    }

    public void setSopEditId(String sopEditId) {
        this.sopEditId = sopEditId;
    }

    public String getCreateTime() {
        return createTime;
    }

    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }


    public Boolean getValid() {
        return valid;
    }

    public void setValid(Boolean valid) {
        this.valid = valid;
    }

    public String getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(String updateTime) {
        this.updateTime = updateTime;
    }

    public String getSopId() {
        return sopId;
    }

    public void setSopId(String sopId) {
        this.sopId = sopId;
    }

    public String getProjectId() {
        return projectId;
    }

    public void setProjectId(String projectId) {
        this.projectId = projectId;
    }

    public String getExtendField() {
        return extendField;
    }

    public void setExtendField(String extendField) {
        this.extendField = extendField;
    }

    public OperatorBean getOperator() {
        return operator;
    }

    public void setOperator(OperatorBean operator) {
        this.operator = operator;
    }

    public String getSopName() {
        return sopName;
    }

    public void setSopName(String sopName) {
        this.sopName = sopName;
    }

    public String getSopType() {
        return sopType;
    }

    public void setSopType(String sopType) {
        this.sopType = sopType;
    }

    public String getNoObj() {
        return noObj;
    }

    public void setNoObj(String noObj) {
        this.noObj = noObj;
    }

    public List<String> getDomains() {
        return domains;
    }

    public void setDomains(List<String> domains) {
        this.domains = domains;
    }

    public List<String> getOrderType() {
        return orderType;
    }

    public void setOrderType(List<String> orderType) {
        this.orderType = orderType;
    }

    public List<ToolsBean> getTools() {
        return tools;
    }

    public void setTools(List<ToolsBean> tools) {
        this.tools = tools;
    }

    public List<FitObjsBean> getFitObjs() {
        return fitObjs;
    }

    public void setFitObjs(List<FitObjsBean> fitObjs) {
        this.fitObjs = fitObjs;
    }

    public List<String> getEquipModelIds() {
        return equipModelIds;
    }

    public void setEquipModelIds(List<String> equipModelIds) {
        this.equipModelIds = equipModelIds;
    }

    public List<String> getLabels() {
        return labels;
    }

    public void setLabels(List<String> labels) {
        this.labels = labels;
    }

    public String getStepsVersion() {
        return stepsVersion;
    }

    public void setStepsVersion(String stepsVersion) {
        this.stepsVersion = stepsVersion;
    }

    public List<SopStepsBean> getSteps() {
        return steps;
    }

    public void setSteps(List<SopStepsBean> steps) {
        this.steps = steps;
    }

    public List<RelatedDataBean> getRelatedData() {
        return relatedData;
    }

    public void setRelatedData(List<RelatedDataBean> relatedData) {
        this.relatedData = relatedData;
    }

    public String getSopStatus() {
        return sopStatus;
    }

    public void setSopStatus(String sopStatus) {
        this.sopStatus = sopStatus;
    }

    public String getPublishStatus() {
        return publishStatus;
    }

    public void setPublishStatus(String publishStatus) {
        this.publishStatus = publishStatus;
    }

    public List<String> getRefSopIds() {
        return refSopIds;
    }

    public void setRefSopIds(List<String> refSopIds) {
        this.refSopIds = refSopIds;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public Integer getVersionCount() {
        return versionCount;
    }

    public void setVersionCount(Integer versionCount) {
        this.versionCount = versionCount;
    }

    public String getVersionExplain() {
        return versionExplain;
    }

    public void setVersionExplain(String versionExplain) {
        this.versionExplain = versionExplain;
    }

    public static class OperatorBean {
        /**
         * id : ***
         * name : 燕小六
         */

        private String id;
        private String name;

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }
    }

    public static class ToolsBean {
        /**
         * tool : name
         * from_step : true
         */

        private String tool;
        private Boolean from_step;

        public String getTool() {
            return tool;
        }

        public void setTool(String tool) {
            this.tool = tool;
        }

        public Boolean isFrom_step() {
            return from_step;
        }

        public void setFrom_step(Boolean from_step) {
            this.from_step = from_step;
        }
    }

    public static class FitObjsBean {
        /**
         * obj_id : ***
         * obj_name : 对象名称1
         * obj_code : XXX
         * obj_type : system
         * obj_source : content_obj
         */
        //"obj_id", "obj_name", "obj_type"
        @NotEmpty
        @NotNull
        private String obj_id;
        @NotEmpty
        @NotNull
        private String obj_name;
        @NotEmpty
        @NotNull
        private String obj_type;
        private String obj_source;
        private String obj_code;

        public String getObj_id() {
            return obj_id;
        }

        public void setObj_id(String obj_id) {
            this.obj_id = obj_id;
        }

        public String getObj_name() {
            return obj_name;
        }

        public void setObj_name(String obj_name) {
            this.obj_name = obj_name;
        }

        public String getObj_code() {
            return obj_code;
        }

        public void setObj_code(String obj_code) {
            this.obj_code = obj_code;
        }

        public String getObj_type() {
            return obj_type;
        }

        public void setObj_type(String obj_type) {
            this.obj_type = obj_type;
        }

        public String getObj_source() {
            return obj_source;
        }

        public void setObj_source(String obj_source) {
            this.obj_source = obj_source;
        }
    }

    public static class RelatedDataBean {
        /**
         * name : ***
         * url : ***
         */

        private String name;
        private String url;

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public String getUrl() {
            return url;
        }

        public void setUrl(String url) {
            this.url = url;
        }
    }


}
