package com.persagy.fm.sop.model.dto;

import javax.validation.Valid;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * sop 中step 存储的json字符串体的格式
 * 版本
 * v1.0
 */
public class SopStepsBean {
    /**
     * from_sop : true
     * sop_id : ****
     * step_content : [{"from_sop":false,"pre_execute":"1","pre_conform":"*******","notice":"*****","content_objs":[{"obj_id":"***","obj_name":"对象名称1","obj_type":"equip_class","type_code":"","parents":[{"parent_ids":["***","***","***"],"parent_names":["建筑1","楼层1","空间"]},{"parent_ids":["***","***"],"parent_names":["专业1","系统1"]},{"parent_ids":["***","***","***"],"parent_names":["专业1","系统大类","设备大类"]}]}],"space_scope":[{"obj_id":"***","obj_name":"对象名称1","obj_type":"space_class"}],"obj_required_control":["code","code"],"obj_show_item":["code","code"],"time_limit":5,"confirm_result":[{"description":"","pic":["",""],"att":[{"key":"","name":""}],"info_points":[{"id":"***","code":"****","name":"****","unit":"***","cmpt":"Numberentry02","wrong_ranges":[{"type":"gt","values":"12"},{"type":"lt","values":"6"}],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"id":"***","code":"****","name":"****","unit":"***","cmpt":"Multiselect01","cmpt_data":[{"code":"***","name":"***"}],"wrongs":["选项1","选项2"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}}],"customs":[{"is_select":true,"name":"异常情况","type":"2","items":["正常","异常"],"wrongs":["异常"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息2","type":"2","items":["选项1","选项2","选项3"],"wrongs":["选项1","选项2"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息3","type":"3","items":["选项1","选项2","选项3"],"wrongs":["选项1","选项2"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息4","type":"4","wrong_ranges":[{"type":"gt","values":"12"},{"type":"lt","values":"6"}],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息5","type":"5","unit":"***","wrong_ranges":[{"type":"range","values":["12","20"]}],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}}]}],"domain":"*****"},{"from_sop":true,"sop_id":"****"}]
     */
    @NotNull
    private Boolean from_sop;
    private String sop_id;
    private List<@Valid StepContentBean> step_content;
    private SopHis.RefedSopBean profile;

    public SopHis.RefedSopBean getProfile() {
        return profile;
    }

    public void setProfile(SopHis.RefedSopBean profile) {
        this.profile = profile;
    }

    public Boolean getFrom_sop() {
        return from_sop;
    }


    public Boolean isFrom_sop() {
        return from_sop;
    }

    public void setFrom_sop(Boolean from_sop) {
        this.from_sop = from_sop;
    }

    public String getSop_id() {
        return sop_id;
    }

    public void setSop_id(String sop_id) {
        this.sop_id = sop_id;
    }

    public List<StepContentBean> getStep_content() {
        return step_content;
    }

    public void setStep_content(List<StepContentBean> step_content) {
        this.step_content = step_content;
    }

    public static class StepContentBean {
        /**
         * from_sop : false
         * pre_execute : 1
         * pre_conform : *******
         * notice : *****
         * content_objs : [{"obj_id":"***","obj_name":"对象名称1","obj_type":"equip_class","type_code":"","parents":[{"parent_ids":["***","***","***"],"parent_names":["建筑1","楼层1","空间"]},{"parent_ids":["***","***"],"parent_names":["专业1","系统1"]},{"parent_ids":["***","***","***"],"parent_names":["专业1","系统大类","设备大类"]}]}]
         * space_scope : [{"obj_id":"***","obj_name":"对象名称1","obj_type":"space_class"}]
         * obj_required_control : ["code","code"]
         * obj_show_item : ["code","code"]
         * time_limit : 5
         * confirm_result : [{"description":"","pic":["",""],"att":[{"key":"","name":""}],"info_points":[{"id":"***","code":"****","name":"****","unit":"***","cmpt":"Numberentry02","wrong_ranges":[{"type":"gt","values":"12"},{"type":"lt","values":"6"}],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"id":"***","code":"****","name":"****","unit":"***","cmpt":"Multiselect01","cmpt_data":[{"code":"***","name":"***"}],"wrongs":["选项1","选项2"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}}],"customs":[{"is_select":true,"name":"异常情况","type":"2","items":["正常","异常"],"wrongs":["异常"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息2","type":"2","items":["选项1","选项2","选项3"],"wrongs":["选项1","选项2"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息3","type":"3","items":["选项1","选项2","选项3"],"wrongs":["选项1","选项2"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息4","type":"4","wrong_ranges":[{"type":"gt","values":"12"},{"type":"lt","values":"6"}],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息5","type":"5","unit":"***","wrong_ranges":[{"type":"range","values":["12","20"]}],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}}]}]
         * domain : *****
         * sop_id : ****
         */
        @NotNull
        private Boolean from_sop;
        private String pre_execute;
        private String pre_conform;
        private String notice;
        private Integer time_limit;
        private String domain;
        private String sop_id;
        private List<@Valid ContentObjsBean> content_objs;
        private List<SpaceScopeBean> space_scope;
        private List<String> obj_required_control;
        private List<String> obj_show_item;
        private List<@Valid ConfirmResultBean> confirm_result;

        private SopHis.RefedSopBean profile;


        public Boolean getFrom_sop() {
            return from_sop;
        }

        public SopHis.RefedSopBean getProfile() {
            return profile;
        }

        public void setProfile(SopHis.RefedSopBean profile) {
            this.profile = profile;
        }

        public Boolean isFrom_sop() {
            return from_sop;
        }

        public void setFrom_sop(Boolean from_sop) {
            this.from_sop = from_sop;
        }

        public String getPre_execute() {
            return pre_execute;
        }

        public void setPre_execute(String pre_execute) {
            this.pre_execute = pre_execute;
        }

        public String getPre_conform() {
            return pre_conform;
        }

        public void setPre_conform(String pre_conform) {
            this.pre_conform = pre_conform;
        }

        public String getNotice() {
            return notice;
        }

        public void setNotice(String notice) {
            this.notice = notice;
        }

        public Integer getTime_limit() {
            return time_limit;
        }

        public void setTime_limit(Integer time_limit) {
            this.time_limit = time_limit;
        }

        public String getDomain() {
            return domain;
        }

        public void setDomain(String domain) {
            this.domain = domain;
        }

        public String getSop_id() {
            return sop_id;
        }

        public void setSop_id(String sop_id) {
            this.sop_id = sop_id;
        }

        public List<ContentObjsBean> getContent_objs() {
            return content_objs;
        }

        public void setContent_objs(List<ContentObjsBean> content_objs) {
            this.content_objs = content_objs;
        }

        public List<SpaceScopeBean> getSpace_scope() {
            return space_scope;
        }

        public void setSpace_scope(List<SpaceScopeBean> space_scope) {
            this.space_scope = space_scope;
        }

        public List<String> getObj_required_control() {
            return obj_required_control;
        }

        public void setObj_required_control(List<String> obj_required_control) {
            this.obj_required_control = obj_required_control;
        }

        public List<String> getObj_show_item() {
            return obj_show_item;
        }

        public void setObj_show_item(List<String> obj_show_item) {
            this.obj_show_item = obj_show_item;
        }

        public List<ConfirmResultBean> getConfirm_result() {
            return confirm_result;
        }

        public void setConfirm_result(List<ConfirmResultBean> confirm_result) {
            this.confirm_result = confirm_result;
        }

        public static class ContentObjsBean {
            /**
             * obj_id : ***
             * obj_name : 对象名称1
             * obj_type : equip_class
             * type_code :
             * parents : [{"parent_ids":["***","***","***"],"parent_names":["建筑1","楼层1","空间"]},{"parent_ids":["***","***"],"parent_names":["专业1","系统1"]},{"parent_ids":["***","***","***"],"parent_names":["专业1","系统大类","设备大类"]}]
             */
            //StringUtil.isNull(lackFields, contentObj, "obj_id", "obj_name", "obj_type");
            @NotNull
            @NotEmpty
            private String obj_id;
            @NotNull
            @NotEmpty
            private String obj_name;
            @NotNull
            @NotEmpty
            private String obj_type;
            private String obj_code;
            private List<ParentsBean> parents;

            public String getObj_id() {
                return obj_id;
            }

            public void setObj_id(String obj_id) {
                this.obj_id = obj_id;
            }

            public String getObj_name() {
                return obj_name;
            }

            public void setObj_name(String obj_name) {
                this.obj_name = obj_name;
            }

            public String getObj_type() {
                return obj_type;
            }

            public void setObj_type(String obj_type) {
                this.obj_type = obj_type;
            }

            public String getType_code() {
                return obj_code;
            }

            public void setType_code(String type_code) {
                this.obj_code = type_code;
            }

            public List<ParentsBean> getParents() {
                return parents;
            }

            public void setParents(List<ParentsBean> parents) {
                this.parents = parents;
            }

            public static class ParentsBean {
                private List<String> parent_ids;
                private List<String> parent_names;

                public List<String> getParent_ids() {
                    return parent_ids;
                }

                public void setParent_ids(List<String> parent_ids) {
                    this.parent_ids = parent_ids;
                }

                public List<String> getParent_names() {
                    return parent_names;
                }

                public void setParent_names(List<String> parent_names) {
                    this.parent_names = parent_names;
                }
            }
        }

        public static class SpaceScopeBean {
            /**
             * obj_id : ***
             * obj_name : 对象名称1
             * obj_type : space_class
             */

            private String obj_id;
            private String obj_name;
            private String obj_type;

            public String getObj_id() {
                return obj_id;
            }

            public void setObj_id(String obj_id) {
                this.obj_id = obj_id;
            }

            public String getObj_name() {
                return obj_name;
            }

            public void setObj_name(String obj_name) {
                this.obj_name = obj_name;
            }

            public String getObj_type() {
                return obj_type;
            }

            public void setObj_type(String obj_type) {
                this.obj_type = obj_type;
            }
        }

        public static class ConfirmResultBean {
            /**
             * description :
             * pic : ["",""]
             * att : [{"key":"","name":""}]
             * info_points : [{"id":"***","code":"****","name":"****","unit":"***","cmpt":"Numberentry02","wrong_ranges":[{"type":"gt","values":"12"},{"type":"lt","values":"6"}],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"id":"***","code":"****","name":"****","unit":"***","cmpt":"Multiselect01","cmpt_data":[{"code":"***","name":"***"}],"wrongs":["选项1","选项2"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}}]
             * customs : [{"is_select":true,"name":"异常情况","type":"2","items":["正常","异常"],"wrongs":["异常"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息2","type":"2","items":["选项1","选项2","选项3"],"wrongs":["选项1","选项2"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息3","type":"3","items":["选项1","选项2","选项3"],"wrongs":["选项1","选项2"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息4","type":"4","wrong_ranges":[{"type":"gt","values":"12"},{"type":"lt","values":"6"}],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息5","type":"5","unit":"***","wrong_ranges":[{"type":"range","values":["12","20"]}],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}}]
             */
            @NotEmpty
            @NotNull
            private String description;

            @NotEmpty
            @NotNull
            private String obj_id;
            @NotEmpty
            @NotNull
            private String obj_name;
            @NotEmpty
            @NotNull
            private String obj_type;
            private List<@Valid InfoPointsBean> info_points;
            private List<@Valid CustomsBean> customs;
            private List<String> pic;
            private List<AttBean> att;


            public String getObj_id() {
                return obj_id;
            }

            public void setObj_id(String obj_id) {
                this.obj_id = obj_id;
            }

            public String getObj_name() {
                return obj_name;
            }

            public void setObj_name(String obj_name) {
                this.obj_name = obj_name;
            }

            public String getObj_type() {
                return obj_type;
            }

            public void setObj_type(String obj_type) {
                this.obj_type = obj_type;
            }

            public String getDescription() {
                return description;
            }

            public void setDescription(String description) {
                this.description = description;
            }

            public List<String> getPic() {
                return pic;
            }

            public void setPic(List<String> pic) {
                this.pic = pic;
            }

            public List<AttBean> getAtt() {
                return att;
            }

            public void setAtt(List<AttBean> att) {
                this.att = att;
            }

            public List<InfoPointsBean> getInfo_points() {
                return info_points;
            }

            public void setInfo_points(List<InfoPointsBean> info_points) {
                this.info_points = info_points;
            }

            public List<CustomsBean> getCustoms() {
                return customs;
            }

            public void setCustoms(List<CustomsBean> customs) {
                this.customs = customs;
            }

            public static class AttBean {
                /**
                 * key :
                 * name :
                 */

                private String key;
                private String name;

                public String getKey() {
                    return key;
                }

                public void setKey(String key) {
                    this.key = key;
                }

                public String getName() {
                    return name;
                }

                public void setName(String name) {
                    this.name = name;
                }
            }

            public static class InfoPointsBean {
                /**
                 * id : ***
                 * code : ****
                 * name : ****
                 * unit : ***
                 * cmpt : Numberentry02
                 * wrong_ranges : [{"type":"gt","values":"12"},{"type":"lt","values":"6"}]
                 * abnormal_set : {"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}
                 * cmpt_data : [{"code":"***","name":"***"}]
                 * wrongs : ["选项1","选项2"]
                 */
                //StringUtil.isNull(lackFields, infoPoint, "id", "code", "name");
                @NotEmpty
                @NotNull
                private String id;
                @NotEmpty
                @NotNull
                private String code;
                @NotEmpty
                @NotNull
                private String name;
                private String unit;
                private String cmpt;
                private AbnormalSetBean abnormal_set;
                private List<WrongRangesBean> wrong_ranges;
                private List<CmptDataBean> cmpt_data;
                private List<String> wrongs;

                public String getId() {
                    return id;
                }

                public void setId(String id) {
                    this.id = id;
                }

                public String getCode() {
                    return code;
                }

                public void setCode(String code) {
                    this.code = code;
                }

                public String getName() {
                    return name;
                }

                public void setName(String name) {
                    this.name = name;
                }

                public String getUnit() {
                    return unit;
                }

                public void setUnit(String unit) {
                    this.unit = unit;
                }

                public String getCmpt() {
                    return cmpt;
                }

                public void setCmpt(String cmpt) {
                    this.cmpt = cmpt;
                }

                public AbnormalSetBean getAbnormal_set() {
                    return abnormal_set;
                }

                public void setAbnormal_set(AbnormalSetBean abnormal_set) {
                    this.abnormal_set = abnormal_set;
                }

                public List<WrongRangesBean> getWrong_ranges() {
                    return wrong_ranges;
                }

                public void setWrong_ranges(List<WrongRangesBean> wrong_ranges) {
                    this.wrong_ranges = wrong_ranges;
                }

                public List<CmptDataBean> getCmpt_data() {
                    return cmpt_data;
                }

                public void setCmpt_data(List<CmptDataBean> cmpt_data) {
                    this.cmpt_data = cmpt_data;
                }

                public List<String> getWrongs() {
                    return wrongs;
                }

                public void setWrongs(List<String> wrongs) {
                    this.wrongs = wrongs;
                }

                public static class AbnormalSetBean {
                    /**
                     * execute_type :
                     * execute_dept_id :
                     * execute_dept_name :
                     * problem_type :
                     * problem_type_name :
                     */

                    private String execute_type;
                    private String execute_dept_id;
                    private String execute_dept_name;
                    private String problem_type;
                    private String problem_type_name;

                    public String getExecute_type() {
                        return execute_type;
                    }

                    public void setExecute_type(String execute_type) {
                        this.execute_type = execute_type;
                    }

                    public String getExecute_dept_id() {
                        return execute_dept_id;
                    }

                    public void setExecute_dept_id(String execute_dept_id) {
                        this.execute_dept_id = execute_dept_id;
                    }

                    public String getExecute_dept_name() {
                        return execute_dept_name;
                    }

                    public void setExecute_dept_name(String execute_dept_name) {
                        this.execute_dept_name = execute_dept_name;
                    }

                    public String getProblem_type() {
                        return problem_type;
                    }

                    public void setProblem_type(String problem_type) {
                        this.problem_type = problem_type;
                    }

                    public String getProblem_type_name() {
                        return problem_type_name;
                    }

                    public void setProblem_type_name(String problem_type_name) {
                        this.problem_type_name = problem_type_name;
                    }
                }

                public static class WrongRangesBean {
                    /**
                     * type : gt
                     * values : 12
                     */

                    private String type;
                    private String values;

                    public String getType() {
                        return type;
                    }

                    public void setType(String type) {
                        this.type = type;
                    }

                    public String getValues() {
                        return values;
                    }

                    public void setValues(String values) {
                        this.values = values;
                    }
                }

                public static class CmptDataBean {
                    /**
                     * code : ***
                     * name : ***
                     */

                    private String code;
                    private String name;

                    public String getCode() {
                        return code;
                    }

                    public void setCode(String code) {
                        this.code = code;
                    }

                    public String getName() {
                        return name;
                    }

                    public void setName(String name) {
                        this.name = name;
                    }
                }
            }

            public static class CustomsBean {
                /**
                 * is_select : true
                 * name : 异常情况
                 * type : 2
                 * items : ["正常","异常"]
                 * wrongs : ["异常"]
                 * abnormal_set : {"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}
                 * wrong_ranges : [{"type":"gt","values":"12"},{"type":"lt","values":"6"}]
                 * unit : ***
                 */

                //StringUtil.isNull(lackFields, custom, "name", "type");

                @NotEmpty
                @NotNull
                private String name;
                @NotEmpty
                @NotNull
                private String type;
                private Boolean is_select;
                private AbnormalSetBeanX abnormal_set;
                private String unit;
                private List<String> items;
                private List<String> wrongs;
                private List<WrongRangesBeanX> wrong_ranges;

                public Boolean isIs_select() {
                    return is_select;
                }

                public void setIs_select(Boolean is_select) {
                    this.is_select = is_select;
                }

                public String getName() {
                    return name;
                }

                public void setName(String name) {
                    this.name = name;
                }

                public String getType() {
                    return type;
                }

                public void setType(String type) {
                    this.type = type;
                }

                public AbnormalSetBeanX getAbnormal_set() {
                    return abnormal_set;
                }

                public void setAbnormal_set(AbnormalSetBeanX abnormal_set) {
                    this.abnormal_set = abnormal_set;
                }

                public String getUnit() {
                    return unit;
                }

                public void setUnit(String unit) {
                    this.unit = unit;
                }

                public List<String> getItems() {
                    return items;
                }

                public void setItems(List<String> items) {
                    this.items = items;
                }

                public List<String> getWrongs() {
                    return wrongs;
                }

                public void setWrongs(List<String> wrongs) {
                    this.wrongs = wrongs;
                }

                public List<WrongRangesBeanX> getWrong_ranges() {
                    return wrong_ranges;
                }

                public void setWrong_ranges(List<WrongRangesBeanX> wrong_ranges) {
                    this.wrong_ranges = wrong_ranges;
                }

                public static class AbnormalSetBeanX {
                    /**
                     * execute_type :
                     * execute_dept_id :
                     * execute_dept_name :
                     * problem_type :
                     * problem_type_name :
                     */

                    private String execute_type;
                    private String execute_dept_id;
                    private String execute_dept_name;
                    private String problem_type;
                    private String problem_type_name;

                    public String getExecute_type() {
                        return execute_type;
                    }

                    public void setExecute_type(String execute_type) {
                        this.execute_type = execute_type;
                    }

                    public String getExecute_dept_id() {
                        return execute_dept_id;
                    }

                    public void setExecute_dept_id(String execute_dept_id) {
                        this.execute_dept_id = execute_dept_id;
                    }

                    public String getExecute_dept_name() {
                        return execute_dept_name;
                    }

                    public void setExecute_dept_name(String execute_dept_name) {
                        this.execute_dept_name = execute_dept_name;
                    }

                    public String getProblem_type() {
                        return problem_type;
                    }

                    public void setProblem_type(String problem_type) {
                        this.problem_type = problem_type;
                    }

                    public String getProblem_type_name() {
                        return problem_type_name;
                    }

                    public void setProblem_type_name(String problem_type_name) {
                        this.problem_type_name = problem_type_name;
                    }
                }

                public static class WrongRangesBeanX {
                    /**
                     * type : gt
                     * values : 12
                     */

                    private String type;
                    private String values;

                    public String getType() {
                        return type;
                    }

                    public void setType(String type) {
                        this.type = type;
                    }

                    public String getValues() {
                        return values;
                    }

                    public void setValues(String values) {
                        this.values = values;
                    }
                }
            }
        }
    }
}
