package com.persagy.fm.sop.model.vo;

import com.persagy.fm.sop.model.dto.SopStepsBean;

import javax.validation.Valid;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * sop表 落库协议
 * v1.0
 */
public class SaveSopVo {

    /**
     * user_id : ***
     * project_id : ***
     * extend_field : ***
     * operator : {"id":"***","name":"燕小六"}
     * sop_id : ***
     * sop_name : ***
     * domains : ["code1","code2"]
     * order_type : ["code1","code2"]
     * no_obj : 1
     * tools : [{"tool":"name","from_step":true},{"tool":"name","from_step":true}]
     * fit_objs : [{"obj_id":"***","obj_name":"对象名称1","obj_code":"XXX","obj_type":"system","obj_source":"content_obj"}]
     * equip_model_ids : ["***","***"]
     * labels : ["name","name"]
     * related_data : [{"name":"***","url":"***"}]
     * steps : [{"from_sop":true,"sop_id":"****"},{"from_sop":false,"step_content":[{"from_sop":false,"pre_execute":"1","pre_conform":"*******","notice":"*****","content_objs":[{"obj_id":"***","obj_name":"对象名称1","obj_type":"equip_class","type_code":"","parents":[{"parent_ids":["***","***","***"],"parent_names":["建筑1","楼层1","空间"]},{"parent_ids":["***","***"],"parent_names":["专业1","系统1"]},{"parent_ids":["***","***","***"],"parent_names":["专业1","系统大类","设备大类"]}]}],"space_scope":[{"obj_id":"***","obj_name":"对象名称1","obj_type":"space_class"}],"obj_required_control":["code","code"],"obj_show_item":["code","code"],"time_limit":5,"confirm_result":[{"description":"","pic":["",""],"att":[{"key":"","name":""}],"info_points":[{"id":"***","code":"****","name":"****","unit":"***","cmpt":"Numberentry02","wrong_ranges":[{"type":"gt","values":"12"},{"type":"lt","values":"6"}],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"id":"***","code":"****","name":"****","unit":"***","cmpt":"Multiselect01","cmpt_data":[{"code":"***","name":"***"}],"wrongs":["选项1","选项2"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}}],"customs":[{"is_select":true,"name":"异常情况","type":"2","items":["正常","异常"],"wrongs":["异常"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息2","type":"2","items":["选项1","选项2","选项3"],"wrongs":["选项1","选项2"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息3","type":"3","items":["选项1","选项2","选项3"],"wrongs":["选项1","选项2"],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息4","type":"4","wrong_ranges":[{"type":"gt","values":"12"},{"type":"lt","values":"6"}],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}},{"name":"确认信息5","type":"5","unit":"***","wrong_ranges":[{"type":"range","values":["12","20"]}],"abnormal_set":{"execute_type":"","execute_dept_id":"","execute_dept_name":"","problem_type":"","problem_type_name":""}}]}],"domain":"*****"},{"from_sop":true,"sop_id":"****"}]},{"from_sop":false,"step_content":[]}]
     */

    @NotNull
    @NotEmpty
    private String user_id;

    private String project_id;

    private String extend_field;
    private OperatorBean operator;
    private String sop_id;

    @NotEmpty
    @NotNull
    private String sop_name;
    private String no_obj;
    private List<String> domains;
    private List<String> order_type;
    private List<ToolsBean> tools;
    private List<@Valid FitObjsBean> fit_objs;
    private List<String> equip_model_ids;
    private List<String> labels;
    private List<RelatedDataBean> related_data;
    @NotEmpty
    @NotNull
    private List<SopStepsBean> steps;

    public String getUser_id() {
        return user_id;
    }

    public void setUser_id(String user_id) {
        this.user_id = user_id;
    }

    public String getProject_id() {
        return project_id;
    }

    public void setProject_id(String project_id) {
        this.project_id = project_id;
    }

    public String getExtend_field() {
        return extend_field;
    }

    public void setExtend_field(String extend_field) {
        this.extend_field = extend_field;
    }

    public OperatorBean getOperator() {
        return operator;
    }

    public void setOperator(OperatorBean operator) {
        this.operator = operator;
    }

    public String getSop_id() {
        return sop_id;
    }

    public void setSop_id(String sop_id) {
        this.sop_id = sop_id;
    }

    public String getSop_name() {
        return sop_name;
    }

    public void setSop_name(String sop_name) {
        this.sop_name = sop_name;
    }

    public String getNo_obj() {
        return no_obj;
    }

    public void setNo_obj(String no_obj) {
        this.no_obj = no_obj;
    }

    public List<String> getDomains() {
        return domains;
    }

    public void setDomains(List<String> domains) {
        this.domains = domains;
    }

    public List<String> getOrder_type() {
        return order_type;
    }

    public void setOrder_type(List<String> order_type) {
        this.order_type = order_type;
    }

    public List<ToolsBean> getTools() {
        return tools;
    }

    public void setTools(List<ToolsBean> tools) {
        this.tools = tools;
    }

    public List<FitObjsBean> getFit_objs() {
        return fit_objs;
    }

    public void setFit_objs(List<FitObjsBean> fit_objs) {
        this.fit_objs = fit_objs;
    }

    public List<String> getEquip_model_ids() {
        return equip_model_ids;
    }

    public void setEquip_model_ids(List<String> equip_model_ids) {
        this.equip_model_ids = equip_model_ids;
    }

    public List<String> getLabels() {
        return labels;
    }

    public void setLabels(List<String> labels) {
        this.labels = labels;
    }

    public List<RelatedDataBean> getRelated_data() {
        return related_data;
    }

    public void setRelated_data(List<RelatedDataBean> related_data) {
        this.related_data = related_data;
    }

    public List<SopStepsBean> getSteps() {
        return steps;
    }

    public void setSteps(List<SopStepsBean> steps) {
        this.steps = steps;
    }

    public static class OperatorBean {
        /**
         * id : ***
         * name : 燕小六
         */

        private String id;
        private String name;

        public String getId() {
            return id;
        }

        public void setId(String id) {
            this.id = id;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }
    }

    public static class ToolsBean {
        /**
         * tool : name
         * from_step : true
         */

        private String tool;
        private Boolean from_step;

        public String getTool() {
            return tool;
        }

        public void setTool(String tool) {
            this.tool = tool;
        }

        public Boolean isFrom_step() {
            return from_step;
        }

        public void setFrom_step(Boolean from_step) {
            this.from_step = from_step;
        }
    }

    public static class FitObjsBean {
        /**
         * obj_id : ***
         * obj_name : 对象名称1
         * obj_code : XXX
         * obj_type : system
         * obj_source : content_obj
         */
        //"obj_id", "obj_name", "obj_type"
        @NotEmpty
        @NotNull
        private String obj_id;
        @NotEmpty
        @NotNull
        private String obj_name;
        @NotEmpty
        @NotNull
        private String obj_type;
        private String obj_source;
        private String obj_code;

        public String getObj_id() {
            return obj_id;
        }

        public void setObj_id(String obj_id) {
            this.obj_id = obj_id;
        }

        public String getObj_name() {
            return obj_name;
        }

        public void setObj_name(String obj_name) {
            this.obj_name = obj_name;
        }

        public String getObj_code() {
            return obj_code;
        }

        public void setObj_code(String obj_code) {
            this.obj_code = obj_code;
        }

        public String getObj_type() {
            return obj_type;
        }

        public void setObj_type(String obj_type) {
            this.obj_type = obj_type;
        }

        public String getObj_source() {
            return obj_source;
        }

        public void setObj_source(String obj_source) {
            this.obj_source = obj_source;
        }
    }

    public static class RelatedDataBean {
        /**
         * name : ***
         * url : ***
         */

        private String name;
        private String url;

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public String getUrl() {
            return url;
        }

        public void setUrl(String url) {
            this.url = url;
        }
    }


}
