package com.persagy.fm.sop.service;

import com.alibaba.fastjson.JSONObject;
import com.persagy.fm.sop.model.SopDTO;
import com.persagy.fm.sop.model.dto.RefSopInfo;
import com.persagy.fm.sop.model.dto.SopEdit;
import com.persagy.fm.sop.model.vo.*;

import java.util.List;
import java.util.Set;

public interface GroupSopService {

    /**
     * 查询编辑中的sop列表设置默认的项目ID， 调用RestSopService中queryEditingSopList接口
     * @param queryHistoryListVo
     * @return
     * @throws Exception
     */
    public JSONObject queryEditingSopList(QueryHistoryListVo queryHistoryListVo ) throws Exception ;


    public JSONObject queryDestroyedSopList(QueryHistoryListVo queryHistoryListVo) throws Exception ;


    /**
     *
     * Description: 条件过滤
     * @param sops
     * @param destoryFlag
     * @return
     * @throws Exception JSONObject
     * @author yuecaipu
     * @since 2018年5月2日: 下午2:11:59
     * Update By yuecaipu 2018年5月2日: 下午2:11:59
     */
    public JSONObject filterRemind(List<SopDTO> sops, boolean destoryFlag) throws Exception ;

    /**
     * 查询已作废的sop列表
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryDestroyedSopList(JSONObject jsonObject) throws Exception;


    /**
     * 查询已发布的sop列表
     *              设置默认的项目ID
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public JSONObject queryPublishedSopList(QuerySopListForSelVo jsonStr) throws Exception;

    /**
     * 集团sop-新增页-添加发布状态sop
     * @param saveSopVo
     * @return
     * @throws Exception
     */
    boolean addPublishedSop(SaveSopVo saveSopVo) throws Exception;

    /**
     * 在发布前验证sop
     * @param saveSopVo
     * @return
     * @throws Exception
     */
    boolean verifySopForPublish(SaveSopVo saveSopVo) throws Exception;

    Set<String> getSopRefSops(SaveSopVo sop);

    String addDraftSop(SaveSopEditVo saveSopEditVo) throws Exception ;

    /**
     * 集团sop-新增页-验证sop
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public boolean verifySopBeforePublish(VerifySopNameVo jsonStr) throws Exception;

    /**
     * 详细页-查询当前sop被引用的sop列表
     * @param querySopReferenceVo
     * @return
     * @throws Exception
     */
    List<RefSopInfo> queryReferencedSopListById(QuerySopReferenceVo querySopReferenceVo)throws Exception;

    /**
     * 添加数据
     * @param sopEdit
     * @return
     * @throws Exception
     */

    public boolean insertRecord(SopEdit sopEdit) throws Exception ;

    /**
     * 集团sop-编辑页-保存草稿状态sop
     * @param saveDraftSopVo
     * @return
     * @throws Exception
     */
    public boolean saveDraftSop(SaveDraftSopVo saveDraftSopVo) throws Exception;

    /**
     * 新增页:查询可供选择的sop，复制、引用时用
     * @param sopListForSelVo
     * @return
     * @throws Exception
     */
    public JSONObject querySopListForSel(QuerySopListForSelVo sopListForSelVo)throws Exception;

    /**
     * 集团sop-新增页-添加发布状态sop
     * @param saveSopVo
     * @return
     * @throws Exception
     */
    public boolean publishSop(SaveSopVo saveSopVo) throws Exception;




}
