package com.persagy.fm.sop.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.persagy.fm.sop.dao.SopEquipModelRelMapper;
import com.persagy.fm.sop.model.dto.SopEquipModelRel;
import com.persagy.fm.sop.service.SopEquipModelRelService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author weijinhao
 * @since 2021-03-17
 */
@Service
public class SopEquipModelRelServiceImpl extends ServiceImpl<SopEquipModelRelMapper, SopEquipModelRel> implements SopEquipModelRelService {

    @Override
    public boolean deleteBySopId(String sopId) {
        //删除所有
        SopEquipModelRel sopEquipModelRel = new SopEquipModelRel();
        QueryWrapper<SopEquipModelRel> SopEquipModelRelQuery = new QueryWrapper<SopEquipModelRel>();
        SopEquipModelRelQuery.eq("sop_id",sopId);
        return sopEquipModelRel.delete(SopEquipModelRelQuery);
    }


    public List<SopEquipModelRel> selectByEquipModelIds(List<String> equip_model_ids) {
        QueryWrapper<SopEquipModelRel> sopEquipModelRelQueryWrapper = new QueryWrapper<>();
        sopEquipModelRelQueryWrapper.in("equip_model_id",equip_model_ids);
        List<SopEquipModelRel> list = this.list(sopEquipModelRelQueryWrapper);
        return list;
    }
}
