package com.persagy.fm.sop.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.persagy.fm.sop.dao.SopLabelRelMapper;
import com.persagy.fm.sop.model.dto.SopLabelRel;
import com.persagy.fm.sop.service.SopLabelRelService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author weijinhao
 * @since 2021-03-17
 */
@Service
public class SopLabelRelServiceImpl extends ServiceImpl<SopLabelRelMapper, SopLabelRel> implements SopLabelRelService {

    @Override
    public boolean deleteBySopId(String sopId) {
        SopLabelRel  sopLabelRel = new SopLabelRel();
        QueryWrapper<SopLabelRel> sopLabelRelQueryWrapper = new QueryWrapper<SopLabelRel>();
        sopLabelRelQueryWrapper.eq("sop_id",sopId);
        return sopLabelRel.delete(sopLabelRelQueryWrapper);
    }

    public List<SopLabelRel> selectByLabels(List<String> labels) {
        QueryWrapper<SopLabelRel> query = new QueryWrapper<>();
        query.in("label",labels);
        return  this.list(query);
    }
}
