package com.persagy.fm.sop.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.persagy.fm.sop.dao.SopObjRelMapper;
import com.persagy.fm.sop.model.dto.SopObjRel;
import com.persagy.fm.sop.service.SopObjRelService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author weijinhao
 * @since 2021-03-17
 */
@Service
public class SopObjRelServiceImpl extends ServiceImpl<SopObjRelMapper, SopObjRel> implements SopObjRelService {

    public boolean deleteBySopId(String sopId) {
        SopObjRel sopObjRel = new SopObjRel();
        QueryWrapper<SopObjRel> query = new QueryWrapper<SopObjRel>();
        query.eq("sop_id",sopId);
        return sopObjRel.delete(query);
    }
    public List<SopObjRel> selectByObjectIds(List<String> objectIds) {
        QueryWrapper<SopObjRel> query = new QueryWrapper<>();
        query.in("obj_id",objectIds);
        return this.list(query);
    }


}
