package com.persagy.fm.sop.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.persagy.fm.sop.dao.SopOrderTypeRelMapper;
import com.persagy.fm.sop.model.dto.SopOrderTypeRel;
import com.persagy.fm.sop.service.SopOrderTypeRelService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author weijinhao
 * @since 2021-03-17
 */
@Service
public class SopOrderTypeRelServiceImpl extends ServiceImpl<SopOrderTypeRelMapper, SopOrderTypeRel> implements SopOrderTypeRelService {

    @Override
    public boolean deleteBySopId(String sopId) {
        SopOrderTypeRel  sopOrderTypeRel = new SopOrderTypeRel();
        QueryWrapper<SopOrderTypeRel> sopOrderTypeRelQueryWrapper = new QueryWrapper<SopOrderTypeRel>();
        sopOrderTypeRelQueryWrapper.eq("sop_id",sopId);
        return sopOrderTypeRel.delete(sopOrderTypeRelQueryWrapper);
    }


    public List<SopOrderTypeRel> selectByOrderTypes(List<String> orderTypes)  {
        QueryWrapper<SopOrderTypeRel> query = new QueryWrapper<>();
        query.in("order_type",orderTypes);
        return this.list(query);
    }
}
