package com.persagy.old.cache;

import com.alibaba.fastjson.JSONObject;
import com.persagy.old.common.RedisConstant;
import org.apache.commons.lang.StringUtils;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * Created by DOOM on 2017/9/7.
 */
@Component
public class DictionaryCache {
    @Resource(name="saasRedisTemplate")
    private RedisTemplate<String,Object> saasRedisTemplate ;


    /**
     * 根据字典类型、字典code码获取项目下字典名称
     * @param dictType 字典类型
     * @param code     字典code码
     * @return
     */
    public String getNameByTypeCode(String dictType, String code){
        if (saasRedisTemplate.opsForHash().get(RedisConstant.ALL_GENERAL_DICTIONARY_KEY, dictType + ":" + code) == null) {
            return "";
        }
        String result = (String) saasRedisTemplate.opsForHash().get(RedisConstant.ALL_GENERAL_DICTIONARY_KEY, dictType + ":" + code);
        JSONObject dictionary = JSONObject.parseObject(result);
        String name = null;
        if (dictionary != null) {
            name = dictionary.getString("name");
            String customerName = dictionary.getString("customer_name");
            if (StringUtils.isNotBlank(customerName)){
                name = customerName;
            }
        }
        return name;
    }
}
