package com.persagy.old.cache;

import com.alibaba.fastjson.JSONObject;
import com.persagy.old.common.RedisConstant;
import com.persagy.old.common.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * Created by guosongchao on 2017/8/17.
 */
@Component
public class InfoPointCache {
    @Resource(name="saasRedisTemplate")
    private RedisTemplate<String, Object> saasRedisTemplate;
    @Autowired
    private ComponentRelationCache componentRelationCache;
    /**
     * 判断信息点是否在APP显示
     * @param infoCmptId   信息点id
     * @param baseCmptCode 信息点原始组件编码
     * @return
     */
    public boolean isShowInApp(String infoCmptId, String baseCmptCode){
        boolean isShowInApp = true;
        String jsonStr = (String) saasRedisTemplate.opsForHash().get(RedisConstant.ALL_INFO_COMPONENT_KEY,infoCmptId);
        if(StringUtil.isNotNull(jsonStr)){
            JSONObject infoPoint = JSONObject.parseObject(jsonStr);
            String appShowFlag = infoPoint.getString("app_show_flag");
            if(!"1".equals(appShowFlag))
                isShowInApp = false;
        }else{
            isShowInApp = componentRelationCache.hasAppCmpt(baseCmptCode);
        }

        return isShowInApp;
    }

}
