package com.persagy.old.cache;

import com.alibaba.fastjson.JSONObject;
import com.persagy.old.common.RedisConstant;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.data.redis.core.RedisOperations;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * Created by yuecaipu on 2018/7/13.
 */
@Component
public class OrderTypeCache {
    private static final Logger log = LoggerFactory.getLogger(OrderTypeCache.class);
    @Resource(name = "saasRedisTemplate")
    private RedisOperations<String, Object> saasRedisTemplate;
    public  String getOrderTypeNameById(String code){

        String orderTypeStr = (String) saasRedisTemplate.opsForHash().get(RedisConstant.ALL_WO_FLOW_PLAN_PERSAGY_KEY, code);

        if (orderTypeStr!=null){
            JSONObject orderType = JSONObject.parseObject(orderTypeStr);
            return orderType.getString("plan_name");
        }
        log.error("OrderTypeCache:getNameByTypeCode未获取到缓存:" + code);
        return "";
    }

}
