package com.persagy.old.cache;

import com.alibaba.fastjson.JSONObject;
import com.persagy.old.common.CommonConst;
import com.persagy.old.common.RedisConstant;
import com.persagy.old.common.StringUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.data.redis.core.RedisOperations;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * Created by guosongchao on 2017/8/15.
 */
@Component("projectCache")
public class ProjectCache  {
    private static final Logger log = LoggerFactory.getLogger(ProjectCache.class);
    @Resource(name="emsRedisTemplate")
    private RedisOperations<String, String> emsRedisTemplate;

    public JSONObject getProjectById(String projectId){
        String jsonStr = (String)emsRedisTemplate.opsForHash().get(RedisConstant.ALL_PROJECTS_KEY, projectId);
        if (StringUtil.isNotNull(jsonStr)){
            return JSONObject.parseObject(jsonStr);
        }
        log.error("projectCache未获取到缓存:"+projectId);
        return new JSONObject();
    }

    public String getProjectNameById(String projectId){

        return getProjectById(projectId).getString(CommonConst.info_name_local_name_project);
    }

    public String getProjLocalIDById(String projectId){

        return getProjectById(projectId).getString(CommonConst.info_name_local_id_project);
    }

    /**
     * 获取项目密码
     * @param projectId
     * @return
     * @throws Exception
     */
    public String getProjectSecretById(String projectId){
        return "";
    }

}
