package com.persagy.old.common;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.persagy.old.service.BaseService;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by gsc on 17/5/16.
 */
@SuppressWarnings("unchecked")
public class StringUtil {
	
	public static boolean isNull(JSONArray lackFields, JSONObject jsonObject, String... params){
		lackFields = lackFields == null ? new JSONArray() : lackFields;
		if(jsonObject == null)
			return false;
		Object value;
		boolean flag = false;
		for(String param : params){
			value = jsonObject.get(param);
			if(value instanceof JSONObject){
				if(value == null || ((JSONObject)value).isEmpty()){
					flag = true;
					if(!lackFields.contains(param))
						lackFields.add(param);
				}
			}else if(value instanceof JSONArray){
				if(value == null || ((JSONArray)value).isEmpty()){
					flag = true;
					if(!lackFields.contains(param))
						lackFields.add(param);
				}
			}else{
				if(value == null || "".equals(JSON.toJSON(value))){
					flag = true;
					if(!lackFields.contains(param))
						lackFields.add(param);
				}
			}
		}
		return flag;
	}
	
	public static boolean isExist(JSONArray lackFields, JSONObject jsonObject, String... params){
		lackFields = lackFields == null ? new JSONArray() : lackFields;
		if(jsonObject == null)
			return false;
		Object value;
		boolean flag = false;
		for(String param : params){
			value = jsonObject.get(param);
			if(value instanceof JSONObject){
				if(value == null || ((JSONObject)value).isEmpty()){
					if(!lackFields.contains(param))
						lackFields.add(param);
				}else{
					flag = true;
				}
			}else if(value instanceof JSONArray){
				if(value == null || ((JSONArray)value).isEmpty()){
					if(!lackFields.contains(param))
						lackFields.add(param);
				}else{
					flag = true;
				}
			}else{
				if(value == null || "".equals(JSON.toJSON(value))){
					if(!lackFields.contains(param))
						lackFields.add(param);
				}else{
					flag = true;
				}
			}
		}
		return flag;
	}
	
    /**
     * 判断String是否为null或空
     * @param params
     * @return
     */
    public static boolean isNull(String... params){
        for(String param : params){
            if(param == null || "".equals(param)){
                return true;
            }
        }
        return false;
    }
    /**
     * 判断String是否为null或空
     * @param params
     * @return
     */
    public static boolean isNotNull(String... params){

        return !isNull(params);
    }
    /**
     * 判断JSONObects是否包含parmas中的字段
     * @param jsonObject
     * @param params
     * @return
     */
    public static boolean isNull(JSONObject jsonObject, String... params){
        for(String param : params){
            if(isNull(jsonObject.getString(param))){
                return true;
            }
        }
        return false;
    }

    /**
     * 判断JSONObect中时候包含parmas中字段的为空数组
     * @param jsonObject
     * @param params
     * @return
     */
    public static boolean isEmptyList(JSONObject jsonObject, String... params){
        JSONArray jsonArray;
        for(String param : params){
            jsonArray = jsonObject.getJSONArray(param);
            if(jsonArray == null || jsonArray.isEmpty()){
                return true;
            }
        }
        return false;
    }

    /**
     * 转换ID
     * @param id     ID
     * @param taget 转换目标ID标识
     * @return
     */
    public static String transferId(String id, String taget, String dataPlatBasePath){
        Map<String, String> parentIdMap = null;
        try {
            parentIdMap = getParentIdAndCategoryMap(id, dataPlatBasePath);
        } catch (Exception e) {
            e.printStackTrace();
        }
        Map<String, String> map = new HashMap<String, String>();
       /* if(id.startsWith(CommonConst.tag_project)){

        }else if(id.startsWith(CommonConst.tag_build)){
            map.put(CommonConst.tag_project, CommonConst.tag_project+ id.substring(2, id.length()-3));
        }else if(id.startsWith(CommonConst.tag_floor)){
            map.put(CommonConst.tag_project, CommonConst.tag_project+id.substring(2, id.length()-6));
            map.put(CommonConst.tag_build, CommonConst.tag_build+id.substring(2, id.length()-3));
        }else if(id.startsWith(CommonConst.tag_space)){
            map.put(CommonConst.tag_project, CommonConst.tag_project+id.substring(2, id.length()-9));
            map.put(CommonConst.tag_build, CommonConst.tag_build+id.substring(2, id.length()-6));
            map.put(CommonConst.tag_floor, CommonConst.tag_floor+id.substring(2, id.length()-3));
        }else if(id.startsWith(CommonConst.tag_equip)){
            map.put(CommonConst.tag_project, CommonConst.tag_project+id.substring(2, id.length()-12));
            map.put(CommonConst.tag_build, CommonConst.tag_build+id.substring(2, id.length()-9));
        }else if(id.startsWith(CommonConst.tag_system)){
            map.put(CommonConst.tag_project, CommonConst.tag_project+id.substring(2, id.length()-10));
            map.put(CommonConst.tag_build, CommonConst.tag_build+id.substring(2, id.length()-7));
        }*/
        if(id.startsWith(CommonConst.tag_project)){

        }else if(id.startsWith(CommonConst.tag_build)){
            map.put(CommonConst.tag_project, CommonConst.tag_project+ id.substring(2, 12));
        }else if(id.startsWith(CommonConst.tag_floor)){
            map.put(CommonConst.tag_project, CommonConst.tag_project+ id.substring(2, 12));
            map.put(CommonConst.tag_build, parentIdMap.get("building"));
        }else if(id.startsWith(CommonConst.tag_space)){
            map.put(CommonConst.tag_project, CommonConst.tag_project+ id.substring(2, 12));
            map.put(CommonConst.tag_build, parentIdMap.get("building"));
            map.put(CommonConst.tag_floor, parentIdMap.get("floor"));
        }else if(id.startsWith(CommonConst.tag_equip)){
            map.put(CommonConst.tag_project, CommonConst.tag_project+ id.substring(2, 12));
            map.put(CommonConst.tag_build, parentIdMap.get("building"));
        }else if(id.startsWith(CommonConst.tag_system)){
            map.put(CommonConst.tag_project, CommonConst.tag_project+ id.substring(2, 12));
            map.put(CommonConst.tag_build, parentIdMap.get("building"));
        }
        return map.get(taget);
    }
    
    /**
     * 
     * Description:获取同一项目下同一类型对象的关联建筑id、楼层id、设备id信息 
     * @param ids 设备（空间、部件）id的集合，集合内容应为同一类型的id
     * @return {"id值":{"building":"", "floor":"", "equipment":"", "category":""}}, 只有传入的id为设备和系统时，才会返回category，其值为类型码组合，如SETDLS(前两位是专业码，中间两位是系统码，后四位是设备类别码)
     * @throws Exception Map<String,String>
     * @author cuixubin
     * @since 2018年5月15日: 下午6:42:17
     * Update By cuixubin 2018年5月15日: 下午6:42:17
     */
    public static Map<String, Map<String, String>> getParentIds(List<String> ids, String  dataPlatBasePath) throws Exception{
    	Map<String, Map<String, String>> resultMap = new HashMap<>();
    	if(null == ids || ids.isEmpty()) {
    		return resultMap;
    	}
    	String id = ids.get(0);
        String projectId = "Pj" + id.substring(2, 12);
        String requestUrl = DataRequestPathUtil.dataPlat_object_batch_query;
        requestUrl = requestUrl.replace("BASEPATH", dataPlatBasePath);
        if (null != projectId && !"".equals(projectId)) {
            requestUrl = requestUrl.replace("PROJECTID", projectId);
        }
        
        String buildParamStr = "{\"criterias\":[{\"id\":\"" + id + "\"}";
        for(int i=1; i<ids.size(); i++) {
        	buildParamStr += ",{\"id\":\"" + ids.get(i) + "\"}";
        }
        buildParamStr += "],\"valid\":null,\"projectId\":\""+ projectId +"\"}";
        
//        String result = new BaseService().httpPostRequest(requestUrl, buildParamStr);
        String result = new BaseService().httpPostRequestDataPlatform(requestUrl, buildParamStr);
        JSONObject resultJson = JSONObject.parseObject(result);
        JSONArray content = (JSONArray) resultJson.get("Content");
        if (content != null && content.size() != 0) {
        	Map<String,String> locationMap = new HashMap<>();
        	for(int i=0; i<content.size(); i++) {
        		JSONObject item = content.getJSONObject(i);
        		locationMap = (Map<String, String>) item.get("location");
        		locationMap.put("category",(String) ((JSONObject) content.get(i)).get("category"));
//              resultMap.put("category",(String) ((JSONObject) content.get(0)).get("category"));
        		resultMap.put(item.getString("id"), locationMap);
        	}
        }
        return resultMap;
    }

    private static Map<String,String> getParentIdAndCategoryMap(String id, String dataPlatBasePath) throws Exception{
        String projectId = "Pj" + id.substring(2, 12);
        String requestUrl = DataRequestPathUtil.dataPlat_object_batch_query;
        requestUrl = requestUrl.replace("BASEPATH", dataPlatBasePath);
        if (null != projectId && !"".equals(projectId)) {
            requestUrl = requestUrl.replace("PROJECTID", projectId);
        }
        String buildParamStr = "{\"criterias\":[{\"id\":\"" + id + "\"}]}";
        JSONObject requstParams = JSONObject.parseObject(buildParamStr);
        requstParams.put("projectId", projectId);
//        String result = new BaseService().httpPostRequest(requestUrl, requstParams.toString());
        String result = new BaseService().httpPostRequestDataPlatform(requestUrl, requstParams.toString());

        JSONObject resultJson = JSONObject.parseObject(result);
        JSONArray content = (JSONArray) resultJson.get("Content");
        Map<String, String> resultMap = new HashMap<>();
        if (content != null) {
            Map<String,String> locationMap = (Map<String, String>) ((JSONObject) content.get(0)).get("location");
            resultMap.putAll(locationMap);
            resultMap.put("category",(String) ((JSONObject) content.get(0)).get("category"));
        }
        return resultMap;
    }



    /**
     * 获取设备或系统的类型
     * @param id 设备、系统ID
     * @Param taget 类型标识
     * @return
     */
    public static String getEquipOrSystemCodeFromId(String id, String taget, String dataPlatBasePath){
        Map<String, String> map = new HashMap<String, String>();
     /*   if(id.startsWith(CommonConst.tag_equip)){
            map.put(CommonConst.tag_dict_class, id.substring(15, 17));
            map.put(CommonConst.tag_dict_equip, id.substring(17, 21));
        }else if(id.startsWith(CommonConst.tag_system)){
            map.put(CommonConst.tag_dict_class, id.substring(15, 17));
            map.put(CommonConst.tag_dict_sytstem, id.substring(17, 19));
        }*/
        Map<String, String> parentCategoryMap = null;
        try {
            parentCategoryMap = getParentIdAndCategoryMap(id, dataPlatBasePath);
        } catch (Exception e) {
            e.printStackTrace();
        }
        String category = parentCategoryMap.get("category");
        if (id.startsWith(CommonConst.tag_equip)) {
            map.put(CommonConst.tag_dict_class, category == null || category.length()<6 ? null : category.substring(0, 2));
            map.put(CommonConst.tag_dict_equip, category == null || category.length()<6  ? null : category.substring(2, 6));
        } else if (id.startsWith(CommonConst.tag_system)) {
            map.put(CommonConst.tag_dict_class, category == null || category.length()<4 ? null : category.substring(0, 2));
            map.put(CommonConst.tag_dict_sytstem, category == null || category.length()<4  ? null : category.substring(2, 4));
        }
        return map.get(taget);
    }
    
    /**
     * 获取设备的类型
     * @param projectId 项目id
     * @Param ids 设备ids
     * @return
     */
	public static JSONArray getEquipCodeFromEquipIds(String projectId, JSONArray ids, String dataPlatBasePath) {
		JSONArray content = null;
		try {
//			Properties properties = new Properties();
//			properties.load(StringUtil.class.getResourceAsStream("/config.properties"));
//			String dataPlatBasePath = properties.getProperty("data.platform.basePath");
			String requestUrl = DataRequestPathUtil.dataPlat_object_batch_query;
			requestUrl = requestUrl.replace("BASEPATH", dataPlatBasePath);
			if (null != projectId && !"".equals(projectId)) {
				requestUrl = requestUrl.replace("PROJECTID", projectId);
			}
			JSONObject requstParams = new JSONObject();
			requstParams.put("criterias", ids);
			requstParams.put("projectId", projectId);
//			String result = new BaseService().httpPostRequest(requestUrl, requstParams.toJSONString());
			String result = new BaseService().httpPostRequestDataPlatform(requestUrl, requstParams.toJSONString());

			JSONObject resultJson = JSONObject.parseObject(result);
			content = (JSONArray) resultJson.get("Content");
		} catch (Exception e) {
			e.printStackTrace();
		}
		JSONArray equipCodes = new JSONArray();
		if (content != null && content.size() != 0) {
			for (int i = 0, length = content.size(); i < length; i++) {
				JSONObject jsonObject = content.getJSONObject(i);
				String category = jsonObject.getString("category");
				String equipCode = category == null || category.length() < 6 ? null : category.substring(2, 6);
				if (!equipCodes.contains(equipCode)) {
					equipCodes.add(equipCode);
				}
			}
		}
		return equipCodes;
	}
    

    /**
     * 右侧补齐String长度
     * @param str
     * @param length
     * @param sign
     * @return
     */
    public static String completLengthFromRight(String str, int length, String sign){
        while(str.length() < length){
            str = str + sign;
        }
        return str;
    }
}
