package com.persagy.old.common.enums;
/**
 * 
 * Description:   对象类型排序优先级 ，数字越大等级越高
 * Company: Persagy 
 * @author yuecaipu 
 * @version 1.0
 * @since: 2018年11月22日: 下午8:07:14
 * Update By yuecaipu 2018年11月22日: 下午8:07:14
 */
public enum ObjectLevel {

	BUILD("Bd", 6),

	SYSTEM("Sy", 5),

	SHAFT("Sh", 4),

	FLOOR("Fl", 3),

	SPACE("Sp", 2),

	EQUIP("Eq", 1);

	private Integer level;

	private String idPre;

	private ObjectLevel(String idPre, Integer level) {
		this.idPre = idPre;
		this.level = level;
	}

	// 根据对象id获取对应的等级
	public static Integer getLevel(String objId) {
		for (ObjectLevel c : ObjectLevel.values()) {
			if (objId.startsWith(c.getIdPre())) {
				return c.getLevel();
			}
		}
		return -1;
	}

	/**
	 * @return the level
	 */

	public Integer getLevel() {
		return level;
	}

	/**
	 * @param level
	 *            the level to set
	 */

	public void setLevel(Integer level) {
		this.level = level;
	}

	/**
	 * @return the idPre
	 */

	public String getIdPre() {
		return idPre;
	}

	/**
	 * @param idPre
	 *            the idPre to set
	 */

	public void setIdPre(String idPre) {
		this.idPre = idPre;
	}

}
