package com.persagy.old.dao;

import com.zillion.database.agent.ZillionAgent;
import org.apache.hadoop.conf.Configuration;

public class DBAgent {
    public static ZillionAgent agent;

    public static ZillionAgent GetAgent() {
        if (agent == null) {
            try {
                Configuration configuration = new Configuration();
                configuration.set("hbase.cluster.distributed", "true");
                // InputStream in = new
                // ClassPathResource("/hbase-site.xml").getInputStream();
                // configuration.addResource(in);
                configuration.set("dfs.replication", dfsReplication);
                configuration.set("hbase.rootdir", hbaseRootdir);
                configuration.set("hbase.cluster.distributed", hbaseClusterDistributed);
                configuration.set("hbase.zookeeper.quorum", hbaseZookeeperQuorum);
                configuration.set("hbase.zookeeper.property.dataDir", hbaseZookeeperPropertyDataDir);

                configuration.set("minor_db.enable", minor_dbEnable);
                configuration.set("minor_db.c3p0.jdbcUrl", minor_dbJdbcUrl);
                configuration.set("minor_db.c3p0.user", minor_user);
                configuration.set("minor_db.c3p0.password", minor_password);
                configuration.set("minor_db.c3p0.acquireIncrement", minor_acquireIncrement);
                configuration.set("minor_db.c3p0.idleConnectionTestPeriod", minor_idleConnectionTestPeriod);
                configuration.set("minor_db.c3p0.initialPoolSize", minor_initialPoolSize);
                configuration.set("minor_db.c3p0.maxIdleTime", minor_maxIdleTime);
                configuration.set("minor_db.c3p0.maxPoolSize", minor_maxPoolSize);
                configuration.set("minor_db.c3p0.maxStatements", minor_maxStatements);
                configuration.set("minor_db.c3p0.minPoolSize", minor_minPoolSize);
                configuration.set("hbase.table.sanity.checks", hbaseTableSanityChecks);

                agent = new ZillionAgent(configuration, "sop");
                agent.Start();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return agent;
    }

    // hbase
    private static String hbaseZookeeperQuorum;
    private static String dfsReplication;
    private static String hbaseRootdir;
    private static String hbaseClusterDistributed;
    private static String hbaseZookeeperPropertyDataDir;

    // mysql
    private static String minor_dbEnable;
    private static String minor_dbJdbcUrl;
    private static String minor_user;
    private static String minor_password;
    private static String minor_acquireIncrement;
    private static String minor_idleConnectionTestPeriod;
    private static String minor_initialPoolSize;
    private static String minor_maxIdleTime;
    private static String minor_maxPoolSize;
    private static String minor_maxStatements;
    private static String minor_minPoolSize;
    private static String hbaseTableSanityChecks;


    public static void setMinor_dbEnable(String minor_dbEnable) {
        DBAgent.minor_dbEnable = minor_dbEnable;
    }

    public static void setMinor_dbJdbcUrl(String minor_dbJdbcUrl) {
        DBAgent.minor_dbJdbcUrl = minor_dbJdbcUrl;
    }

    public static void setMinor_user(String minor_user) {
        DBAgent.minor_user = minor_user;
    }

    public static void setMinor_password(String minor_password) {
        DBAgent.minor_password = minor_password;
    }

    public static void setMinor_acquireIncrement(String minor_acquireIncrement) {
        DBAgent.minor_acquireIncrement = minor_acquireIncrement;
    }

    public static void setMinor_idleConnectionTestPeriod(String minor_idleConnectionTestPeriod) {
        DBAgent.minor_idleConnectionTestPeriod = minor_idleConnectionTestPeriod;
    }

    public static void setMinor_initialPoolSize(String minor_initialPoolSize) {
        DBAgent.minor_initialPoolSize = minor_initialPoolSize;
    }

    public static void setMinor_maxIdleTime(String minor_maxIdleTime) {
        DBAgent.minor_maxIdleTime = minor_maxIdleTime;
    }

    public static void setMinor_maxPoolSize(String minor_maxPoolSize) {
        DBAgent.minor_maxPoolSize = minor_maxPoolSize;
    }

    public static void setMinor_maxStatements(String minor_maxStatements) {
        DBAgent.minor_maxStatements = minor_maxStatements;
    }

    public static void setMinor_minPoolSize(String minor_minPoolSize) {
        DBAgent.minor_minPoolSize = minor_minPoolSize;
    }

    public static void setHbaseTableSanityChecks(String hbaseTableSanityChecks) {
        DBAgent.hbaseTableSanityChecks = hbaseTableSanityChecks;
    }

    public static void setHbaseZookeeperQuorum(String hbaseZookeeperQuorum) {
        DBAgent.hbaseZookeeperQuorum = hbaseZookeeperQuorum;
    }

    public static void setDfsReplication(String dfsReplication) {
        DBAgent.dfsReplication = dfsReplication;
    }

    public static void setHbaseRootdir(String hbaseRootdir) {
        DBAgent.hbaseRootdir = hbaseRootdir;
    }

    public static void setHbaseClusterDistributed(String hbaseClusterDistributed) {
        DBAgent.hbaseClusterDistributed = hbaseClusterDistributed;
    }

    public static void setHbaseZookeeperPropertyDataDir(String hbaseZookeeperPropertyDataDir) {
        DBAgent.hbaseZookeeperPropertyDataDir = hbaseZookeeperPropertyDataDir;
    }



}