package com.persagy.old.service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.util.List;
import java.util.Map;

/**
 * Created by guosongchao on 2017/8/16.
 */
public interface ObjectServiceI {
    /**
     * 搜索物理世界对象
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String searchObject(String jsonStr) throws Exception;
    /**
     * 搜索物理世界对象大类（系统，设备，空间大类）
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String searchObjectClass(String jsonStr) throws Exception;
    /**
     * 查询对象分类
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryObjClassForObjSel(String jsonStr) throws Exception;

    /**
     * 查询通用系统类
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String querySystemClass(String jsonStr) throws Exception;

    /**
     * 查询通用设备类
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryEquipClass(String jsonStr) throws Exception;

    /**
     * 查询建筑体
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryBuild(String jsonStr) throws Exception;

    /**
     * 查询楼层
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryFloor(String jsonStr) throws Exception;

    /**
     * 查询空间
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String querySpace(String jsonStr) throws Exception;

    /**
     * 查询系统实例
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String querySystem(String jsonStr) throws Exception;

    /**
     * 系统专业下所有系统
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String querySystemForSystemDomain(String jsonStr) throws Exception;

    /**
     * 查询建筑-楼层-空间列表树
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryBuildFloorSpaceTree(String jsonStr) throws Exception;

    /**
     * 查询设备实例
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryEquip(String jsonStr) throws Exception;

    /**
     * 查询工具、部件列表
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryTempObjectList(String jsonStr) throws Exception;

    /**
     * 验证自定义对象是否已经存在
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String existTempObjectWithType(String jsonStr) throws Exception;
    
    /**
     * 添加自定义对象
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String addBatchTempObject(String jsonStr) throws Exception;

    /**
     * 搜索信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String searchInfoPoint(String jsonStr) throws Exception;

    /**
     * 查询对象分类
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryObjClassForInfoPointSel(String jsonStr) throws Exception;

    /**
     * 查询建筑下信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryInfoPointForBuild(String jsonStr) throws Exception;

    /**
     * 查询楼层下信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryInfoPointForFloor(String jsonStr) throws Exception;

    /**
     * 查询空间下信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryInfoPointForSpace(String jsonStr) throws Exception;

    /**
     * 查询系统下信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryInfoPointForSystem(String jsonStr) throws Exception;

    /**
     * 查询设备下信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryInfoPointForEquip(String jsonStr) throws Exception;

    /**
     * 查询系统类下信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryInfoPointForSystemClass(String jsonStr) throws Exception;
    
    /**
     * 查询建筑下信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryInfoPointForBuildClass(String jsonStr) throws Exception;
    
    /**
     * 查询楼层下信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryInfoPointForFloorClass(String jsonStr) throws Exception;
    
    /**
     * 查询空间下信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryInfoPointForSpaceClass(String jsonStr) throws Exception;

    /**
     * 查询设备类下信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public String queryInfoPointForEquipClass(String jsonStr) throws Exception;
    /**
     * 查询竖井下信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
	public String queryInfoPointForShaft(String jsonStr)  throws Exception;
    /**
     * 
     * Description: 根据对象ID批量查询对象
     * @param jsonStr   对象id集合
     * @param projectId 项目id
     * @param valid		对象有效状态  true表示筛选可用的对象, false表示筛选已删除对象, null表示都查询
     * @throws Exception
     */
    public String queryBatchObj(String jsonStr, String projectId, boolean valid) throws Exception;

    /**
     * 查询设备系统类型、信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public List<String> queryBatchDomainOrInfoPoint(String jsonStr) throws Exception;
    /**
     * 查询所有设备空间系统类型、信息点
     * @param jsonStr
     * @return
     * @throws Exception
     */
    public List<String> queryBatchAllDomainOrInfoPoint(String jsonStr) throws Exception;
    
    /**
     * 获取对象查询结果中ID和localname的对应关系
     * @param queryResult
     * @return
     */
    public Map<String, String> getObjectIdNameMap(String queryResult);
    
    /**
     * 查询数据
     * @param requestPath
     * @param projectId
     * @param secret
     * @param jsonStr
     * @return
     */
    public String httpPostRequestDataPlatformPath(String requestPath, String projectId, String secret, String jsonStr) throws Exception ;
    
    /**
	 * 功能描述： 获取数据平台的关系实例(单个)
	 * @param project_id
	 * @param secret
	 * @param from_id
	 * @param to_id
	 * @param graph_id
	 * @param rel_type
	 * @return
	 * @throws Exception 
	 */
	public JSONObject queryRelation(String project_id, String secret,
                                    String from_id, String to_id,
                                    String graph_id, String rel_type) throws Exception;
    /**
	 * 功能描述： 获取数据平台的关系实例(多个)
	 * @param project_id
	 * @param from_id
	 * @param to_id
	 * @param graph_id
	 * @param rel_type
	 * @return
	 * @throws Exception
	 */
	public JSONArray queryRelations(String project_id, String from_id, String to_id, String graph_id, String rel_type)
			throws Exception;
	/**
	 *
	 * @param project_id
	 * @param secret
	 * @param jsonObject
	 * @return
	 * @throws Exception
	 */
	public JSONArray queryRelation(String project_id, String secret,
                                   JSONArray criterias) throws Exception;

	/**
	 * 查询空间功能类型
	 * @param jsonStr
	 * @return
	 */
	public String querySpaceClass(String jsonStr) throws Exception;


    /**
     * @description 根据className和objCode查询实例  eg. className="equipClass" objCode="TDLS"
     * @param projectId
     * @param className
     * @param objCode
     * @return com.alibaba.fastjson.JSONArray
     * @author feng
     * @date 16:05 2018/5/24
     */
    JSONArray queryInstanceByObjType(String projectId, String className, String objCode, Map<String, String> spaceRelation) throws Exception;


    /**
     * @description 筛选空间下的设备
     * @param projectId
     * @param spaceCode
     * @param equipmentArray
     * @return com.alibaba.fastjson.JSONArray
     * @author feng
     * @date 14:27 2018/5/26
     */
    JSONArray filterEquipmentInSpace(String projectId, String spaceCode, JSONArray equipmentArray, Map<String, String> spaceRelationMap) throws Exception;


    /**
     * 筛选楼层下的设备
     * @param projectId 项目id
     * @param floorId 楼层id
     * @param equipmentArray 需要筛选的设备数组
     * @return com.alibaba.fastjson.JSONArray
     * @throws Exception
     */
    JSONArray filterEquipmentInFloor(String projectId, String floorId, JSONArray equipmentArray, Map<String, String> spaceRelationMap) throws Exception;

    JSONArray filterEquipmentByFloorIdentity(String projectId, String floorIdentityCode, JSONArray equipmentArray, Map<String, String> spaceRelationMap) throws Exception;

    Map<String, String> getSpaceRelation(String projectId) throws Exception;
    /**
     * 筛选楼层下的空间
     * @param projectId  项目id
     * @param floorId 楼层Id
     * @param spaceArray 需要筛选的空间
     * @return com.alibaba.fastjson.JSONArray
     * @throws Exception
     */
    JSONArray filterSapceInFloor(String projectId, String floorId, JSONArray spaceArray) throws Exception;

    JSONArray filterSapceByFloorIdentity(String projectId, String floorIdentityCode, JSONArray spaceArray) throws Exception;


    /**
     *
     * Description: 通过id获取对象（space，equip，floor，build等）详情
     * @param obj_id
     * @return String
     * @author yuecaipu
     * @since 2018年6月1日: 上午9:24:07
     * Update By yuecaipu 2018年6月1日: 上午9:24:07
     */
	public String queryObjById(String objId, String projectId) throws Exception;

	/**
	 * 
	 * Description: 查询楼层信息点
	 * @param jsonObject
	 * @return
	 * @throws Exception String
	 * @author yuecaipu
	 * @since 2018年6月4日: 下午7:14:03
	 * Update By yuecaipu 2018年6月4日: 下午7:14:03
	 */
	public String queryFloorInfoPointByCode(String infoPointCode) throws Exception;

	/**
	 * 
	 * Description: 查询建筑功能类型
	 * @param jsonObject
	 * @return
	 * @throws Exception String
	 * @author yuecaipu
	 * @since 2018年6月4日: 下午7:14:03
	 * Update By yuecaipu 2018年6月4日: 下午7:14:03
	 */
	public String queryBuildFuncType() throws Exception;
	
	/**
	 * 
	 * Description: 查询竖井功能类型
	 * @param jsonObject
	 * @return
	 * @throws Exception String
	 * @author yuecaipu
	 * @since 2018年6月4日: 下午7:14:03
	 * Update By yuecaipu 2018年6月4日: 下午7:14:03
	 */
	public String queryShaftFuncType() throws Exception;
	
	/**
	 * 
	 * Description: 查询项目类型
	 * @return
	 * @throws Exception String
	 * @author yuecaipu
	 * @since 2018年10月19日: 上午9:44:57
	 * Update By yuecaipu 2018年10月19日: 上午9:44:57
	 */
	public String queryProFuncType() throws Exception;
	
	/**
	 * 
	 * Description: 根据项目id获取对应的一级项目类型
	 * @return
	 * @throws Exception String
	 * @author yuecaipu
	 * @since 2018年10月19日: 上午9:44:57
	 * Update By yuecaipu 2018年10月19日: 上午9:44:57
	 */
	public String queryRootProjFuncTypeById(String projectId) throws Exception;
	  /**
	   * 
	   * Description: 实例化中间件：支持空间类、设备类
	   * @param jsonObject
	   * @return String
	   * @author yuecaipu
	 * @throws Exception 
	   * @since 2018年10月19日: 下午6:45:13
	   * Update By yuecaipu 2018年10月19日: 下午6:45:13
	   */
	public String convertClassToObject(JSONObject jsonObject) throws Exception;
	/*根据空间id或设备id查关系详情（非层级结构）*/
	public JSONArray querySpaceOrEquipNoHierarchy(String projectId, String objType, JSONArray objIds) throws Exception;
	/**
	 * 
	 * Description: 数据平台 查询某个object下指定类型的objects subset_query
	 * @param projectId
	 * @param id
	 * @param type
	 * @return
	 * @throws Exception JSONArray
	 * @author yuecaipu
	 * @since 2018年11月17日: 下午6:37:29
	 * Update By yuecaipu 2018年11月17日: 下午6:37:29
	 */
	public JSONArray subsetQuery(String projectId, String id, String... type) throws Exception;
	/**
	 * Description: 获取设备类下的设备实例
	 * @param projectId
	 * @param equipType
	 * @return
	 * @throws Exception JSONArray
	 * @author yuecaipu
	 * @since 2018年10月26日: 下午5:51:22
	 * Update By yuecaipu 2018年10月26日: 下午5:51:22
	 */
	public JSONArray queryEquipByType(String projectId, String equipType) throws Exception;
	/**
	 * Description: 获取空间类下的空间实例
	 * @param projectId
	 * @param roomFuncType
	 * @return
	 * @throws Exception JSONArray
	 * @author yuecaipu
	 * @since 2018年10月26日: 下午5:51:04
	 * Update By yuecaipu 2018年10月26日: 下午5:51:00
	 */
	public JSONArray querySpaceByType(String projectId, String roomFuncType) throws Exception;
	public String getProFuncTypeNameById(String extend_field) throws Exception;

    JSONArray queryCustomInfoPointList();

    boolean addCustomInfoPoint(JSONObject jsonObject);

    boolean updateCustomInfoPoint(JSONObject jsonObject);

    boolean delelteCustomInfoPointById(JSONObject jsonObject);
}
