package com.persagy.old.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.persagy.old.common.JSONUtil;
import com.persagy.old.dao.DBCommonMethods;
import com.persagy.old.dao.DBConst;
import com.persagy.old.service.BaseService;
import com.persagy.old.service.EquipModelServiceI;
import org.springframework.stereotype.Service;

@Service("equipModelService")
public class EquipModelServiceImpl extends BaseService implements EquipModelServiceI {

    @Override
    public String queryRecordByCondition(String jsonStr) throws Exception {
        JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        jsonObject.put(DBConst.TABLE_FIELD_VALID, true);
        String paramStr = JSONUtil.getCriteriaWithMajors(jsonObject, "company_id", "equip_model_id", "equip_model_name", "valid").toJSONString();
        String resultStr = DBCommonMethods.queryRecordByCriteria(DBConst.DATABASE_SAAS_NAME,DBConst.TABLE_EQUIP_MODEL, paramStr);
        return resultStr;
    }
    @Override
    public String queryRecordByEquipModelName(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
    	String paramStr = JSONUtil.getCriteriaWithMajors(jsonObject, "equip_model_name").toJSONString();
    	String resultStr = DBCommonMethods.queryRecordByCriteria(DBConst.DATABASE_SAAS_NAME,DBConst.TABLE_EQUIP_MODEL, paramStr);
    	return resultStr;
    }
    @Override
    public String queryRecordByEquipModelId(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
    	String paramStr = JSONUtil.getCriteriaWithMajors(jsonObject,"equip_model_id").toJSONString();
    	String resultStr = DBCommonMethods.queryRecordByCriteria(DBConst.DATABASE_SAAS_NAME,DBConst.TABLE_EQUIP_MODEL, paramStr);
    	return resultStr;
    }
    @Override
    public String queryBathchMergeRecordByCondition(String jsonStr, String arrayInfo, String infoName) throws Exception {
        JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        jsonObject.put(DBConst.TABLE_FIELD_VALID, true);
        String paramStr = JSONUtil.getCriteriasWithMajors(jsonObject, arrayInfo, infoName,"valid").toJSONString();
        String resultStr = DBCommonMethods.queryBathchMergeRecordByCriterias(DBConst.DATABASE_SAAS_NAME,DBConst.TABLE_EQUIP_MODEL, paramStr);
        return resultStr;
    }
    @Override
    public String queryBathchMergeRecordByequipModelIds(String jsonStr, String arrayInfo, String infoName) throws Exception {
		JSONObject jsonObject = JSONObject.parseObject(jsonStr);
		String paramStr = JSONUtil.getCriteriasWithMajors(jsonObject, arrayInfo, infoName, infoName).toJSONString();
		String resultStr = DBCommonMethods.queryBathchMergeRecordByCriterias(DBConst.DATABASE_SAAS_NAME,
				DBConst.TABLE_EQUIP_MODEL, paramStr);
		return resultStr;
    }
}