package com.persagy.old.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.google.common.collect.Maps;
import com.persagy.old.cache.ComponentRelationCache;
import com.persagy.old.cache.DictionaryCache;
import com.persagy.old.cache.GraphCache;
import com.persagy.old.cache.InfoPointCache;
import com.persagy.old.common.*;
import com.persagy.old.dao.DBCommonMethods;
import com.persagy.old.dao.DBConst;
import com.persagy.old.dao.DBConst.Result;
import com.persagy.old.service.BaseService;
import com.persagy.old.service.DictionaryServiceI;
import com.persagy.old.service.ObjectServiceI;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.MapUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * Created by guosongchao on 2017/8/16.
 */
@Service("objectService")
public class ObjectServiceImpl extends BaseService implements ObjectServiceI {

    @Autowired
    private GraphCache graphCache;
    @Autowired
    private DictionaryCache dictionaryCache;
//    @Autowired
//    private ProjectCache projectCache;
    @Autowired
    private DictionaryServiceI dictionaryService;
    
    @Autowired
    private ComponentRelationCache componentRelationCache;
    @Autowired
    private InfoPointCache infoPointCache;
    
    private static final Logger log = LoggerFactory.getLogger(ObjectServiceImpl.class);
    
    @Override
    @Deprecated
    public String searchObject(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        String projectId = jsonObject.getString("project_id");
        String keyWord = jsonObject.getString("keyword");
        keyWord = keyWord == null ? "" : keyWord;
        String[] keyWords = keyWord.split(" +"); 
        int count = 500;
        String type;
        JSONArray objects = new JSONArray();
        JSONObject result, object;
        //1 调用数据平台 搜索物理世界
        JSONObject params = new JSONObject();
        params.put("keywords", keyWords);
        params.put("category", JSONArray.parseArray("[\"Eq\",\"Sy\",\"EqObj\",\"SyObj\",\"BdObj\",\"SpObj\",\"FlObj\",\"ShObj\"]"));
        params.put("limit", 500);
        params.put("projectId", projectId);
//        String requestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_like_query, projectId, projectCache.getProjectSecretById(projectId));
        String requestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_like_query);
//        String resultStr = httpPostRequest(requestUrl, params.toJSONString());
        String resultStr = httpPostRequestDataPlatform(requestUrl, params.toJSONString());
        if(resultStr.contains("failure")){
            return resultStr;
        }
        JSONObject parent;
        JSONArray parents, parentIds, parentNames;
        String objName;
        JSONObject resultJson = JSONObject.parseObject(resultStr);
        JSONArray resultArray = resultJson.getJSONArray("Content");
        resultArray = resultArray == null ? new JSONArray() : resultArray;
        for(int i=0; i<resultArray.size(); i++){
            result = resultArray.getJSONObject(i);
			if (objects.size() >= count) {
				break;
			}
            object = new JSONObject();
            type = result.getString("type");
            if("Eq".equals(type)){
                //设备大类
                if(StringUtil.isNull(result, "major", "majorName", "sys", "sysName")){
                   continue;
                }
                object.put("obj_id", result.getString("eq"));
                /*
                 * 若获取项目下字典名称为空，name使用数据平台的数据
                 * update by yuecaipu on 2018-5-9 18:15
                 */
                objName = dictionaryCache.getNameByTypeCode(CommonConst.dict_type_object_domain, object.getString("obj_id"));
                objName = objName == null ? result.getString("eqName"):objName;
                object.put("obj_name", objName);
                object.put("obj_code", result.getString("eq"));
                object.put("obj_type", "equip_class");
                object.put("parents", JSONArray.parseArray("[{\"parent_ids\":[\""+result.getString("major")+"\",\""+result.getString("sys")+"\"],\"parent_names\":[\""+result.getString("majorName")+"\",\""+result.getString("sysName")+"\"]}]"));
            }else if("Sy".equals(type)){
                //系统大类
                if(StringUtil.isNull(result, "major", "majorName")){
                    continue;
                }
                object.put("obj_id", result.getString("sys"));
                /*
                 * 若获取项目下字典名称为空，name使用数据平台的数据
                 * update by yuecaipu on 2018-5-9 18:15
                 */
                objName = result.getString("sysName");
                object.put("obj_name", objName);
                object.put("obj_code", result.getString("sys"));
                object.put("obj_type", "system_class");
                object.put("parents", JSONArray.parseArray("[{\"parent_ids\":[\""+result.getString("major")+"\"],\"parent_names\":[\""+result.getString("majorName")+"\"]}]"));
            }else if("EqObj".equals(type)){
                //设备对象
                parents = new JSONArray();
                parent = new JSONObject();
                parentIds = new JSONArray();
                parentNames = new JSONArray();
                parentIds.add(result.getString("bdObj"));
                parentNames.add(result.getString("bdObjName"));
                if(!StringUtil.isNull(result, "flObj", "flObjName", "spObj", "spObjName")){
                    parentIds.add(result.getString("flObj"));
                    parentNames.add(result.getString("flObjName"));
                    parentIds.add(result.getString("spObj"));
                    parentNames.add(result.getString("spObjName"));
                }
                parent.put("parent_ids", parentIds);
                parent.put("parent_names", parentNames);
                parents.add(parent);
                if(!StringUtil.isNull(result, "major", "majorName", "sysObj", "sysObjName")){
                    parent = JSONObject.parseObject("{\"parent_ids\":[\""+result.getString("major")+"\",\""+result.getString("sysObj")+"\"],\"parent_names\":[\""+result.getString("majorName")+"\",\""+result.getString("sysObjName")+"\"]}");
                    parents.add(parent);
                }
                object.put("obj_id", result.getString("eqObj"));
                object.put("obj_name", result.getString("eqObjName"));
                object.put("obj_type", "equip");
                object.put("parents", parents);
            }else if("SyObj".equals(type)){
                //系统对象
                parents = new JSONArray();
                parent = new JSONObject();
                parentIds = new JSONArray();
                parentNames = new JSONArray();
                parentIds.add(result.getString("bdObj"));
                parentNames.add(result.getString("bdObjName"));
                if(!StringUtil.isNull(result, "flObj", "flObjName", "spObj", "spObjName")){
                    parentIds.add(result.getString("flObj"));
                    parentNames.add(result.getString("flobjName"));
                    parentIds.add(result.getString("spObj"));
                    parentNames.add(result.getString("spObjName"));
                }
                parent.put("parent_ids", parentIds);
                parent.put("parent_names", parentNames);
                parents.add(parent);
                object.put("obj_id", result.getString("sysObj"));
                object.put("obj_name", result.getString("sysObjName"));
                object.put("obj_type", "system");
                object.put("parents", parents);
            }else if("SpObj".equals(type)){
                //空间对象
                object.put("obj_id", result.getString("spObj"));
                object.put("obj_name", result.getString("spObjName"));
                object.put("obj_type", "space");
                object.put("parents", JSONArray.parseArray("[{\"parent_ids\":[\""+result.getString("bdObj")+"\",\""+result.getString("flObj")+"\"],\"parent_names\":[\""+result.getString("bdObjName")+"\",\""+result.getString("flObjName")+"\"]}]"));
            }else if("FlObj".equals(type)){
                //楼层对象
                object.put("obj_id", result.getString("flObj"));
                object.put("obj_name", result.getString("flObjName"));
                object.put("obj_type", "floor");
                object.put("parents", JSONArray.parseArray("[{\"parent_ids\":[\""+result.getString("bdObj")+"\"],\"parent_names\":[\""+result.getString("bdObjName")+"\"]}]"));
            }else if("BdObj".equals(type)){
                //建筑对象
                object.put("obj_id", result.getString("bdObj"));
                object.put("obj_name", result.getString("bdObjName"));
                object.put("obj_type", "build");
            }else if("ShObj".equals(type)){
				//TODO
			}
            objects.add(object);
        }
		// 2.搜索空间功能类型Sp
		if (objects.size() < count) {
			jsonObject.put("need_back_parents", true);
			String spaceClass = querySpaceClass(jsonObject.toJSONString());
			JSONObject spaceClassJson = JSONObject.parseObject(spaceClass);
			if (Result.SUCCESS.equals(spaceClassJson.getString(DBConst.Result.RESULT))) {
				JSONArray content = spaceClassJson.getJSONArray(Result.CONTENT);
				filterObjByKeyWords(keyWords, objects, content, CommonConst.data_type_space_class);
			}
		}
		// 3.搜索 build_func_type-建筑功能类型
		if (objects.size() < count) {
			String buildFuncType = queryBuildFuncType();
			JSONObject buildFuncTypeJson = JSONObject.parseObject(buildFuncType);
			if (Result.SUCCESS.equals(buildFuncTypeJson.getString(Result.RESULT))) {
				filterObjByKeyWords(keyWords, objects, buildFuncTypeJson.getJSONArray(Result.CONTENT),
						"build_func_type");
			}
		}
		// 4.搜索 floor_type-楼层性质（类）
		if (objects.size() < count) {
			String floorType = queryFloorInfoPointByCode("FloorType");
			floorType = floorType.replaceAll("code", "obj_id");
			floorType = floorType.replaceAll("name", "obj_name");
			JSONObject floorTypeJson = JSONObject.parseObject(floorType);
			if (Result.SUCCESS.equals(floorTypeJson.getString(Result.RESULT))) {
				filterObjByKeyWords(keyWords, objects, floorTypeJson.getJSONArray(Result.CONTENT), "floor_type");
			}
		}
		// 5.搜索 shaft_type-竖井功能类型（类）
		if (objects.size() < count) {
			String shaftType = queryShaftFuncType();
			JSONObject shaftTypeJson = JSONObject.parseObject(shaftType);
			if (Result.SUCCESS.equals(shaftTypeJson.getString(Result.RESULT))) {
				filterObjByKeyWords(keyWords, objects, shaftTypeJson.getJSONArray(Result.CONTENT), "shaft_type");
			}
		}

		addLocalCode(objects,projectId); //当时svn2654加这玩意儿干啥呢？？？TODO
		return ToolsUtil.successJsonMsg(objects);
	}
    
    private void addLocalCode(JSONArray objects, String projectId) throws Exception {
    	JSONObject object ;
    	JSONArray criterias = new JSONArray();
		for (int i = 0,length = objects.size(); i <length ; i++) {
			object = objects.getJSONObject(i);
			if (!object.containsKey("obj_code")) {
				JSONObject tempObject = new JSONObject();
				tempObject.put("id", object.getString("obj_id"));
				criterias.add(tempObject);
			}
		}
		if (!criterias.isEmpty()) {
//			String projectId = StringUtil.transferId(criterias.getJSONObject(0).getString("id"), CommonConst.tag_project);		
//			String requestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query_post, projectId, null);
			String requestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query_post);
			JSONObject params = new JSONObject();
			params.put("projectId", projectId);
			params.put("criterias", criterias);
//			String resultStr = httpPostRequest(requestUrl, params.toJSONString());
			String resultStr = httpPostRequestDataPlatform(requestUrl, params.toJSONString());
			JSONObject resultjson = JSONObject.parseObject(resultStr);
			JSONArray resultContent = resultjson.getJSONArray("Content");
			
			HashMap<String, JSONObject> map = getObjIdAndInfosmap(resultContent);
			
			for (int i = 0, length = objects.size(); i < length; i++) {
				object = objects.getJSONObject(i);
				String objId = object.getString("obj_id");
				if (map.containsKey(objId)) {
					JSONObject infos = map.get(objId);
					String localCode = getLocalCode(object.getString("obj_type"), infos);
					object.put("obj_code", localCode);
				}
			}
		}
	}

	
	 /**
	 * Description: 
	 * @param object
	 * @param map
	 * @param objId void
	 * @author yuecaipu
	 * @since 2018年7月12日: 下午6:02:21
	 * Update By yuecaipu 2018年7月12日: 下午6:02:21
	 */
	private String getLocalCode(String objType, JSONObject infos) {
		String localCode = "";
		if (objType.equals("build")) {
			localCode = infos.getString("BuildLocalID");
		}
		if (objType.equals("floor")) {
			localCode = infos.getString("FloorLocalID");
		}
		if (objType.equals("space")) {
			localCode = infos.getString("RoomLocalID");
		}
		if (objType.equals("system")) {
			localCode = infos.getString("SysLocalID");
		}
		if (objType.equals("equip")) {
			localCode = infos.getString("EquipLocalID");
		}
		return localCode;
	}

    
	private HashMap<String, JSONObject> getObjIdAndInfosmap(JSONArray resultContent) {
		HashMap<String, JSONObject> map = new HashMap<>();
		if (!resultContent.isEmpty()) {
			for (int i = 0, length = resultContent.size(); i < length; i++) {
				JSONObject obj = resultContent.getJSONObject(i);
				map.put(obj.getString("id"), obj.getJSONObject("infos"));
			}
		}
		return map;
	}

	@Override
    public String searchObjectClass(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
    	String projectId = CommonConst.group_sop_id;
    	String keyWord = jsonObject.getString("keyword");
    	keyWord = keyWord == null ? "" : keyWord;
    	String[] keyWords = keyWord.split(" +"); 
    	int count = 50;
    	String type;
    	JSONArray objects = new JSONArray();
    	JSONObject result, object;
    	//1 调用数据平台 搜索物理世界(系统大类、设备大类)
    	JSONObject params = new JSONObject();
    	params.put("keywords", keyWords);
    	params.put("category", JSONArray.parseArray("[\"Eq\",\"Sy\"]"));
    	params.put("limit", 100);
    	params.put("projectId", projectId);
//    	String requestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_like_query, projectId, projectCache.getProjectSecretById(projectId));
    	String requestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_like_query);
//    	String resultStr = httpPostRequest(requestUrl, params.toJSONString());
    	String resultStr = httpPostRequestDataPlatform(requestUrl, params.toJSONString());
    	if(resultStr.contains("failure")){
    		return resultStr;
    	}
    	String objName;
    	JSONObject resultJson = JSONObject.parseObject(resultStr);
    	JSONArray resultArray = resultJson.getJSONArray("Content");
    	resultArray = resultArray == null ? new JSONArray() : resultArray;
    	for(int i=0; i<resultArray.size(); i++){
    		result = resultArray.getJSONObject(i);
			if (objects.size() >= count) {
				break;
			}
    		object = new JSONObject();
    		type = result.getString("type");
    		if("Eq".equals(type)){
    			//设备大类
    			if(StringUtil.isNull(result, "major", "majorName", "sys", "sysName")){
    				continue;
    			}
    			object.put("obj_id", result.getString("eq"));
    			/*
    			 * 若获取项目下字典名称为空，name使用数据平台的数据
    			 * update by yuecaipu on 2018-5-9 18:15
    			 */
    			objName = result.getString("eqName");
    			object.put("obj_name", objName);
    			object.put("obj_code", result.getString("eq"));
    			object.put("obj_type", "equip_class");
    			object.put("parents", JSONArray.parseArray("[{\"parent_ids\":[\""+result.getString("major")+"\",\""+result.getString("sys")+"\"],\"parent_names\":[\""+result.getString("majorName")+"\",\""+result.getString("sysName")+"\"]}]"));
    		}else if("Sy".equals(type)){
    			//系统大类
    			if(StringUtil.isNull(result, "major", "majorName")){
    				continue;
    			}
    			object.put("obj_id", result.getString("sys"));
    			/*
    			 * 若获取项目下字典名称为空，name使用数据平台的数据
    			 * update by yuecaipu on 2018-5-9 18:15
    			 */
    			objName = result.getString("sysName");
    			object.put("obj_name", objName);
    			object.put("obj_code", result.getString("sys"));
    			object.put("obj_type", "system_class");
    			object.put("parents", JSONArray.parseArray("[{\"parent_ids\":[\""+result.getString("major")+"\"],\"parent_names\":[\""+result.getString("majorName")+"\"]}]"));
    		}
    		objects.add(object);
    	}
		// 2.搜索空间功能类型Sp
		if (objects.size() < count) {
			jsonObject.put("need_back_parents", true);
			String spaceClass = querySpaceClass(jsonObject.toJSONString());
			JSONObject spaceClassJson = JSONObject.parseObject(spaceClass);
			if (Result.SUCCESS.equals(spaceClassJson.getString(Result.RESULT))) {
				filterObjByKeyWords(keyWords, objects, spaceClassJson.getJSONArray(Result.CONTENT),"space_class");
			}
		}
		// 3.搜索 build_func_type-建筑功能类型
		if (objects.size() < count) {
			String buildFuncType = queryBuildFuncType();
			JSONObject buildFuncTypeJson = JSONObject.parseObject(buildFuncType);
			if (Result.SUCCESS.equals(buildFuncTypeJson.getString(Result.RESULT))) {
				filterObjByKeyWords(keyWords, objects, buildFuncTypeJson.getJSONArray(Result.CONTENT),"build_func_type");
			}
		}
		// 4.搜索 floor_type-楼层性质（类）
		if (objects.size() < count) {
			String floorType = queryFloorInfoPointByCode("FloorType");
			floorType = floorType.replaceAll("code", "obj_id");
			floorType = floorType.replaceAll("name", "obj_name");
			JSONObject floorTypeJson = JSONObject.parseObject(floorType);
			if (Result.SUCCESS.equals(floorTypeJson.getString(Result.RESULT))) {
				filterObjByKeyWords(keyWords, objects, floorTypeJson.getJSONArray(Result.CONTENT),"floor_type");
			}
		}
		// 5.搜索 shaft_type-竖井功能类型（类）
		if (objects.size() < count) {
			String shaftType = queryShaftFuncType();
			JSONObject shaftTypeJson = JSONObject.parseObject(shaftType);
			if (Result.SUCCESS.equals(shaftTypeJson.getString(Result.RESULT))) {
				filterObjByKeyWords(keyWords, objects, shaftTypeJson.getJSONArray(Result.CONTENT),"shaft_type");
			}
		}
    	return ToolsUtil.successJsonMsg(objects);
    }

	
	 private String queryShaftInfoPointDataSourceByCode(String infoPointCode) throws Exception {//ShaftFuncType

		String infoUrl = getDataPlatDictPath(DataRequestPathUtil.dataPlat_infoCode_query_property, null);
		String requestParam = "{\"type\":\"shaft\"}";
		String queryInfoResult = httpPostRequestDataPlatform(infoUrl, requestParam);
		JSONObject queryInfoJson = JSONObject.parseObject(queryInfoResult);
		
		if (Result.FAILURE.equals(queryInfoJson.getString(Result.RESULT))) {
			return queryInfoResult;
		}
		// 2.找到infoPointCode信息点，取他的dataSource，返回
		JSONArray queryInfoContents = queryInfoJson.getJSONArray(Result.CONTENT);
		String dataSources = null;
		if (queryInfoContents != null && queryInfoContents.size() > 0) {
			JSONObject queryInfoContent;
			for (int i = 0; i < queryInfoContents.size(); i++) {
				queryInfoContent = queryInfoContents.getJSONObject(i);
				if (infoPointCode.equals(queryInfoContent.getString("infoPointCode"))) {
					dataSources = queryInfoContent.getString("dataSource");
					break;
				}
			}
		}
		return dataSources;
	}

	/**
	 * Description: 根据关键词数组 搜索空间功能类型
	 * @param keyWords
	 * @param objects
	 * @param content void
	 * @author yuecaipu
	 * @since 2018年6月11日: 下午5:23:54
	 * Update By yuecaipu 2018年6月11日: 下午5:23:54
	 */
	 
	private void filterObjByKeyWords(String[] keyWords, JSONArray objects, JSONArray content, String objType) {
		if (content!=null) {
			JSONObject obj , object;
			String objName ;
			for (int i = 0, length = content.size(); i < length; i++) {
				obj = content.getJSONObject(i);
				objName = obj.getString("obj_name");
				boolean flag = true;
				for (String keyword : keyWords) {
					if (!objName.contains(keyword)) {
						flag = false;
					}
				}
				if (flag) {
					object = new JSONObject();
					object.put("obj_id", obj.getString("obj_id"));
					object.put("obj_name", obj.getString("obj_name"));
					object.put("obj_code", obj.getString("obj_id"));
					object.put("obj_type", objType);
					object.put("parents", obj.getJSONArray("parents"));
					objects.add(object);
				}
				filterObjByKeyWords(keyWords,objects,obj.getJSONArray("content"),objType);
			}
		}
	}

    @Override
    public String queryObjClassForObjSel(String jsonStr) throws Exception {
        String resultStr;
        try{
            resultStr = ToolsUtil.successJsonMsg(CommonMessage.object_class_object);
        }catch (Exception e){
            resultStr = ToolsUtil.errorJsonMsg("");
        }
        return resultStr;
    }

    @Override
    public String querySystemClass(String jsonStr) throws Exception {
        JSONObject jsonObject = JSONObject.parseObject(jsonStr);
//        String projectId = jsonObject.getString("project_id");
        boolean needBack = jsonObject.getBooleanValue("need_back_parents");
        String url = getDataPlatDictPath(DataRequestPathUtil.dataPlat_dict_query, "equipment_all");
//        String dictStr = httpGetRequest(url);
        String dictStr = httpPostRequestDataPlatform(url,"{}");
        JSONObject dictJson = JSONObject.parseObject(dictStr);
        if("success".equals(dictJson.getString("Result"))){
            JSONObject clazz, system, classItem, systemItem;
            JSONArray clazzs, systems, systemArray;
            String parentsStr, classId, clazzName, systemId;
            JSONArray classArray = dictJson.getJSONArray("Content");
            clazzs = new JSONArray();
            for(int i=0; i<classArray.size(); i++){
                classItem = classArray.getJSONObject(i);
                clazz = new JSONObject();
                classId = classItem.getString("code");
                clazzName = classItem.getString("class");
//                clazzName = dictionaryCache.getNameByTypeCode(CommonConst.dict_type_object_domain, classId, projectId);
                systemArray = classItem.getJSONArray("content");
                systems = new JSONArray();
                parentsStr = "[{\"parent_ids\":[\""+classId+"\"],\"parent_names\":[\""+clazzName+"\"]}]";
                if(systemArray != null) {
                    for (int j = 0; j<systemArray.size(); j++){
                        systemItem = systemArray.getJSONObject(j);
                        system = new JSONObject();
                        if(needBack)
                           system.put("parents", JSONArray.parseArray(parentsStr));
	                    systemId = systemItem.getString("code");
	                    system.put("obj_id", systemId);
	                    system.put("obj_name", systemItem.getString("system"));
	                    system.put("obj_code", systemId);
	                    systems.add(system);
                    }
                }
                clazz.put("obj_id", classId);
                clazz.put("obj_name", clazzName);
                clazz.put("content", systems);
                clazzs.add(clazz);
            }
            dictJson.put("Content", clazzs);
            dictJson.put("Count", clazzs.size());
            dictStr = dictJson.toJSONString();
        }
        return dictStr;
    }

    @Override
    public String queryEquipClass(String jsonStr) throws Exception {
        JSONObject jsonObject = JSONObject.parseObject(jsonStr);
//        String projectId = jsonObject.getString("project_id");
        boolean needBack = jsonObject.getBooleanValue("need_back_parents");
        String url = getDataPlatDictPath(DataRequestPathUtil.dataPlat_dict_query, "equipment_all");
//        String dictStr = httpGetRequest(url);
        String dictStr = httpPostRequestDataPlatform(url,"{}");
        JSONObject dictJson = JSONObject.parseObject(dictStr);
        if("success".equals(dictJson.getString("Result"))){
            String parentsStr, clazzId, clazzName, systemId, systemName, equipId;
            JSONObject clazz, clazzItem, system, systemItem, equip, equipItem;
            JSONArray clazzs, clazzArray, systems, systemArray, equips, equipArray;
            clazzArray = dictJson.getJSONArray("Content");
            clazzs = new JSONArray();
            for(int i=0; i<clazzArray.size(); i++){
                clazzItem = clazzArray.getJSONObject(i);
                clazz = new JSONObject();
                clazzId = clazzItem.getString("code");
                clazzName = clazzItem.getString("class");
//                clazzName = dictionaryCache.getNameByTypeCode(CommonConst.dict_type_object_domain, clazzId, projectId);
                systemArray = clazzItem.getJSONArray("content");
                systems = new JSONArray();
                for(int j=0; j<systemArray.size(); j++){
                    systemItem = systemArray.getJSONObject(j);
                    system = new JSONObject();
                    systemId = systemItem.getString("code");
                    systemName = systemItem.getString("system");
                    equipArray = systemItem.getJSONArray("content");
                    equips = new JSONArray();
                    for(int k=0; k<equipArray.size(); k++){
                        equipItem = equipArray.getJSONObject(k);
                        equip = new JSONObject();
                        if(needBack){
                            parentsStr = "[{\"parent_ids\":[\""+clazzId+"\",\""+systemId+"\"],\"parent_names\":[\""+clazzName+"\",\""+systemName+"\"]}]";
                            equip.put("parents", JSONArray.parseArray(parentsStr));
                        }
                        equipId = equipItem.getString("code");
                        equip.put("obj_id", equipId);
                        equip.put("obj_name", equipItem.getString("facility"));
                        equip.put("obj_code", equipId);
                        equips.add(equip);
                    }
                    system.put("obj_id", systemId);
                    system.put("obj_name", systemName);
                    system.put("content", equips);
                    systems.add(system);
                }
                clazz.put("obj_id", clazzId);
                clazz.put("obj_name", clazzName);
                clazz.put("content", systems);
                clazzs.add(clazz);
            }
            dictJson.put(Result.CONTENT, clazzs);
            dictJson.put(Result.COUNT, clazzs.size());
            dictStr = dictJson.toJSONString();
        }
        return dictStr;
    }
    
	@Override 
	public String querySpaceClass(String jsonStr) throws Exception {
        boolean needBack = JSONObject.parseObject(jsonStr).getBooleanValue("need_back_parents");
//		// 1.调用数据平台接口获取数据
//		String dictUrl = getDataPlatDictPath(DataRequestPathUtil.dataPlat_dict_query, "space");
////		String resultStr = httpGetRequest(dictUrl);
//		String resultStr = httpPostRequestDataPlatform(dictUrl,"{}");
//		JSONObject resultJson = JSONObject.parseObject(resultStr);
//		// 2.转化数据格式;
//		if (Result.FAILURE.equals(resultJson.getString(Result.RESULT))) {
//			return resultStr;
//		}
//		JSONArray contents = resultJson.getJSONArray(Result.CONTENT);
//		contents = transformDataFormat2(contents,needBack,null);
//		resultJson.put(Result.CONTENT, contents);
//		resultJson.put(Result.COUNT, contents.size());
//		return resultJson.toJSONString();
        JSONArray contents = dictionaryService.queryDataSourceById(CommonConst.JsonToData.SpaceFunction);
        contents = transformDataFormat2(contents,needBack,null);
        return ToolsUtil.successJsonMsg(contents);
	}
	
	/**
	 * Description: 
	 * @param jsonArr 空间信息树形结构数据
	 * @param needBack 是否返回父级信息
	 * @param parents 父级信息
	 * @return JSONArray
	 * @author cuixubin
	 * @since 2018年5月24日: 上午9:13:29
	 * Update By cuixubin 2018年5月24日: 上午9:13:29
	 */
	private JSONArray transformDataFormat2(JSONArray jsonArr, boolean needBack, JSONArray parents) {
		JSONArray resultAry = new JSONArray();
		if(jsonArr != null && jsonArr.size() > 0) {
			for(int i=0; i<jsonArr.size(); i++) {
				String obj_id = jsonArr.getJSONObject(i).getString("code");
				String obj_name = jsonArr.getJSONObject(i).getString("name");
				JSONArray content = jsonArr.getJSONObject(i).getJSONArray("content");
				JSONObject item = new JSONObject();
				item.put("obj_id", obj_id);
				item.put("obj_name", obj_name);
				item.put("obj_code", obj_id);
				
				JSONArray parentThis = null;
				JSONArray parentNext = null;
				if(needBack) {
					parentThis = new JSONArray();
					parentNext = new JSONArray();
					if(null == parents) {
						JSONArray parentIds = new JSONArray();
						parentIds.add(obj_id);
						
						JSONArray parentNames = new JSONArray();
						parentNames.add(obj_name);
						
						JSONObject parentsItem = new JSONObject();
						parentsItem.put("parent_ids", parentIds);
						parentsItem.put("parent_names", parentNames);
						parentNext.add(parentsItem);
						
						parentThis = JSONArray.parseArray("[{\"parent_ids\":[],\"parent_names\":[]}]");
					}else {
						parentNext = JSONArray.parseArray(parents.toJSONString());
						parentNext.getJSONObject(0).getJSONArray("parent_ids").add(obj_id);
						parentNext.getJSONObject(0).getJSONArray("parent_names").add(obj_name);
						
						parentThis = JSONArray.parseArray(parents.toJSONString());
					}
					
					item.put("parents", parentThis);
				}
				
				item.put("content", transformDataFormat2(content, needBack, parentNext));
				resultAry.add(item);
			}
		}
		return resultAry;
	}
	
	/**转化数据格式
	 * @param jsonArr    待转换的集合
	 * @param needBack   数据叶子节点是否需要带父级
	 * @param parent     父级对象
	 */
	private JSONArray transformDataFormat(JSONArray jsonArr, boolean needBack, String  parent) {
		if (jsonArr!=null && jsonArr.size()>0) {
			JSONObject parentObject =null;
			JSONObject parentItem;
			String parentStr =null;
			JSONArray parentsArr =null,parentIds,parentNames;
			//构建返回的父级参数
			if (parent!=null ) {
				parentObject = JSONObject.parseObject(parent);
				parentsArr = parentObject.getJSONArray("parents");
				parentsArr = parentsArr==null? JSONArray.parseArray("[{\"parent_ids\":[],\"parent_names\":[]}]"):parentsArr;
				parentItem = parentsArr.getJSONObject(0);
				parentIds = parentItem.getJSONArray("parent_ids");
				parentNames = parentItem.getJSONArray("parent_names");
				parentIds.add(parentObject.getString("obj_id"));
				parentNames.add(parentObject.getString("obj_name"));
				parentStr = parentsArr.toJSONString();
			}

			JSONObject item ,spaceJson;
			String code ,name;
			JSONArray content, contents;
			contents = new JSONArray();
			//设置返回数据
			for (int i = 0; i < jsonArr.size(); i++) {
				item = new JSONObject();
				spaceJson = jsonArr.getJSONObject(i);
				code = spaceJson.getString("code");
				name = spaceJson.getString("name");
				content = spaceJson.getJSONArray("content");
				item.put("obj_id", code);
				item.put("obj_name", name);
				if (needBack) {
					if (parentObject!=null) {
						item.put("parents", JSONArray.parseArray(parentStr));
					}
				}
				item.put("content", transformDataFormat(content,needBack,item.toJSONString()));
				contents.add(item);
			}
			return contents;
		}
		return null;
	}

    @Override
    public String queryBuild(String jsonStr) throws Exception {
        JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        String projectId = jsonObject.getString("project_id");
//        String url = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query, projectId, projectCache.getProjectSecretById(projectId));
        String url = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
//        String buildStr = httpPostRequest(url, "{\"criteria\":{\"type\":[\"Bd\"]}}");
        String buildStr = httpPostRequestDataPlatform(url, "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"type\":[\"Bd\"]}}");
        JSONObject buildJson = JSONObject.parseObject(buildStr);
        if("success".equals(buildJson.getString("Result"))){
        	Map<String, String> idLocalNameMap = getObjectIdNameMap(buildJson, CommonConst.info_name_local_name_build);
        	Map<String, String> idLocalIdMap = getObjectIdNameMap(buildJson, CommonConst.info_name_local_id_build);
        	JSONArray builds = new JSONArray();
        	JSONObject build;
        	//for(String id : idLocalNameMap.keySet()){
        	for (Map.Entry<String,String> entry :idLocalNameMap.entrySet()){
        		build = new JSONObject();
        		build.put("obj_id", entry.getKey());
        		build.put("obj_name", entry.getValue());
        		build.put("obj_code", idLocalIdMap.get(entry.getKey()));
        		builds.add(build);
        	}
//            JSONObject build, buildItem;
//            JSONArray builds, buildArray;
//            buildArray = buildJson.getJSONArray("Content");
//            builds = new JSONArray();
//            for(int i=0; i<buildArray.size(); i++){
//                buildItem = buildArray.getJSONObject(i);
//                build = new JSONObject();
//                build.put("obj_id", buildItem.getString("id"));
//                build.put("obj_name", buildItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_name_build));
//                builds.add(build);
//            }
            buildStr = ToolsUtil.successJsonMsg(builds);
        }
        return buildStr;
    }

    @Override
    public String queryFloor(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        String projectId = jsonObject.getString("project_id");
        boolean needBack = jsonObject.getBooleanValue("need_back_parents");
//        String floorUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query, projectId, projectCache.getProjectSecretById(projectId));
        String floorUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
        /*
		 * 请求数据平台接口方式调整：httpPostRequest方法改为httpPostRequestDataPlatform方法
		 * update by cuixubin 2018-05-04 10:45
		 */
//        String floorStr = httpPostRequest(floorUrl, "{\"criteria\":{\"type\":[\"Fl\"]}}");
        String floorStr = httpPostRequestDataPlatform(floorUrl, "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"type\":[\"Fl\"]}}");
//        String buildUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query, projectId, projectCache.getProjectSecretById(projectId));
        String buildUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
        /*
		 * 请求数据平台接口方式调整：httpPostRequest方法改为httpPostRequestDataPlatform方法
		 * update by cuixubin 2018-05-04 10:45
		 */
//        String buildStr = httpPostRequest(buildUrl, "{\"criteria\":{\"type\":[\"Bd\"]}}");
        String buildStr = httpPostRequestDataPlatform(buildUrl, "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"type\":[\"Bd\"]}}");
        String resultStr = null;
        JSONObject floorJson = JSONObject.parseObject(floorStr);
        JSONObject buildJson = JSONObject.parseObject(buildStr);
        if("success".equals(floorJson.getString("Result"))){
            if("success".equals(buildJson.getString("Result"))){
                //key:buildId value:List<floor>
                Map<String, JSONArray> floorMap = new HashMap<String, JSONArray>();
                String parentStr, buildId, buildName, floorId;
                JSONObject build, floor, floorItem;
                JSONArray builds, floorArray, floorList;
                //遍历楼层暂存Map
                floorArray = floorJson.getJSONArray("Content");
               //根据楼层id放到List集合中
    			//List<String> floorIdInContents = new ArrayList<>();
    			//根据楼层id获取建筑id
    			Map<String, JSONObject> floorId_location = new HashMap<>();
    			for(int i = 0; i < floorArray.size(); i++) {
    				JSONObject queryContent= floorArray.getJSONObject(i);
    				String floor_id = queryContent.getString("id");
    				floorId_location.put(floor_id, queryContent.getJSONObject("location"));
    				//floorIdInContents.add(floor_id);
    			}
    			//floorId_location = floorId_location == null ? new HashMap<>() : floorId_location;
                
                for(int i=0; i<floorArray.size(); i++){
                    floorItem = floorArray.getJSONObject(i);
                    floor = new JSONObject();
                    floorId = floorItem.getString("id");
                    floor.put("obj_id", floorId);
                    floor.put("obj_name", floorItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_name_floor));
                    floor.put("obj_code", floorItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_id_floor));
					//buildId = StringUtil.transferId(floorId, CommonConst.tag_build);
                    buildId = floorId_location.get(floorId) == null ? null : floorId_location.get(floorId).getString("building");
					floorList = floorMap.getOrDefault(buildId, new JSONArray());
                    floorList.add(floor);
                    floorMap.put(buildId, floorList);
                }
                //遍历建筑 {"buildingId":"buildingName"}
                Map<String, String> map = getObjectIdNameMap(buildJson, CommonConst.info_name_local_name_build);
            	builds = new JSONArray();
            	//for(String id : map.keySet()){
                String id;
                for (Map.Entry<String, String> entry : map.entrySet()) {
                    id = entry.getKey();
            		build = new JSONObject();
            		//buildName = map.get(id);
            		buildName = entry.getValue();
            		floorList = floorMap.get(id);
                    if(needBack && floorList != null){
                        parentStr = "[{\"parent_ids\":[\""+id+"\"],\"parent_names\":[\""+buildName+"\"]}]";
                        for(int j=0; j<floorList.size(); j++){
                            floor = floorList.getJSONObject(j);
                            floor.put("parents", JSONArray.parseArray(parentStr));
                        }
                    }
                    build.put("obj_id", id);
                    build.put("obj_name", buildName);
                    build.put("content", floorList);
                    builds.add(build);
            	}
                resultStr = ToolsUtil.successJsonMsg(builds);
            }else{
                resultStr = buildStr;
            }
        }else{
            resultStr = floorStr;
        }

        return resultStr;
    }

    @Override
    public String querySpace(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        String projectId = jsonObject.getString("project_id");
        boolean needBack = jsonObject.getBooleanValue("need_back_parents");
        String objId = jsonObject.getString("obj_id");
        String objType = jsonObject.getString("obj_type");

//        String spaceUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query, projectId, projectCache.getProjectSecretById(projectId));
        String spaceUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
//        String buildUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query, projectId, projectCache.getProjectSecretById(projectId));
        String buildUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query);
        String floorParamStr, buildParamStr, spaceStr, floorStr, buildStr;
        String floorUrl, spaceParmaStr = "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"id\":\""+objId+"\",\"type\":[\"Sp\"]}}";
        if(CommonConst.data_type_floor.equals(objType)){
//            floorUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query, projectId, projectCache.getProjectSecretById(projectId));
            floorUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query);
            String buildId = StringUtil.transferId(objId, CommonConst.tag_build, dataPlatBasePath);
            buildParamStr = "{\"projectId\":\"" + projectId + "\",\"criterias\":[{\"id\":\""+buildId+"\"}]}";
            floorParamStr = "{\"projectId\":\"" + projectId + "\",\"criterias\":[{\"id\":\""+objId+"\"}]}";
        }else{
//            floorUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query, projectId, projectCache.getProjectSecretById(projectId));
            floorUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
            buildParamStr = "{\"projectId\":\"" + projectId + "\",\"criterias\":[{\"id\":\""+objId+"\"}]}";
            floorParamStr = "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"id\":\""+objId+"\",\"type\":[\"Fl\"]}}";
        }
        
        /*
		 * 请求数据平台接口方式调整：httpPostRequest方法改为httpPostRequestDataPlatform方法
		 * update by cuixubin 2018-05-04 11:15
		 */
//        spaceStr = httpPostRequest(spaceUrl, spaceParmaStr);
//        floorStr = httpPostRequest(floorUrl, floorParamStr);
//        buildStr = httpPostRequest(buildUrl, buildParamStr);
        spaceStr = httpPostRequestDataPlatform(spaceUrl, spaceParmaStr);
        floorStr = httpPostRequestDataPlatform(floorUrl, floorParamStr);
        buildStr = httpPostRequestDataPlatform(buildUrl, buildParamStr);
        String resultStr = null;
        JSONObject spaceJson = JSONObject.parseObject(spaceStr);
        JSONObject floorJson = JSONObject.parseObject(floorStr);
        JSONObject buildJson = JSONObject.parseObject(buildStr);
        if("success".equals(spaceJson.getString("Result")) && "success".equals(floorJson.getString("Result")) && "success".equals(buildJson.getString("Result"))){
            //定义缓存Map
            //key:buildId value:build
            Map<String, String> buildMap = new HashMap<String, String>();
            //key:floorId value:floor
            Map<String, String> floorMap = new HashMap<String, String>();
            //定义变量
            JSONObject space, spaceItem, floorItem, buildItem;
            JSONArray spaces, spaceArray, floorArray, buildArray;
            String spaceId, parentStr, floorId, buildId;
            //处理建筑数据
            buildArray = buildJson.getJSONArray("Content");
            for(int i=0; i<buildArray.size(); i++){
                buildItem = buildArray.getJSONObject(i);
                buildMap.put(buildItem.getString("id"), buildItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_name_build));
            }
            //处理楼层数据
            floorArray = floorJson.getJSONArray("Content");
            for(int i=0; i<floorArray.size(); i++){
                floorItem = floorArray.getJSONObject(i);
                floorMap.put(floorItem.getString("id"), floorItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_name_floor));
            }
            //处理空间数据
            spaceArray = spaceJson.getJSONArray("Content");
            spaces = new JSONArray();
			//根据空间id获取建筑和楼层的id
			Map<String, JSONObject> spaceId_location = new HashMap<>();
			for(int i = 0; i < spaceArray.size(); i++) {
				JSONObject queryContent= spaceArray.getJSONObject(i);
				String space_id = queryContent.getString("id");
				spaceId_location.put(space_id, queryContent.getJSONObject("location"));
			}
			//spaceId_location = spaceId_location == null ? new HashMap<>() : spaceId_location;
            for(int i=0; i<spaceArray.size(); i++){
                spaceItem = spaceArray.getJSONObject(i);
                space = new JSONObject();
                spaceId = spaceItem.getString("id");
                if(needBack){
                    //floorId = StringUtil.transferId(spaceId, CommonConst.tag_floor);
                    //buildId = StringUtil.transferId(spaceId, CommonConst.tag_build);
                	floorId = spaceId_location.get(spaceId) == null ? null : spaceId_location.get(spaceId).getString("floor");
                	buildId = spaceId_location.get(spaceId) == null ? null : spaceId_location.get(spaceId).getString("building");		
                    if(floorMap.containsKey(floorId))
                        parentStr = "[{\"parent_ids\":[\""+buildId+"\",\""+floorId+"\"],\"parent_names\":[\""+buildMap.get(buildId)+"\",\""+floorMap.get(floorId)+"\"]}]";
                    else
                        parentStr = "[{\"parent_ids\":[\""+buildId+"\"],\"parent_names\":[\""+buildMap.get(buildId)+"\"]}]";
                    space.put("parents", JSONArray.parseArray(parentStr));
                }
                space.put("obj_id", spaceId);
                space.put("obj_name", spaceItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_name_space));
                space.put("obj_code", spaceItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_id_space));
                spaces.add(space);
            }
            resultStr = ToolsUtil.successJsonMsg(spaces);
        }
        if("failure".equals(spaceJson.getString("Result")))
            resultStr = spaceStr;
        if("failure".equals(floorJson.getString("Result")))
            resultStr = floorStr;
        if("failure".equals(buildJson.getString("Result")))
            resultStr = buildStr;
        return resultStr;
    }

    @Override
    public String querySystem(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        String projectId = jsonObject.getString("project_id");
        boolean needBack = jsonObject.getBooleanValue("need_back_parents");
        String dictUrl = getDataPlatDictPath(DataRequestPathUtil.dataPlat_dict_query, "equipment_all");
        /*
		 * 请求数据平台接口方式调整：httpGetRequest方法改为httpGetRequestDataPlatform方法
		 * update by jishaojun 2018-05-04 16:02
		 */
//        String dictStr = httpGetRequest(dictUrl);
        String dictStr = httpPostRequestDataPlatform(dictUrl,"{}");
//        String buildUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query, projectId, projectCache.getProjectSecretById(projectId));
        String buildUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
        /*
		 * 请求数据平台接口方式调整：httpPostRequest方法改为httpPostRequestDataPlatform方法
		 * update by cuixubin 2018-05-04 11:15
		 */
//        String buildStr = httpPostRequest(buildUrl, "{\"criteria\":{\"type\":[\"Bd\"]}}");
        String buildStr = httpPostRequestDataPlatform(buildUrl, "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"type\":[\"Bd\"]}}");
//        String systemUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query, projectId, projectCache.getProjectSecretById(projectId));
        String systemUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
        /*
		 * 请求数据平台接口方式调整：httpPostRequest方法改为httpPostRequestDataPlatform方法
		 * update by cuixubin 2018-05-04 11:15
		 */
//        String systemStr = httpPostRequest(systemUrl, "{\"criteria\":{\"type\":[\"Sy\"]}}");
        String systemStr = httpPostRequestDataPlatform(systemUrl, "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"type\":[\"Sy\"]}}");
        JSONObject dictJson = JSONObject.parseObject(dictStr);
        JSONObject buildJson = JSONObject.parseObject(buildStr);
        JSONObject systemJson = JSONObject.parseObject(systemStr);
        String resultStr = null;
        if("success".equals(dictJson.getString("Result")) && "success".equals(buildJson.getString("Result")) && "success".equals(systemJson.getString("Result"))){
            //定义缓存
            //key:systemClass(dictId) value:List<system>
            Map<String, List<String>> systemMap = new HashMap<String, List<String>>();
            //key:buildId value:buildName
            Map<String, String> buildMap = new HashMap<String, String>();
            List<String> systemList;
            //定义变量
            String dictId, dictName, buildId, buildName, systemId, systemName, systemClass, parentStr;
            JSONObject dict, dictItem, buildItem, system, systemItem;
            JSONArray dicts, dictArray, buildArray, systems, systemArray;
            //处理系统数据
            systemArray = systemJson.getJSONArray("Content");
            for(int i=0; i<systemArray.size(); i++){
                systemItem = systemArray.getJSONObject(i);
                system = new JSONObject();
                systemId = systemItem.getString("id");
                systemName = systemItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_name_system);
                String category = systemItem.getString("category");
                systemClass = category == null || category.length() < 2 ? null : category.substring(0, 2);
                system.put("obj_id", systemId);
                system.put("obj_name", systemName);
                system.put("obj_code", systemItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_id_system));
                //位置信息（所属建筑）
                system.put("location", systemItem.getJSONObject("location"));
                systemList = systemMap.getOrDefault(systemClass, new ArrayList<String>());
                systemList.add(system.toJSONString());
                systemMap.put(systemClass, systemList);
            }
            //处理建筑数据
            buildArray = buildJson.getJSONArray("Content");
            for(int i=0; i<buildArray.size(); i++){
                buildItem = buildArray.getJSONObject(i);
                buildMap.put(buildItem.getString("id"), buildItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_name_build));
            }
            //处理数据字典
            dictArray = dictJson.getJSONArray("Content");
            dicts = new JSONArray();
            for(int i=0; i<dictArray.size(); i++){
                dictItem = dictArray.getJSONObject(i);
                dict = new JSONObject();
                dictId = dictItem.getString("code");
                dictName = dictItem.getString("class");
//                dictName = dictionaryCache.getNameByTypeCode(CommonConst.dict_type_object_domain, dictId, projectId);
                systemList = systemMap.getOrDefault(dictId, new ArrayList<String>());
                systems = new JSONArray();
                
    			//根据系统id获取建筑id
    			Map<String, JSONObject> systemId_location = new HashMap<>();
    			for(int j = 0; j < systemList.size(); j++) {
    				String system_id = systemList.get(j);
    				JSONObject systemObj = JSONObject.parseObject(system_id);
    				system_id = systemObj.getString("obj_id");
    				systemId_location.put(system_id, systemObj.getJSONObject("location"));
    			}
    			//systemId_location = systemId_location == null ? new HashMap<>() : systemId_location;
                
                for(String systemObj : systemList){
                    system = JSONObject.parseObject(systemObj);
                    systemId = system.getString("obj_id");
                    //buildId = StringUtil.transferId(systemId, CommonConst.tag_build);
                    buildId = systemId_location.get(systemId) == null ? null : systemId_location.get(systemId).getString("building");
                    buildName = buildMap.get(buildId);
                    if(needBack){
                    	parentStr = "[{\"parent_ids\":[\""+dictId+"\"],\"parent_names\":[\""+dictName+"\"]},{\"parent_ids\":[\""+buildId+"\"],\"parent_names\":[\""+buildName+"\"]}]";
                        system.put("parents", JSONArray.parseArray(parentStr));
                    }
                    systems.add(system);
                }
                dict.put("obj_id", dictId);
                dict.put("obj_name", dictName);
                dict.put("content", systems);
                dicts.add(dict);
            }
            resultStr = ToolsUtil.successJsonMsg(dicts);
        }
        if("failure".equals(dictJson.getString("Result")))
            resultStr = dictStr;
        if("failure".equals(buildJson.getString("Result")))
            resultStr = buildStr;
        if("failure".equals(systemJson.getString("Result")))
            resultStr = systemStr;
        return resultStr;
    }

    @Override
    public String querySystemForSystemDomain(String jsonStr) throws Exception {
        JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        String projectId = jsonObject.getString("project_id");
//        String url = getDataPlatformPath(DataRequestPathUtil.dataPlat_system_query_by_domain, projectId, projectCache.getProjectSecretById(projectId));
        String url = getDataPlatformPath(DataRequestPathUtil.dataPlat_system_query_by_domain);
//        String systemStr = httpPostRequest(url, "{\"criteria\":{\"category\":\""+jsonObject.getString("system_domain")+"\"}}");
        String systemStr = httpPostRequestDataPlatform(url, "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"category\":\""+jsonObject.getString("system_domain")+"\"}}");
        String resultStr = systemStr;
        JSONObject systemJson = JSONObject.parseObject(systemStr);
        if("success".equals(systemJson.getString("Result"))){
            JSONObject system, systemItem;
            JSONArray systems, systemArray;
            systemArray = systemJson.getJSONArray("Content");
            systems = new JSONArray();
            for(int i=0; i<systemArray.size(); i++){
                systemItem = systemArray.getJSONObject(i);
                system = new JSONObject();
                system.put("system_id", systemItem.getString("id"));
                system.put("system_name", systemItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_name_system));
                systems.add(system);
            }
            resultStr = ToolsUtil.successJsonMsg(systems);
        }
        return resultStr;
    }

    @Override
    public String queryBuildFloorSpaceTree(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        String projectId = jsonObject.getString("project_id");
        String params = "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"type\":[\"Bd\",\"Fl\",\"Sp\"]}}";
//        String requestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query, projectId, projectCache.getProjectSecretById(projectId));
        String requestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
//        String objectResultStr = httpPostRequest(requestUrl, params);
        String objectResultStr = httpPostRequestDataPlatform(requestUrl, params);
        if(objectResultStr.contains("success")){
            //key:buildId value:buildl+LocalName
            Map<String, String> buildMap = new HashMap<String, String>();
            //key:buildId value:List<FloorId-or-SpaceId>
            Map<String, JSONArray> relBuildStepObjectMap = new HashMap<String, JSONArray>();
            //key:floorId value:floor_local_name
            Map<String, String> floorMap = new HashMap<String, String>();
            //key:floor_id value:floor_sequence_id
            Map<String, String> floorSequenceMap = new HashMap<String, String>();
            //key:floorId value:List<SpaceId>
            Map<String, JSONArray> relFloorSpaceMap = new HashMap<String, JSONArray>();
            //key:spaceId value:space_local_name
            Map<String, String> spaceMap = new HashMap<String, String>();
            String objectId, buildId, floorId;
            String floor_sequence_id;
            JSONObject objectItem;
            JSONArray mapValues;
            JSONObject objectJson = JSONObject.parseObject(objectResultStr);
            JSONArray objectArray =objectJson.getJSONArray("Content");
            objectArray = objectArray == null ? new JSONArray() : objectArray;
            
          //根据id放到List集合中
			List<String> floorIdInContents = new ArrayList<>();
			List<String> spaceIdInContents = new ArrayList<>();
			for(int i = 0; i < objectArray.size(); i++) {
				JSONObject queryContent= objectArray.getJSONObject(i);
				String obj_id = queryContent.getString("id");
				if(obj_id.startsWith(CommonConst.tag_floor)) {
					floorIdInContents.add(obj_id);
				}else if(obj_id.startsWith(CommonConst.tag_space)) {
					spaceIdInContents.add(obj_id);
				}
			}
			//根据空间或者楼层id获取上层的id
			Map<String, Map<String, String>> spaceId_location = StringUtil.getParentIds(spaceIdInContents,dataPlatBasePath);
			spaceId_location = spaceId_location == null ? new HashMap<>() : spaceId_location;
			
			Map<String, Map<String, String>> floorId_location = StringUtil.getParentIds(floorIdInContents,dataPlatBasePath);
			floorId_location = floorId_location == null ? new HashMap<>() : floorId_location;
            
            for(int i=0; i<objectArray.size(); i++){
                objectItem = objectArray.getJSONObject(i);
                objectId = objectItem.getString("id");
                floor_sequence_id = objectItem.getJSONObject(CommonConst.info_name_datas).getString("FloorSequenceID");
                if(objectId.startsWith(CommonConst.tag_build)){
                    //建筑
                    buildMap.put(objectId, objectItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_name_build));
                }else if(objectId.startsWith(CommonConst.tag_floor)){
                    //楼层
                    //buildId = StringUtil.transferId(objectId, CommonConst.tag_build);
                	buildId = floorId_location.get(objectId) == null ? null : floorId_location.get(objectId).get("building");
                    mapValues = relBuildStepObjectMap.get(buildId);
                    mapValues = mapValues == null ? new JSONArray() : mapValues;
                    mapValues.add(objectId);
                    relBuildStepObjectMap.put(buildId, mapValues);
                    floorMap.put(objectId, objectItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_name_floor));
                    floorSequenceMap.put(objectId, floor_sequence_id);
                }else if(objectId.startsWith(CommonConst.tag_space)){
                    //空间
                    //floorId = StringUtil.transferId(objectId, CommonConst.tag_floor);
                	floorId = spaceId_location.get(objectId) == null ? null : spaceId_location.get(objectId).get("floor");
                    if(null != floorId && floorId.endsWith("000")){
                        //buildId = StringUtil.transferId(objectId, CommonConst.tag_build);
                    	buildId = spaceId_location.get(objectId) == null ? null : spaceId_location.get(objectId).get("building");
                        mapValues = relBuildStepObjectMap.get(buildId);
                        mapValues = mapValues == null ? new JSONArray() : mapValues;
                        mapValues.add(objectId);
                        relBuildStepObjectMap.put(buildId, mapValues);
                    }else{
                        mapValues = relFloorSpaceMap.get(floorId);
                        mapValues = mapValues == null ? new JSONArray() : mapValues;
                        mapValues.add(objectId);
                        relFloorSpaceMap.put(floorId, mapValues);
                    }
                    spaceMap.put(objectId, objectItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_name_space));
                }
            }
            String stepObjectId, spaceId;
            JSONObject build, buildStepObject, space;
            JSONArray builds, buildStepObjects, spaces, relStepObjects, relSpaces;
            //
            builds = new JSONArray();
            for(String buildKey : buildMap.keySet()){
                build = new JSONObject();
                buildStepObjects = new JSONArray();
                //处理下级对象楼层、空间
                relStepObjects = relBuildStepObjectMap.getOrDefault(buildKey, new JSONArray());
                for(int i=0; i<relStepObjects.size(); i++){
                    stepObjectId = relStepObjects.getString(i);
                    buildStepObject = new JSONObject();
                    if(stepObjectId.startsWith(CommonConst.tag_floor)){
                        //楼层
                        spaces = new JSONArray();
                        relSpaces = relFloorSpaceMap.getOrDefault(stepObjectId, new JSONArray());
                        for(int j=0; j<relSpaces.size(); j++){
                            spaceId = relSpaces.getString(j);
                            space = new JSONObject();
                            space.put("obj_id", spaceId);
                            space.put("obj_name", spaceMap.getOrDefault(spaceId, ""));
                            space.put("obj_type", "space");
                            spaces.add(space);
                        }
                
                        buildStepObject.put("obj_id", stepObjectId);
                        buildStepObject.put("obj_name", floorMap.getOrDefault(stepObjectId, ""));
                        buildStepObject.put("obj_type", "floor");
                        buildStepObject.put("floor_sequence_id",floorSequenceMap.getOrDefault(stepObjectId, "") );
                        buildStepObject.put("content", spaces);
                        buildStepObjects.add(buildStepObject);
                    }else{
                        //空间
                        buildStepObject.put("obj_id", stepObjectId);
                        buildStepObject.put("obj_id", spaceMap.getOrDefault(stepObjectId, ""));
                        buildStepObject.put("obj_type", "space");
                        buildStepObjects.add(buildStepObject);
                    }
                }
                build.put("obj_id", buildKey);
                build.put("obj_name", buildMap.getOrDefault(buildKey, ""));
                build.put("obj_type", "build");
                //根据floor_sequence_id 对楼层排序
                buildStepObjects = DataRequestProcessUtil.sortByIntegerField(buildStepObjects, "floor_sequence_id", -1);
                build.put("content", buildStepObjects);
                builds.add(build);
            }
            objectResultStr = ToolsUtil.successJsonMsg(builds);
        }
        return objectResultStr;
    }


    @Override
    public String queryEquip(String jsonStr) throws Exception {
    	Long startTM = System.currentTimeMillis();

    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
    	//项目id
        String projectId = jsonObject.getString("project_id");
        //建筑id
        String buildId = jsonObject.getString("build_id");
        //专业编码
        String domain = jsonObject.getString("domain_code");
        //系统编码
        String systemCode = jsonObject.getString("system_code");
        //设备编码
        String equipCode = jsonObject.getString("equip_code");
        //系统id(前端暂不支持传入)
        String systemId = jsonObject.getString("system_id");
        //空间id
        String spaceId = jsonObject.getString("space_id");
        //搜索关键字
        String keyword = jsonObject.getString("keyword");
        //返回数据叶子节点是否需要带父级
        boolean needBackParents = jsonObject.getBooleanValue("need_back_parents");
        needBackParents = false;
        
        // 1.设备查询
        // 1.1按专业大类查询设备-请求url
//        String equipRequestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_equipment_complex_query, projectId, projectCache.getProjectSecretById(projectId));
        String equipRequestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_equipment_complex_query);
        // 1.2按专业大类查询设备-请求参数
        JSONObject params = new JSONObject();
        JSONObject criteria = new JSONObject();
        if(!StringUtil.isNull(buildId)) {
        	criteria.put("building_id", buildId);
        }
        if (!StringUtil.isNull(domain)) {
        	criteria.put("category", domain);
		}
        if (!StringUtil.isNull(systemCode)) {
        	criteria.put("system_category", systemCode);
        }
        if (!StringUtil.isNull(equipCode)) {
        	criteria.put("equipment_category", equipCode);
        }
        if (!StringUtil.isNull(keyword)) {
        	criteria.put("name", keyword);
        }

        params.put("criteria", criteria);
        params.put("projectId", projectId);
        params.put("valid", true);
        // 1.3按专业大类查询设备-请求结果
//        String resultStr = httpPostRequest(equipRequestUrl, params.toJSONString());
        String resultStr = httpPostRequestDataPlatform(equipRequestUrl, params.toJSONString());
        JSONObject equipJson = JSONObject.parseObject(resultStr);
        JSONArray equipArray = equipJson.getJSONArray("Content");
        if(equipArray == null || equipArray.isEmpty()) {
        	// 查询不到设备，直接返回结果
        	String returnStr = ToolsUtil.successJsonMsg(new JSONArray());
        	return returnStr;
        }

        //2. 设置返回结果
        Map<String, String> buildIdNameMap = new HashMap<String, String>();
        // 对象（楼层、空间、系统）id_名称集合
        Map<String, String> objectIdNameMap = new HashMap<String, String>();
        // 楼层（空间、系统）id以及对应的建筑（楼层）id {"id":{"building":"", "floor":""}}
        Map<String, JSONObject> objectIdRelationIdMap = new HashMap<>();
        
        if(needBackParents) {
        	// 建筑查询参数及url
        	String paramsQueryBuilding, buildRequstUrl;
        	
        	if(StringUtil.isNull(buildId)){
        		// 查询项目下所有建筑
        		paramsQueryBuilding = "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"type\":[\"Bd\"]}}";
//        		buildRequstUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query, projectId, projectCache.getProjectSecretById(projectId));
        		buildRequstUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
        	}else{
        		// 根据传入的建筑id参数查询具体建筑
        		paramsQueryBuilding = "{\"projectId\":\"" + projectId + "\",\"criterias\":[{\"id\":\"" + buildId + "\"}]}";
//        		buildRequstUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query, projectId, projectCache.getProjectSecretById(projectId));
        		buildRequstUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query);
        	}
        	
//        	String buildResultStr = httpPostRequest(buildRequstUrl, paramsQueryBuilding);
        	String buildResultStr = httpPostRequestDataPlatform(buildRequstUrl, paramsQueryBuilding);
            JSONObject buildJson = JSONObject.parseObject(buildResultStr);
            JSONArray builds = buildJson.getJSONArray("Content");
            if ("failure".equals(buildJson.getString("Result")) || builds.size() < 1) {
                return buildResultStr;
            }
            
            buildIdNameMap = getObjectIdNameMap(buildResultStr);
            
            // 查询项目（建筑）下楼层，空间，系统请求参数
            String paramQueryFlSPSy;
//            String flSPSyRequestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query, projectId, projectCache.getProjectSecretById(projectId));
            String flSPSyRequestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
            // 查询建筑（如果没有建筑id则查询项目）下楼层、空间、系统信息
            if(StringUtil.isNull(buildId)){
            	paramQueryFlSPSy = "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"type\":[\"Fl\",\"Sp\",\"Sy\"]}}";
            }else{
            	paramQueryFlSPSy = "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"id\":\""+ buildId +"\",\"type\":[\"Fl\",\"Sp\",\"Sy\"]}}";
            }
            
            // 查询项目（建筑）下楼层，空间，系统结果
//            String flSPSyResultStr = httpPostRequest(flSPSyRequestUrl, paramQueryFlSPSy);
            String flSPSyResultStr = httpPostRequestDataPlatform(flSPSyRequestUrl, paramQueryFlSPSy);
            if(flSPSyResultStr.contains("failure")){
                return flSPSyResultStr;
            }
            
            objectIdNameMap = getObjectIdNameMap(flSPSyResultStr);
            objectIdRelationIdMap = getBuildingOrFoor(flSPSyResultStr);
        }
        
        // 设备id_空间id集合
        Map<String, String> eqid_spid_map = new HashMap<>();
        // ------------------- 查询设备和空间关系 start---------------------- //
        // 查询关系实例Url
//        String relationInstanceRequestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_relation_relation_instance_query, projectId, projectCache.getProjectSecretById(projectId));
        String relationInstanceRequestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_relation_relation_instance_query);
        // 查询关系请求参数对象
        params.clear();
        // 项目下的 设备-空间  图实例id
        String graphIdOfEquipAndSPace = graphCache.getGraphIdByProjectIdAndGraph(projectId, CommonConst.graph_type_equip_in_space);
        
        if(!StringUtil.isNull(graphIdOfEquipAndSPace)) {
        	if(needBackParents) {
        		criteria.clear();
        		criteria.put("graph_id", graphIdOfEquipAndSPace);
        		criteria.put("rel_type", CommonConst.relation_type_equip_in_space);
        		if(!StringUtil.isNull(spaceId)){
        			criteria.put("to_id", spaceId);
        		}
        		params.put("criteria", criteria);
        		params.put("projectId", projectId);
//        		resultStr = httpPostRequest(relationInstanceRequestUrl, params.toJSONString());
        		resultStr = httpPostRequestDataPlatform(relationInstanceRequestUrl, params.toJSONString());
        		
        		if(resultStr.contains("success")){
        			// resultStr 设备与空间关系查询的结果集
        			eqid_spid_map = getRelationMap(resultStr, CommonConst.relation_from_id, CommonConst.relation_to_id);
        		}
        	}else if(!StringUtil.isNull(spaceId)) {
        		criteria.clear();
        		criteria.put("graph_id", graphIdOfEquipAndSPace);
        		criteria.put("rel_type", CommonConst.relation_type_equip_in_space);
        		criteria.put("to_id", spaceId);
        		params.put("criteria", criteria);
        		params.put("projectId", projectId);
//        		resultStr = httpPostRequest(relationInstanceRequestUrl, params.toJSONString());
        		resultStr = httpPostRequestDataPlatform(relationInstanceRequestUrl, params.toJSONString());
        		
        		if(resultStr.contains("success")){
        			// resultStr 设备与空间关系查询的结果集
        			eqid_spid_map = getRelationMap(resultStr, CommonConst.relation_from_id, CommonConst.relation_to_id);
        		}
        	}
        }
        // ------------------- 查询设备和空间关系 end---------------------- //
        
        
        // 设备id_系统id集合
        Map<String, String> eqid_syid_map = new HashMap<>();
        // ------------------- 查询设备和系统关系 start---------------------- //
        //项目下的设备-系统图实例id
        String graphIdOfEquipAndSystem = graphCache.getGraphIdByProjectIdAndGraph(projectId, CommonConst.graph_type_system_contain_equip);
        if(!StringUtil.isNull(graphIdOfEquipAndSystem)){
        	if(needBackParents) {
        		criteria.clear();
        		criteria.put("graph_id", graphIdOfEquipAndSystem);
        		criteria.put("rel_type", CommonConst.relation_type_system_contain_equip);
        		if(!StringUtil.isNull(systemId)){
        			criteria.put("from_id", systemId);
        		}
        		params.clear();
        		params.put("criteria", criteria);
        		params.put("projectId", projectId);
//        		resultStr = httpPostRequest(relationInstanceRequestUrl, params.toJSONString());
        		resultStr = httpPostRequestDataPlatform(relationInstanceRequestUrl, params.toJSONString());
        		
        		if(resultStr.contains("success")){
        			// resultStr 设备与系统关系查询的结果集
        			eqid_syid_map = getRelationMap(resultStr, CommonConst.relation_to_id, CommonConst.relation_from_id);
        		}
        	}else if(!StringUtil.isNull(systemId)) {
        		criteria.clear();
        		criteria.put("graph_id", graphIdOfEquipAndSystem);
        		criteria.put("rel_type", CommonConst.relation_type_system_contain_equip);
    			criteria.put("from_id", systemId);
        		params.clear();
        		params.put("criteria", criteria);
        		params.put("projectId", projectId);
//        		resultStr = httpPostRequest(relationInstanceRequestUrl, params.toJSONString());
        		resultStr = httpPostRequestDataPlatform(relationInstanceRequestUrl, params.toJSONString());
        		
        		if(resultStr.contains("success")){
        			// resultStr 设备与系统关系查询的结果集
        			eqid_syid_map = getRelationMap(resultStr, CommonConst.relation_to_id, CommonConst.relation_from_id);
        		}
        	}
        }
        // ------------------- 查询设备和系统关系 end---------------------- //
        
        
        // 系统id_系统所属专业编码
        Map<String, String> syid_domaincode_map = new HashMap<>();
        // ------------------- 查询系统所属专业编码 start---------------------- //
        if(null != eqid_syid_map && !eqid_syid_map.isEmpty()) {
        	Set<String> sysIdSet = new LinkedHashSet<>();
        	for(String sysId : eqid_syid_map.values()) {
        		sysIdSet.add(sysId);
        	}
        	
        	StringBuilder criteriasSB = new StringBuilder("[");
        	for(String sysId : sysIdSet) {
        		criteriasSB.append("{\"id\":\"" + sysId + "\"},");
        	}
        	String criteriasStr = criteriasSB.toString();
        	criteriasStr = criteriasStr.substring(0, criteriasStr.length() - 1) + "]";
        	
        	JSONObject param = new JSONObject();
        	param.put("projectId", projectId);
        	param.put("criterias", JSONArray.parseArray(criteriasStr));
        	
        	// 根据id集合批量查询系统实例
//        	String batchRequestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query, projectId, projectCache.getProjectSecretById(projectId));
        	String batchRequestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query);
//        	resultStr = httpPostRequest(batchRequestUrl, param.toJSONString());
        	resultStr = httpPostRequestDataPlatform(batchRequestUrl, param.toJSONString());
        	if(resultStr.contains("success")){
        		JSONObject resultJson = JSONObject.parseObject(resultStr);
        		JSONArray sysArray = resultJson.getJSONArray("Content");
        		if(sysArray != null && !sysArray.isEmpty()) {
					for (int i = 0; i < sysArray.size(); i++) {
						JSONObject queryContent = sysArray.getJSONObject(i);
						syid_domaincode_map.put(queryContent.getString("id"),
								queryContent.getString("category") == null ? null
										: queryContent.getString("category").substring(0, 2));
					}
				}
        	}
        }
        // ------------------- 查询系统所属专业编码 end---------------------- //
        
                
        String equipId, relSpaceId, relSpaceName, relFloorId, relFloorName, relSystemId, relSystemName, domainId, domainName;
        JSONObject equip, equipItem, parent;
        JSONArray spaceSystemFilter, equips, parents, parentIds, parentNames;
        equips = new JSONArray();
        
        // 要返回的设备id集合
        //List<String> equipIdList = new ArrayList<>();
        
        // 设备id_所属建筑id集合
        Map<String, String> eqid_bdid_map = new HashMap<>();
       
        
        // 根据空间id和系统id过滤后的设备集合
        spaceSystemFilter = new JSONArray();
        for (int i = 0; i < equipArray.size(); i++) {
        	JSONObject queryContent = equipArray.getJSONObject(i);
        	String equip_id = queryContent.getString("id");
        	
        	if(!StringUtil.isNull(spaceId) && (MapUtils.isEmpty(eqid_spid_map) || !eqid_spid_map.containsKey(equip_id))) {
        		continue;
        	}
        	
        	if(!StringUtil.isNull(systemId) && (MapUtils.isEmpty(eqid_syid_map) || !eqid_syid_map.containsKey(equip_id))) {
        		continue;
        	}
        	
        	//equipIdList.add(equip_id);
        	
        	if(!StringUtil.isNull(buildId)) {
        		eqid_bdid_map.put(equip_id, buildId);
        	}else {
        		eqid_bdid_map.put(equip_id, queryContent.getJSONObject("location") == null ? null
        				: queryContent.getJSONObject("location").getString("building"));
        	}
        	
        	spaceSystemFilter.add(queryContent);
        }
        
        for(int i=0; i<spaceSystemFilter.size(); i++){
            equipItem = spaceSystemFilter.getJSONObject(i);
            equipId = equipItem.getString("id");
            buildId = eqid_bdid_map.get(equipId);
            equip = new JSONObject();
            if(needBackParents){
                //组织parents
                parents = new JSONArray();
                //建筑-楼层-空间
                parent = new JSONObject();
                parentIds = new JSONArray();
                parentNames = new JSONArray();
                parentIds.add(buildId);
                parentNames.add(buildIdNameMap.get(buildId));
                if(eqid_spid_map.containsKey(equipId)){
                    relSpaceId = eqid_spid_map.get(equipId);
                    relSpaceName = objectIdNameMap.get(relSpaceId);
                    // 空间所属楼层id
                    relFloorId = objectIdRelationIdMap.get(relSpaceId) == null ? null : (String) objectIdRelationIdMap.get(relSpaceId).get("floor");
                    relFloorName = objectIdNameMap.get(relFloorId);
                    if(null != relFloorId && !relFloorId.endsWith("000") && !StringUtil.isNull(relFloorName)){
                        parentIds.add(relFloorId);
                        parentNames.add(relFloorName);
                    }
                    parentIds.add(relSpaceId);
                    parentNames.add(relSpaceName);
                }
                parent.put("parent_ids", parentIds);
                parent.put("parent_names", parentNames);
                parents.add(parent);
                
                //专业-系统实例
                parent = new JSONObject();
                parentIds = new JSONArray();
                parentNames = new JSONArray();
                relSystemId = eqid_syid_map.get(equipId);
                relSystemName = objectIdNameMap.get(relSystemId);
                // 专业编码
                domainId = syid_domaincode_map.get(relSystemId);
                domainName = dictionaryCache.getNameByTypeCode(CommonConst.dict_type_object_domain, domainId);
				if (domainId != null) {
					parentIds.add(domainId);
				}
				if (domainName != null) {
					parentNames.add(domainName);
				}
				if (relSystemId != null) {
					parentIds.add(relSystemId);
				}
				if (relSystemName != null) {
					parentNames.add(relSystemName);
				}
				if (parentIds.size() != 0) {
					parent.put("parent_ids", parentIds);
				}
				if (parentNames.size() != 0) {
					parent.put("parent_names", parentNames);
				}
				if (!StringUtil.isEmptyList(parent, "parent_ids") && !StringUtil.isEmptyList(parent, "parent_names")) {
					parents.add(parent);
				}
                equip.put("parents", parents);
            }
            equip.put("obj_id", equipId);
            equip.put("obj_name", equipItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_name_equip));
            equip.put("obj_code", equipItem.getJSONObject(CommonConst.info_name_datas).getString(CommonConst.info_name_local_id_equip));
            equips.add(equip);
        }
        resultStr = ToolsUtil.successJsonMsg(equips);
        Long endTM = System.currentTimeMillis();
        log.info("*****queryEquip-[INTERFACE-TIME-COST]- " + (endTM - startTM) / 1000.0 + " 秒");
        return resultStr;
    }
    
    /**
     * 处理实例实体查询结果中id与location的信息对应关系
     * @param queryResult
     * @return {"id":{"building":"", "floor":""}}
     */
    private Map<String, JSONObject> getBuildingOrFoor(String queryResult){
        Map<String, JSONObject> idNameMap = new HashMap<String, JSONObject>();
        JSONObject result;
        JSONArray results;
        JSONObject resultJson = JSONObject.parseObject(queryResult);
        results = resultJson.getJSONArray("Content");
        for(int i=0; i<results.size(); i++){
            result = results.getJSONObject(i);
            JSONObject location = result.getJSONObject("location");
            location = location == null ? new JSONObject() : location;
            idNameMap.put(result.getString("id"), location);
        }
        return idNameMap;
    }

    @Override
    public String queryTempObjectList(String jsonStr) throws Exception {
        JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        jsonObject.put(DBConst.TABLE_FIELD_VALID, true);
        String paramStr = JSONUtil.getCriteriaWithMajors(jsonObject, "valid", "project_id", "obj_type").toJSONString();
        String resultStr = DBCommonMethods.queryRecordByCriteria(DBConst.DATABASE_SAAS_NAME, DBConst.TABLE_TEMP_OBJECT, paramStr);
        resultStr = JSONUtil.processQueryResult(resultStr, null, null, JSONUtil.filter, null, null, "obj_id", "obj_name", "obj_type").toJSONString();
        return resultStr;
    }
    
    @Override
    public String existTempObjectWithType(String jsonStr) throws Exception{
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
    	String params = JSONUtil.getCriteriaWithMajors(jsonObject, "project_id", "obj_type", "obj_name").toJSONString();
    	String resultStr = DBCommonMethods.queryRecordByCriteria(DBConst.DATABASE_SAAS_NAME, DBConst.TABLE_TEMP_OBJECT, params);
    	JSONObject resultJson = JSONObject.parseObject(resultStr);
    	if(Result.FAILURE.equals(resultJson.getString(Result.RESULT))){
    		return resultStr;
    	}
    	boolean exist = true;
    	JSONArray content = resultJson.getJSONArray(Result.CONTENT);
    	if(content == null || content.size() == 0){
    		exist = false;
    	}
    	JSONObject item = new JSONObject();
    	item.put("exist", exist);
    	return ToolsUtil.successJsonMsg(item);
    }

    @Override
    public String addBatchTempObject(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        String objName = jsonObject.getString("obj_name");
        String resultStr = null, paramStr = null;
        paramStr = JSONUtil.getCriteriaWithMajors(jsonObject, "project_id", "obj_type", "obj_name").toJSONString();
        resultStr = DBCommonMethods.queryRecordByCriteria(DBConst.DATABASE_SAAS_NAME, DBConst.TABLE_TEMP_OBJECT, paramStr);
        JSONObject resultJson = JSONObject.parseObject(resultStr);
        if(Result.SUCCESS.equals(resultJson.getString(Result.RESULT))){
        	String objId = null;
        	JSONObject obj;
        	JSONArray objs = resultJson.getJSONArray(Result.CONTENT);
        	objs = objs == null ? new JSONArray() : objs;
        	boolean flag = true;
        	for(int i=0; i<objs.size(); i++){
        		obj = objs.getJSONObject(i);
        		if(objName.equals(obj.getString("obj_name"))){
        			objId = obj.getString("obj_id");
        			flag = false;
        		}
        	}
        	if(flag){
        		objId = ToolsUtil.getRecordId("");
        		jsonObject.put("obj_id", objId);
        		paramStr = JSONUtil.getAddParamJson(jsonObject).toJSONString();
        		resultStr = DBCommonMethods.insertRecord(DBConst.DATABASE_SAAS_NAME, DBConst.TABLE_TEMP_OBJECT, paramStr);
        		resultJson = JSONObject.parseObject(resultStr);
        		if(Result.SUCCESS.equals(resultJson.getString(Result.RESULT))){
        			JSONObject item = new JSONObject();
        			item.put("obj_id", objId);
        			resultStr = ToolsUtil.successJsonMsg(item);
        		}
        	}else{
        		JSONObject item = new JSONObject();
    			item.put("obj_id", objId);
    			resultStr = ToolsUtil.successJsonMsg(item);
        	}
        	
        }
        return resultStr;
    }

    @Override
    public String searchInfoPoint(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        String projectId = jsonObject.getString("project_id");
        String keyWord = jsonObject.getString("keyword");
        keyWord = keyWord == null ? "" : keyWord;
        String[] keyWords = keyWord.split(" +");
        JSONObject param  = new JSONObject();
        JSONArray category = JSONArray.parseArray("[\"Eq\",\"Sy\",\"EqObj\",\"SyObj\"]");
        param.put("keywords", keyWords);
        param.put("info_class", "private");
        param.put("category", category);
        param.put("limit", "200");
        param.put("projectId", projectId);
//        String infoRequestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_infoPoint_search, projectId, projectCache.getProjectSecretById(projectId));
        String infoRequestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_infoPoint_search);
//        String resultStr = httpPostRequest(infoRequestUrl, param.toJSONString());
        String resultStr = httpPostRequestDataPlatform(infoRequestUrl, param.toJSONString());
        if(resultStr.contains("success")){
            String infoType, parentId, parentName;
            JSONObject info, infoItem, parent, infoPoint;
            JSONArray infos, parents, parentIds, parentNames;
            JSONObject resultJson = JSONObject.parseObject(resultStr);
            JSONArray infoArray = resultJson.getJSONArray("Content");
            infos = new JSONArray();
            for(int i=0; i<infoArray.size(); i++){
                infoItem = infoArray.getJSONObject(i);
                info = new JSONObject();
                parents = new JSONArray();
                infoType = infoItem.getString("type");
                if(CommonConst.tag_equip.equals(infoType)){
                    //设备大类信息点
                    parents = new JSONArray();
                    infoPoint = new JSONObject();
                    //处理父级关系
                    parent = new JSONObject();
                    parentIds = new JSONArray();
                    parentNames = new JSONArray();
                    parentId = infoItem.getString("major");
                    parentName = dictionaryCache.getNameByTypeCode(CommonConst.dict_type_object_domain, parentId);
                    if(!StringUtil.isNull(parentId, parentName)) {
                        parentIds.add(parentId);
                        parentNames.add(parentName);
                    }
                    parentId = infoItem.getString("sys");
                    parentName = infoItem.getString("sysName");
                    if(!StringUtil.isNull(parentId, parentName)) {
                        parentIds.add(parentId);
                        parentNames.add(parentName);
                    }
                    parent.put("parent_ids", parentIds);
                    parent.put("parent_names", parentNames);
                    parents.add(parent);
                    //处理信息点
                    infoPoint.put("id", "equip_" + infoItem.getString("eq") + "_" + infoItem.getString("info"));
                    infoPoint.put("code", infoItem.getString("info"));
                    infoPoint.put("name", infoItem.getString("infoName"));

                    info.put("obj_id", infoItem.getString("eq"));
                    info.put("obj_name", infoItem.getString("eqName"));
                    info.put("obj_type", "equip_class");
                    info.put("parents", parents);
                    info.put("info_point", infoPoint);
                }else if(CommonConst.tag_system.equals(infoType)){
                    //系统大类信息点
                    parents = new JSONArray();
                    infoPoint = new JSONObject();
                    //处理父级关系
                    parent = new JSONObject();
                    parentIds = new JSONArray();
                    parentNames = new JSONArray();
                    parentId = infoItem.getString("major");
                    parentName = dictionaryCache.getNameByTypeCode(CommonConst.dict_type_object_domain, parentId);
                    if(!StringUtil.isNull(parentId, parentName)) {
                        parentIds.add(parentId);
                        parentNames.add(parentName);
                    }
                    parent.put("parent_ids", parentIds);
                    parent.put("parent_names", parentNames);
                    parents.add(parent);
                    //处理信息点
                    infoPoint.put("id", "system_" + infoItem.getString("sys") + "_" + infoItem.getString("info"));
                    infoPoint.put("code", infoItem.getString("info"));
                    infoPoint.put("name", infoItem.getString("infoName"));

                    info.put("obj_id", infoItem.getString("sys"));
                    info.put("obj_name", infoItem.getString("sysName"));
                    info.put("obj_type", "system_class");
                    info.put("parents", parents);
                    info.put("info_point", infoPoint);
                }else if(CommonConst.tag_equip_object.equals(infoType)){
                    //设备对象信息点
                    parents = new JSONArray();
                    infoPoint = new JSONObject();
                    //处理父级关系
                    parent = new JSONObject();
                    //处理设备大类父级关系
                    if(!StringUtil.isNull(infoItem, "major", "sysObj")) {
                        parentIds = new JSONArray();
                        parentNames = new JSONArray();
                        parentId = infoItem.getString("major");
                        parentName = dictionaryCache.getNameByTypeCode(CommonConst.dict_type_object_domain, parentId);
                        if (!StringUtil.isNull(parentId, parentName)) {
                            parentIds.add(parentId);
                            parentNames.add(parentName);
                        }
                        parentId = infoItem.getString("sysObj");
                        parentName = infoItem.getString("sysObjName");
                        if (!StringUtil.isNull(parentId, parentName)) {
                            parentIds.add(parentId);
                            parentNames.add(parentName);
                        }
                        parent.put("parent_ids", parentIds);
                        parent.put("parent_names", parentNames);
                        parents.add(parent);
                    }
                    //处理建筑-楼层-空间父级关系
                    parent = new JSONObject();
                    parentIds = new JSONArray();
                    parentNames = new JSONArray();
                    if(!StringUtil.isNull(infoItem, "bdObj")){
                        parentId = infoItem.getString("bdObj");
                        parentName = infoItem.getString("bdObjName");
                        parentIds.add(parentId);
                        parentNames.add(parentName);
                    }
                    if(!StringUtil.isNull(infoItem, "flObj")){
                        parentId = infoItem.getString("flObj");
                        parentName = infoItem.getString("flObjName");
                        parentIds.add(parentId);
                        parentNames.add(parentName);
                    }
                    if(!StringUtil.isNull(infoItem, "spObj")){
                        parentId = infoItem.getString("spObj");
                        parentName = infoItem.getString("spObjName");
                        parentIds.add(parentId);
                        parentNames.add(parentName);
                    }
                    parent.put("parent_ids", parentIds);
                    parent.put("parent_names", parentNames);
                    parents.add(parent);

                    //处理信息点
                    infoPoint.put("id", "equip_" + StringUtil.getEquipOrSystemCodeFromId(infoItem.getString("eqObj"), CommonConst.tag_dict_equip, dataPlatBasePath) + "_" + infoItem.getString("info"));
                    infoPoint.put("code", infoItem.getString("info"));
                    infoPoint.put("name", infoItem.getString("infoName"));

                    info.put("obj_id", infoItem.getString("eqObj"));
                    info.put("obj_name", infoItem.getString("eqObjName"));
                    info.put("obj_type", "equip");
                    info.put("parents", parents);
                    info.put("info_point", infoPoint);
                }else if(CommonConst.tag_system_object.equals(infoType)){
                    //系统对象信息点
                    parents = new JSONArray();
                    infoPoint = new JSONObject();
                    //处理父级关系
                    parent = new JSONObject();
                    parentIds = new JSONArray();
                    parentNames = new JSONArray();
                    parentId = infoItem.getString("major");
                    parentName = dictionaryCache.getNameByTypeCode(CommonConst.dict_type_object_domain, parentId);
                    if(!StringUtil.isNull(parentId, parentName)) {
                        parentIds.add(parentId);
                        parentNames.add(parentName);
                    }
                    parent.put("parent_ids", parentIds);
                    parent.put("parent_names", parentNames);
                    parents.add(parent);
                    //建筑
                    parentIds = new JSONArray();
                    parentNames = new JSONArray();
                    parentId = infoItem.getString("bdObj");
                    parentName = infoItem.getString("bdObjName");
                    if(!StringUtil.isNull(parentId, parentName)) {
                        parentIds.add(parentId);
                        parentNames.add(parentName);
                    }
                    parent = new JSONObject();
                    parent.put("parent_ids", parentIds);
                    parent.put("parent_names", parentNames);
                    parents.add(parent);
                    //处理信息点
                    infoPoint.put("id", "system_" + StringUtil.getEquipOrSystemCodeFromId(infoItem.getString("sysObj"), CommonConst.tag_dict_sytstem, dataPlatBasePath) + "_" + infoItem.getString("info"));
                    infoPoint.put("code", infoItem.getString("info"));
                    infoPoint.put("name", infoItem.getString("infoName"));

                    info.put("obj_id", infoItem.getString("sysObj"));
                    info.put("obj_name", infoItem.getString("sysObjName"));
                    info.put("obj_type", "system");
                    info.put("parents", parents);
                    info.put("info_point", infoPoint);
                }
                if(info.containsKey("info_point") 
                		&& infoPointCache.isShowInApp(info.getJSONObject("info_point").getString("id"), infoItem.getString(CommonConst.info_name_info_point_baseCmpt))){
                	infos.add(info);
                }
            }
            resultStr = ToolsUtil.successJsonMsg(infos);
        }
        return resultStr;
    }

    @Override
    public String queryObjClassForInfoPointSel(String jsonStr) throws Exception {
        String resultStr;
        try{
            resultStr = ToolsUtil.successJsonMsg(CommonMessage.object_class_infoPoint);
        }catch (Exception e){
            resultStr = ToolsUtil.errorJsonMsg("");
        }
        return resultStr;
    }

    @Override
    public String queryInfoPointForBuild(String jsonStr) throws Exception {
        return null;
    }

    @Override
    public String queryInfoPointForFloor(String jsonStr) throws Exception {
        return null;
    }

    @Override
    public String queryInfoPointForSpace(String jsonStr) throws Exception {
        return null;
    }

    @Override
    public String queryInfoPointForSystem(String jsonStr) throws Exception {
        JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        String systemId = jsonObject.getString("obj_id");
        String keyword = jsonObject.getString("keyword");
        String[] keywords = null;
        if(!StringUtil.isNull(keyword)){
        	 keywords = keyword.split(" ");
        }
        String systemType = StringUtil.getEquipOrSystemCodeFromId(systemId, CommonConst.tag_dict_sytstem, dataPlatBasePath);
        String url = getDataPlatDictPath(DataRequestPathUtil.dataPlat_infoPoint_special, systemType);
//        String infoStr = httpGetRequest(url);
        String infoStr = httpPostRequestDataPlatform(url,"{}");
        JSONObject infoJson = JSONObject.parseObject(infoStr);
        Map<String, JSONArray> cmptDataMap = Maps.newHashMap();
        if("success".equals(infoJson.getString("Result"))){
            JSONObject info, infoItem;
            JSONArray infos, infoArray;
            String code, id, name, baseCmpt;
            infoArray = infoJson.getJSONArray("Content");
            infos = new JSONArray();
            for(int i=0; i<infoArray.size(); i++){
                infoItem = infoArray.getJSONObject(i);
                code = infoItem.getString(CommonConst.info_name_info_point_code);
                name = infoItem.getString(CommonConst.info_name_info_point_name);
                baseCmpt = infoItem.getString(CommonConst.info_name_info_point_baseCmpt);
                boolean flag = true;
                if(keywords != null){
                	for(String key : keywords){
                		if(!name.contains(key)){
                			flag = false;
                		}
                	}
                }
                if(!flag){
                	continue;
                }
                id = "system"+"_" +systemType+"_"+code;
                if(infoPointCache.isShowInApp(id, infoItem.getString(CommonConst.info_name_info_point_baseCmpt))){
                    info = new JSONObject();
                    info.put("id", id);
                    info.put("code", code);
                    info.put("name", infoItem.getString(CommonConst.info_name_info_point_name));
                    info.put("unit", infoItem.getString("unit"));
                    info.put("cmpt", componentRelationCache.getAppComponentCodeByBaseCmptCode(baseCmpt));
                    info.put("cmpt_data", getInfoPointCmptData(infoItem.get("dataSource"), info.getString("name"), cmptDataMap ));

                    infos.add(info);
                }
            }
            infoStr = ToolsUtil.successJsonMsg(infos);
        }
        return infoStr;
    }

    @Override
    public String queryInfoPointForEquip(String jsonStr) throws Exception {
        JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        String equipId = jsonObject.getString("obj_id");
        String keyword = jsonObject.getString("keyword");
        String[] keywords = null;
        if(!StringUtil.isNull(keyword)){
        	 keywords = keyword.split(" ");
        }
        String equipType = StringUtil.getEquipOrSystemCodeFromId(equipId, CommonConst.tag_dict_equip, dataPlatBasePath);
        String url = getDataPlatDictPath(DataRequestPathUtil.dataPlat_infoPoint_special, equipType);
//        String infoStr = httpGetRequest(url);
        String infoStr = httpPostRequestDataPlatform(url,"{}");
        JSONObject infoJson = JSONObject.parseObject(infoStr);
        Map<String, JSONArray> cmptDataMap = Maps.newHashMap();
        if("success".equals(infoJson.getString("Result"))){
            JSONObject info, infoItem;
            JSONArray infos, infoArray;
            String code, id, name, baseCmpt;
            infoArray = infoJson.getJSONArray("Content");
            infos = new JSONArray();
            for(int i=0; i<infoArray.size(); i++){
                infoItem = infoArray.getJSONObject(i);
                code = infoItem.getString(CommonConst.info_name_info_point_code);
                name = infoItem.getString(CommonConst.info_name_info_point_name);
                baseCmpt = infoItem.getString(CommonConst.info_name_info_point_baseCmpt);
                boolean flag = true;
                if(keywords != null){
                	for(String key : keywords){
                		if(!name.contains(key)){
                			flag = false;
                		}
                	}
                }
                if(!flag){
                	continue;
                }
                id = "equip"+"_" +equipType+"_"+code;
                if(infoPointCache.isShowInApp(id, infoItem.getString(CommonConst.info_name_info_point_baseCmpt))){
                    info = new JSONObject();
                    info.put("id", id);
                    info.put("code", code);
                    info.put("name", infoItem.getString(CommonConst.info_name_info_point_name));
                    info.put("unit", infoItem.getString("unit"));
                    info.put("cmpt", componentRelationCache.getAppComponentCodeByBaseCmptCode(baseCmpt));
                    info.put("cmpt_data", getInfoPointCmptData(infoItem.get("dataSource"), info.getString("name"), cmptDataMap ));
                    infos.add(info);
                }
            }
            infoStr = ToolsUtil.successJsonMsg(infos);
        }
        return infoStr;
    }

    @Override
    public String queryInfoPointForSystemClass(String jsonStr) throws Exception {
        JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        String systemType = jsonObject.getString("obj_id");
        String keyword = jsonObject.getString("keyword");
        String[] keywords = null;
        if(!StringUtil.isNull(keyword)){
        	 keywords = keyword.split(" ");
        }
        String url = getDataPlatDictPath(DataRequestPathUtil.dataPlat_infoPoint_special, systemType);
//        String infoStr = httpGetRequest(url);
        String infoStr = httpPostRequestDataPlatform(url,"{}");
        JSONObject infoJson = JSONObject.parseObject(infoStr);
        Map<String, JSONArray> cmptDataMap = Maps.newHashMap();
        if("success".equals(infoJson.getString("Result"))){
            JSONObject info, infoItem;
            JSONArray infos, infoArray;
            String code, id, name,baseCmpt;
            infoArray = infoJson.getJSONArray("Content");
            infos = new JSONArray();
            for(int i=0; i<infoArray.size(); i++){
                infoItem = infoArray.getJSONObject(i);
                code = infoItem.getString(CommonConst.info_name_info_point_code);
                name = infoItem.getString(CommonConst.info_name_info_point_name);
                baseCmpt = infoItem.getString(CommonConst.info_name_info_point_baseCmpt);
                boolean flag = true;
                if(keywords != null){
                	for(String key : keywords){
                		if(!name.contains(key)){
                			flag = false;
                		}
                	}
                }
                if(!flag){
                	continue;
                }
                id = "system"+"_" +systemType+"_"+code;
                if(infoPointCache.isShowInApp(id, infoItem.getString(CommonConst.info_name_info_point_baseCmpt))){
                    info = new JSONObject();
                    info.put("id", id);
                    info.put("code", code);
                    info.put("name", infoItem.getString(CommonConst.info_name_info_point_name));
                    info.put("unit", infoItem.getString("unit"));
                    info.put("cmpt", componentRelationCache.getAppComponentCodeByBaseCmptCode(baseCmpt));
                    info.put("cmpt_data", getInfoPointCmptData(infoItem.get("dataSource"), info.getString("name"), cmptDataMap ));

                    infos.add(info);
                }
            }
            infoStr = ToolsUtil.successJsonMsg(infos);
        }
        return infoStr;
    }
    
    @Override
    public String queryInfoPointForShaft(String jsonStr) throws Exception {
        JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        String type = "shaft";
        String keyword = jsonObject.getString("keyword");
        String[] keywords = null;
        if(!StringUtil.isNull(keyword)){
        	 keywords = keyword.split(" ");
        }
        String url = getDataPlatDictPath(DataRequestPathUtil.dataPlat_infoPoint_special, type);
//        String infoStr = httpGetRequest(url);
        String infoStr = httpPostRequestDataPlatform(url,"{}");
        JSONObject infoJson = JSONObject.parseObject(infoStr);
        Map<String, JSONArray> cmptDataMap = Maps.newHashMap();
        if("success".equals(infoJson.getString("Result"))){
            JSONObject info, infoItem;
            JSONArray infos, infoArray;
            String code, id, name,baseCmpt;
            infoArray = infoJson.getJSONArray("Content");
            infos = new JSONArray();
            for(int i=0; i<infoArray.size(); i++){
                infoItem = infoArray.getJSONObject(i);
                code = infoItem.getString(CommonConst.info_name_info_point_code);
                name = infoItem.getString(CommonConst.info_name_info_point_name);
                baseCmpt = infoItem.getString(CommonConst.info_name_info_point_baseCmpt);
                boolean flag = true;
                if(keywords != null){
                	for(String key : keywords){
                		if(!name.contains(key)){
                			flag = false;
                		}
                	}
                }
                if(!flag){
                	continue;
                }
                id = "shaft"+"_" +type+"_"+code;
                if(infoPointCache.isShowInApp(id, infoItem.getString(CommonConst.info_name_info_point_baseCmpt))){
                    info = new JSONObject();
                    info.put("id", id);
                    info.put("code", code);
                    info.put("name", infoItem.getString(CommonConst.info_name_info_point_name));
                    info.put("unit", infoItem.getString("unit"));
                    info.put("cmpt", componentRelationCache.getAppComponentCodeByBaseCmptCode(baseCmpt));
                    info.put("cmpt_data", getInfoPointCmptData(infoItem.get("dataSource"), info.getString("name"), cmptDataMap ));

                    infos.add(info);
                }
            }
            infoStr = ToolsUtil.successJsonMsg(infos);
        }
        return infoStr;
    }
    
    @Override
    public String queryInfoPointForBuildClass(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
//    	String systemType = jsonObject.getString("obj_id");
    	String keyword = jsonObject.getString("keyword");
    	String[] keywords = null;
    	if(!StringUtil.isNull(keyword)){
    		keywords = keyword.split(" ");
    	}
    	String url = getDataPlatDictPath(DataRequestPathUtil.dataPlat_infoPoint_query_building, null);
//    	String infoStr = httpGetRequest(url);
    	String infoStr = httpPostRequestDataPlatform(url,"{}");
    	JSONObject infoJson = JSONObject.parseObject(infoStr);
    	Map<String, JSONArray> cmptDataMap = Maps.newHashMap();
    	if("success".equals(infoJson.getString("Result"))){
    		JSONObject info, infoItem;
    		JSONArray infos, infoArray;
    		String code, id, name,baseCmpt;
    		infoArray = infoJson.getJSONArray("Content");
    		infos = new JSONArray();
    		for(int i=0; i<infoArray.size(); i++){
    			infoItem = infoArray.getJSONObject(i);
    			code = infoItem.getString(CommonConst.info_name_info_point_code);
    			name = infoItem.getString(CommonConst.info_name_info_point_name);
    			baseCmpt = infoItem.getString(CommonConst.info_name_info_point_baseCmpt);
    			boolean flag = true;
    			if(keywords != null){
    				for(String key : keywords){
    					if(!name.contains(key)){
    						flag = false;
    					}
    				}
    			}
    			if(!flag){
    				continue;
    			}
    			id = "build_0_"+code;
    			if(infoPointCache.isShowInApp(id, infoItem.getString(CommonConst.info_name_info_point_baseCmpt))){
    				info = new JSONObject();
    				info.put("id", id);
    				info.put("code", code);
    				info.put("name", infoItem.getString(CommonConst.info_name_info_point_name));
                    info.put("unit", infoItem.getString("unit"));
                    info.put("cmpt", componentRelationCache.getAppComponentCodeByBaseCmptCode(baseCmpt));
                    info.put("cmpt_data", getInfoPointCmptData(infoItem.get("dataSource"), info.getString("name"), cmptDataMap ));

    				infos.add(info);
    			}
    		}
    		infoStr = ToolsUtil.successJsonMsg(infos);
    	}
    	return infoStr;
    }
    @Override
    public String queryInfoPointForFloorClass(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
//    	String systemType = jsonObject.getString("obj_id");
    	String keyword = jsonObject.getString("keyword");
    	String[] keywords = null;
    	if(!StringUtil.isNull(keyword)){
    		keywords = keyword.split(" ");
    	}
    	String url = getDataPlatDictPath(DataRequestPathUtil.dataPlat_infoPoint_query_floor, null);
//    	String infoStr = httpGetRequest(url);
    	String infoStr = httpPostRequestDataPlatform(url,"{}");
    	JSONObject infoJson = JSONObject.parseObject(infoStr);
    	 Map<String, JSONArray> cmptDataMap = Maps.newHashMap();
    	if("success".equals(infoJson.getString("Result"))){
    		JSONObject info, infoItem;
    		JSONArray infos, infoArray;
			String code, id, name, baseCmpt;
    		infoArray = infoJson.getJSONArray("Content");
    		infos = new JSONArray();
    		for(int i=0; i<infoArray.size(); i++){
    			infoItem = infoArray.getJSONObject(i);
    			code = infoItem.getString(CommonConst.info_name_info_point_code);
    			name = infoItem.getString(CommonConst.info_name_info_point_name);
    			baseCmpt = infoItem.getString(CommonConst.info_name_info_point_baseCmpt);
    			boolean flag = true;
    			if(keywords != null){
    				for(String key : keywords){
    					if(!name.contains(key)){
    						flag = false;
    					}
    				}
    			}
    			if(!flag){
    				continue;
    			}
    			id = "floor"+"_0_"+code;
    			if(infoPointCache.isShowInApp(id, infoItem.getString(CommonConst.info_name_info_point_baseCmpt))){
    				info = new JSONObject();
    				info.put("id", id);
    				info.put("code", code);
    				info.put("name", infoItem.getString(CommonConst.info_name_info_point_name));
					info.put("unit", infoItem.getString("unit"));
	                info.put("cmpt", componentRelationCache.getAppComponentCodeByBaseCmptCode(baseCmpt));
                    if ("FloorIdentity".equals(code)) {
                        info.put("cmpt_data", dictionaryService.queryDataSourceById(CommonConst.JsonToData.Flooridentity));
                    } else {
                        info.put("cmpt_data", getInfoPointCmptData(infoItem.get("dataSource"), info.getString("name"), cmptDataMap));
                    }
    				infos.add(info);
    			}
    		}
    		infoStr = ToolsUtil.successJsonMsg(infos);
    	}
    	return infoStr;
    }
/*    @Override
    public String queryInfoPointForSpaceClass(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
//    	String systemType = jsonObject.getString("obj_id");
    	String keyword = jsonObject.getString("keyword");
    	String[] keywords = null;
    	if(!StringUtil.isNull(keyword)){
    		keywords = keyword.split(" ");
    	}
    	String url = getDataPlatDictPath(DataRequestPathUtil.dataPlat_infoPoint_query_space, null);
    	String infoStr = httpGetRequest(url);
    	JSONObject infoJson = JSONObject.parseObject(infoStr);
    	if("success".equals(infoJson.getString("Result"))){
    		JSONObject info, infoItem;
    		JSONArray infos, infoArray;
    		String code, id, name;
    		infoArray = infoJson.getJSONArray("Content");
    		infos = new JSONArray();
    		for(int i=0; i<infoArray.size(); i++){
    			infoItem = infoArray.getJSONObject(i);
    			code = infoItem.getString(CommonConst.info_name_info_point_code);
    			name = infoItem.getString(CommonConst.info_name_info_point_name);
    			boolean flag = true;
    			if(keywords != null){
    				for(String key : keywords){
    					if(!name.contains(key)){
    						flag = false;
    					}
    				}
    			}
    			if(!flag){
    				continue;
    			}
    			id = "space_0_"+code;
    			if(infoPointCache.isShowInApp(id, infoItem.getString(CommonConst.info_name_info_point_baseCmpt))){
    				info = new JSONObject();
    				info.put("id", id);
    				info.put("code", code);
    				info.put("name", infoItem.getString(CommonConst.info_name_info_point_name));
    				infos.add(info);
    			}
    		}
    		infoStr = ToolsUtil.successJsonMsg(infos);
    	}
    	return infoStr;
    }*/
    @Override
    public String queryInfoPointForSpaceClass(String jsonStr) throws Exception {
    	JSONObject jsonObject = JSONObject.parseObject(jsonStr);
//    	String systemType = jsonObject.getString("obj_id");
    	String keyword = jsonObject.getString("keyword");
    	String[] keywords = null;
    	if(!StringUtil.isNull(keyword)){
    		keywords = keyword.split(" ");
    	}
    	String url = getDataPlatDictPath(DataRequestPathUtil.dataPlat_infoPoint_query_space, null);
//    	String infoStr = httpGetRequest(url);
    	String infoStr = httpPostRequestDataPlatform(url,"{}");
    	JSONObject infoJson = JSONObject.parseObject(infoStr);
        Map<String, JSONArray> cmptDataMap = Maps.newHashMap();
    	if("success".equals(infoJson.getString("Result"))){
    		JSONObject info, infoItem;
    		JSONArray infos, infoArray;
    		String code, id, name, baseCmpt;
    		infoArray = infoJson.getJSONArray("Content");
    		infos = new JSONArray();
    		for(int i=0; i<infoArray.size(); i++){
    			infoItem = infoArray.getJSONObject(i);
    			code = infoItem.getString(CommonConst.info_name_info_point_code);
    			name = infoItem.getString(CommonConst.info_name_info_point_name);
    			baseCmpt = infoItem.getString(CommonConst.info_name_info_point_baseCmpt);
    			boolean flag = true;
    			if(keywords != null){
    				for(String key : keywords){
    					if(!name.contains(key)){
    						flag = false;
    					}
    				}
    			}
    			if(!flag){
    				continue;
    			}
    			id = "space_0_"+code;
    			if(infoPointCache.isShowInApp(id, infoItem.getString(CommonConst.info_name_info_point_baseCmpt))){
    				info = new JSONObject();
    				info.put("id", id);
    				info.put("code", code);
    				info.put("name", infoItem.getString(CommonConst.info_name_info_point_name));
                    info.put("unit", infoItem.getString("unit"));
                    info.put("cmpt", componentRelationCache.getAppComponentCodeByBaseCmptCode(baseCmpt));
                    if ("RoomFuncType".equals(code) || "ProjRoomFuncType".equals(code)) {
                        info.put("cmpt_data", dictionaryService.queryDataSourceById(CommonConst.JsonToData.SpaceFunction));
                    } else {
                        info.put("cmpt_data", getInfoPointCmptData(infoItem.get("dataSource"), info.getString("name"), cmptDataMap ));
                    }
    				infos.add(info);
    			}
    		}
    		infoStr = ToolsUtil.successJsonMsg(infos);
    	}
    	return infoStr;
    }

    @Override
    public String queryInfoPointForEquipClass(String jsonStr) throws Exception {
        JSONObject jsonObject = JSONObject.parseObject(jsonStr);
//        String projectId = jsonObject.getString("project_id");
        String equipType = jsonObject.getString("obj_id");
        String keyword = jsonObject.getString("keyword");
        String[] keywords = null;
        if(!StringUtil.isNull(keyword)){
        	 keywords = keyword.split(" ");
        }
        String url = getDataPlatDictPath(DataRequestPathUtil.dataPlat_infoPoint_special, equipType);
//        String infoStr = httpGetRequest(url);
        String infoStr = httpPostRequestDataPlatform(url,"{}");
        Map<String, JSONArray> cmptDataMap = Maps.newHashMap();
        JSONObject infoJson = JSONObject.parseObject(infoStr);
        if("success".equals(infoJson.getString("Result"))){
            JSONObject info, infoItem;
            JSONArray infos, infoArray;
            String code, id, name, baseCmpt;
            infoArray = infoJson.getJSONArray("Content");
            infos = new JSONArray();
            for(int i=0; i<infoArray.size(); i++){
                infoItem = infoArray.getJSONObject(i);
                code = infoItem.getString(CommonConst.info_name_info_point_code);
                name = infoItem.getString(CommonConst.info_name_info_point_name);
                baseCmpt = infoItem.getString(CommonConst.info_name_info_point_baseCmpt);
                boolean flag = true;
                if(keywords != null){
                	for(String key : keywords){
                		if(!name.contains(key)){
                			flag = false;
                		}
                	}
                }
                if(!flag){
                	continue;
                }
                id = "equip"+"_" +equipType+"_"+code;
                if(infoPointCache.isShowInApp(id, infoItem.getString(CommonConst.info_name_info_point_baseCmpt))){
                    info = new JSONObject();
                    info.put("id", id);
                    info.put("code", code);
                    info.put("name", infoItem.getString(CommonConst.info_name_info_point_name));
                    info.put("unit", infoItem.getString("unit"));
                    info.put("cmpt", componentRelationCache.getAppComponentCodeByBaseCmptCode(baseCmpt));
                    info.put("cmpt_data", getInfoPointCmptData(infoItem.get("dataSource"), info.getString("name"), cmptDataMap ));
                    infos.add(info);
                }
            }
            infoStr = ToolsUtil.successJsonMsg(infos);
        }
        return infoStr;
    }

    @Override
    public String queryBatchObj(String jsonStr, String projectId, boolean valid) throws Exception {
        String resultStr;
        JSONArray objIds = JSONArray.parseArray(jsonStr);
        if(objIds.size() < 1){
            resultStr = ToolsUtil.successJsonMsg(new JSONArray());
        }else {
            JSONObject param = new JSONObject();
            JSONArray criterias = new JSONArray();
            JSONObject criteria;
            for (int i = 0; i <objIds.size(); i++){
                criteria = new JSONObject();
                criteria.put("id", objIds.getString(i));
                criterias.add(criteria);
            }
            param.put("criterias", criterias);
            param.put("projectId", projectId);
            param.put(DBConst.TABLE_FIELD_VALID, valid);
//            String url = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query, projectId, projectCache.getProjectSecretById(projectId));
            String url = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query);
//            resultStr = httpPostRequest(url, param.toJSONString());
            resultStr = httpPostRequestDataPlatform(url, param.toJSONString());
        }
        return resultStr;
    }

    @Override
    public List<String> queryBatchDomainOrInfoPoint(String jsonStr) throws Exception {
        List<String> result = new ArrayList<String>();
        JSONArray dictArray = JSONArray.parseArray(jsonStr);
        if(dictArray.size() > 0){
            String dictId, infoUrl, type, infoStr;
//            JSONObject infoJson, info;
//            JSONArray infos;

            for(int i=0; i<dictArray.size(); i++){
                dictId = dictArray.getString(i);
                if(dictId.contains("_")){
                    type = dictId.substring(dictId.indexOf("_")+1, dictId.lastIndexOf("_"));
                    if (type.equals("0")) {
                    	type = dictId.substring(0,dictId.indexOf("_"));
						if (type.equals("build")) {
							type = "building";
						}
                    	infoUrl = getDataPlatDictPath(DataRequestPathUtil.dataPlat_infoPoint_special, type);
					}else {
						
						infoUrl = getDataPlatDictPath(DataRequestPathUtil.dataPlat_infoPoint_special, type);
					}
//                    infoStr = httpGetRequest(infoUrl);
                    infoStr = httpPostRequestDataPlatform(infoUrl,"{\"ID\":\""+type+"\"}");
                    if(infoStr.contains("failure"))
                        return null;
                    result.addAll(proccessQueryResult(JSONObject.parseObject(infoStr), "infoPointCode", dictId.substring(0, dictId.lastIndexOf("_"))));
                }
            }
            String domainUrl = getDataPlatDictPath(DataRequestPathUtil.dataPlat_dict_query, "equipment_all");
//            String domainStr = httpGetRequest(domainUrl);
            String domainStr = httpPostRequestDataPlatform(domainUrl,"{}");
            if(domainStr.contains("failure"))
                return null;
            JSONObject domainJson = JSONObject.parseObject(domainStr);
            JSONArray domains = domainJson.getJSONArray("Content");
            JSONObject domain, system, equip;
            JSONArray systems, equips;
            for(int i=0; i<domains.size(); i++){
                domain = domains.getJSONObject(i);
                systems = domain.getJSONArray("content");
                for(int j=0; j<systems.size(); j++){
                    system = systems.getJSONObject(j);
                    result.add(system.getString("code"));
                    equips = system.getJSONArray("content");
                    for(int k=0; k<equips.size(); k++){
                        equip = equips.getJSONObject(k);
                        result.add(equip.getString("code"));
                    }
                }
            }
        }
        return result;
    }

    /**
     * 处理实例实体查询结果中id与localname的对应关系
     * @param queryResult
     * @return
     */
    public Map<String, String> getObjectIdNameMap(String queryResult){
        Map<String, String> idNameMap = new HashMap<String, String>();
        String localName = null;
        JSONObject result, infoDatas;
        JSONArray results;
        JSONObject resultJson = JSONObject.parseObject(queryResult);
        results = resultJson.getJSONArray("Content");
        for(int i=0; i<results.size(); i++){
            result = results.getJSONObject(i);
            infoDatas = result.getJSONObject(CommonConst.info_name_datas);
            if(infoDatas.containsKey(CommonConst.info_name_local_name_project)){
                localName = infoDatas.getString(CommonConst.info_name_local_name_project);
            }else if(infoDatas.containsKey(CommonConst.info_name_local_name_build)){
                localName = infoDatas.getString(CommonConst.info_name_local_name_build);
            }else if(infoDatas.containsKey(CommonConst.info_name_local_name_floor)){
                localName = infoDatas.getString(CommonConst.info_name_local_name_floor);
            }else if(infoDatas.containsKey(CommonConst.info_name_local_name_space)){
                localName = infoDatas.getString(CommonConst.info_name_local_name_space);
            }else if(infoDatas.containsKey(CommonConst.info_name_local_name_equip)){
                localName = infoDatas.getString(CommonConst.info_name_local_name_equip);
            }else if(infoDatas.containsKey(CommonConst.info_name_local_name_system)){
                localName = infoDatas.getString(CommonConst.info_name_local_name_system);
            }else if(infoDatas.containsKey(CommonConst.info_name_local_name_shaft)){
                localName = infoDatas.getString(CommonConst.info_name_local_name_shaft);
            }
            idNameMap.put(result.getString("id"), localName);
        }
        return idNameMap;
    }

    /**
     * 处理关系查询结果
     * @param queryResult
     * @param keyName
     * @param valueName
     * @return
     */
    public Map<String, String> getRelationMap(String queryResult, String keyName, String valueName){
        Map<String, String> relationMap = new HashMap<String, String>();
        if(queryResult.contains("success")){
            JSONObject result;
            JSONObject resultJson = JSONObject.parseObject(queryResult);
            JSONArray results = resultJson.getJSONArray("Content");
            for(int i=0; i<results.size(); i++){
                result = results.getJSONObject(i);
                relationMap.put(result.getString(keyName), result.getString(valueName));
            }
        }
        return relationMap;
    }

    /**
     * 处理查询结果 获取sop主键ID
     * @param jsonObject
     * @param infoName
     * @return
     */
    public List<String> proccessQueryResult(JSONObject jsonObject, String infoName){
        List<String> set = null;
        if(jsonObject != null){
            JSONArray array = jsonObject.getJSONArray("Content");
            if(array != null){
                set = new ArrayList<String>();
                for(int i=0; i<array.size(); i++){
                    set.add(array.getJSONObject(i).getString(infoName));
                }
            }
        }
        return set;
    }
    
    private Map<String, String> getObjectIdNameMap(JSONObject queryResult, String localName){
		Map<String, String> map = new HashMap<String, String>();
		JSONArray array = queryResult.getJSONArray(Result.CONTENT);
		array = array == null ? new JSONArray() : array;
		for(int i=0; i<array.size(); i++){
			JSONObject item = array.getJSONObject(i);
			map.put(item.getString("id"), item.getJSONObject(CommonConst.info_name_datas).getString(localName));
		}
		return map;
	}

    /**
     * 处理查询结果 获取sop主键ID
     * @param jsonObject
     * @param infoName
     * @return
     */
    public List<String> proccessQueryResult(JSONObject jsonObject, String infoName, String type){
        List<String> set = null;
        if(jsonObject != null){
            JSONArray array = jsonObject.getJSONArray("Content");
            if(array != null){
                set = new ArrayList<String>();
                for(int i=0; i<array.size(); i++){
                    set.add(type + "_" +array.getJSONObject(i).getString(infoName));
                }
            }
        }
        return set;
    }

	@Override
	public String httpPostRequestDataPlatformPath(String requestPath, String projectId, String secret, String jsonStr) throws Exception {
//		String requestUrl = getDataPlatformPath(requestPath, projectId, secret);
		String requestUrl = getDataPlatformPath(requestPath);
//		return httpPostRequest(requestUrl, jsonStr);
		return httpPostRequestDataPlatform(requestUrl, jsonStr);
	}
	
	/**
	 * 功能描述： 获取数据平台的关系实例
	 * @param project_id
	 * @param secret
	 * @param from_id
	 * @param to_id
	 * @param graph_id
	 * @param rel_type
	 * @return
	 * @throws Exception 
	 */
	@Override
	public JSONObject queryRelation(String project_id, String secret,
                                    String from_id, String to_id,
                                    String graph_id, String rel_type) throws Exception {
		JSONObject jsonObject = new JSONObject();
		JSONObject criteria = new JSONObject();
		criteria.put("from_id", from_id);
		criteria.put("to_id", to_id);
		criteria.put("graph_id", graph_id);
		criteria.put("rel_type", rel_type);
		jsonObject.put("criteria", criteria);
		jsonObject.put("projectId", project_id);
//		String relationUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_relation_relation_instance_query,
//				project_id,
//				secret);
		String relationUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_relation_relation_instance_query);
		JSONObject relation = null;
//		String queryResult = httpPostRequest(relationUrl, jsonObject.toJSONString());
		String queryResult = httpPostRequestDataPlatform(relationUrl, jsonObject.toJSONString());
		JSONObject relationJson = JSONObject.parseObject(queryResult);
		if(Result.SUCCESS.equals(relationJson.getString(Result.RESULT))) {
			JSONArray relationContents = relationJson.getJSONArray(Result.CONTENT);
			if(relationContents != null && relationContents.size() > 0) {
				relation = relationContents.getJSONObject(0);
			}
		}
		return relation;
	}
	@Override
	public JSONArray queryRelations(String project_id, String from_id, String to_id, String graph_id, String rel_type) throws Exception {
		JSONObject jsonObject = new JSONObject();
		JSONObject criteria = new JSONObject();
		criteria.put("from_id", from_id);
		criteria.put("to_id", to_id);
		criteria.put("graph_id", graph_id);
		criteria.put("rel_type", rel_type);
		jsonObject.put("criteria", criteria);
		jsonObject.put("projectId", project_id);
		String relationUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_relation_relation_instance_query);
		String queryResult = httpPostRequestDataPlatform(relationUrl, jsonObject.toJSONString());
		JSONObject relationJson = JSONObject.parseObject(queryResult);
		return relationJson.getJSONArray(Result.CONTENT);
	}
	@Override
	public JSONArray queryRelation(String project_id, String secret,
                                   JSONArray criterias) throws Exception {
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("merge", true);
		jsonObject.put("criterias", criterias);
		jsonObject.put("projectId", project_id);
		JSONArray relationContents = null;
//		String relationUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_relation_relation_instance_query,
//				project_id,
//				secret);
		String relationUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_relation_relation_instance_query);
//		String queryResult = httpPostRequest(relationUrl, jsonObject.toJSONString());
		String queryResult = httpPostRequestDataPlatform(relationUrl, jsonObject.toJSONString());
		JSONObject relationJson = JSONObject.parseObject(queryResult);
		if(Result.SUCCESS.equals(relationJson.getString(Result.RESULT))) {
			relationContents = relationJson.getJSONArray(Result.CONTENT);
		}
		return relationContents;
	}
    /**
     * 获取信息点的datasource，如果是引用其他数据字典的需要转化
     * @param dataSource
     * @param name           信息点名称
     * @param cmptDataMap   暂存，防止需要转换的数据字典重复查询
     * @return
     * @throws Exception
     */
	public JSONArray getInfoPointCmptData(Object dataSource, String name, Map<String, JSONArray> cmptDataMap) throws Exception {
	    cmptDataMap = cmptDataMap == null ? Maps.newHashMap() : cmptDataMap;
	    if(dataSource != null){
            if(dataSource instanceof JSONArray){
                return (JSONArray) dataSource;
            }else if(dataSource instanceof String){
                String dataSourceStr = (String) dataSource;
                JSONArray cmptData = cmptDataMap.get(dataSourceStr);
                if(cmptData == null && !StringUtil.isNull(dataSourceStr)){
                    cmptData = dictionaryService.queryDictionaryDataForJSONArrayByName(name);
                    if(cmptData != null){
                        cmptDataMap.put(dataSourceStr, cmptData);
                    }
                    return cmptData;
                }else{
                	/*
                	 * 防止空指针
                	 * update by yuecaipu on 2018/5/8/20:00
                	 */
                	cmptData = cmptData==null? new JSONArray():cmptData;
                    return JSONArray.parseArray(cmptData.toJSONString());
                }
            }else{
                return null;
            }
        }else{
	        return null;
        }
    }

	@Override
	public List<String> queryBatchAllDomainOrInfoPoint(String jsonStr) throws Exception {
		List<String> list = queryBatchDomainOrInfoPoint(jsonStr);
		String dictUrl = getDataPlatDictPath(DataRequestPathUtil.dataPlat_dict_query, "space");
//		String resultStr = httpGetRequest(dictUrl);
		String resultStr = httpPostRequestDataPlatform(dictUrl,"{}");
		JSONObject resultJson = JSONObject.parseObject(resultStr);
		// 2.转化数据格式;
		if (Result.SUCCESS.equals(resultJson.getString(Result.RESULT))) {
			JSONArray contents = resultJson.getJSONArray(Result.CONTENT);
			addSpaceClass(list,contents);
		
		}
/*		String spaceClass = querySpaceClass(jsonStr);
		JSONObject spaceClassObj = JSONObject.parseObject(spaceClass);
		JSONArray content = spaceClassObj.getJSONArray(Result.CONTENT);*/
		return list;
	}

	private void addSpaceClass(List<String> list, JSONArray content) {
		if (content != null && content.size() > 0) {
			JSONObject spaceClass;
			for (int i = 0, lenght = content.size(); i < lenght; i++) {
				spaceClass = content.getJSONObject(i);				
				list.add(spaceClass.getString("code"));
				addSpaceClass(list,spaceClass.getJSONArray("content"));
			}
		}
	}

	@Override
    public JSONArray queryInstanceByObjType(String projectId, String className, String objCode, Map<String,String> spaceRelationMap) throws Exception {
        JSONArray contentArray = null;
        if("space_class".equals(className)) {
            // TODO 是否考虑子空间
            contentArray = querySpaceByCode(projectId,objCode);
        } else {
//            String requestURL = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query, projectId, projectCache.getProjectSecretById(projectId));
            String requestURL = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
//            String response = httpPostRequest(requestURL, "{\"criteria\":{\"type\":[\"" + objCode + "\"]}}");
            String response = httpPostRequestDataPlatform(requestURL, "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"type\":[\"" + objCode + "\"]}}");
            JSONObject responseObject = JSONObject.parseObject(response);
            if ("success".equals(responseObject.getString("Result"))) {
                contentArray = responseObject.getJSONArray("Content");
            }
        }
        if (CollectionUtils.isEmpty(contentArray)) {
            return new JSONArray();
        }
        JSONArray resultArray = new JSONArray();
  //      Map<String,String> spaceRelationMap = getSpaceRelation(projectId);
        JSONArray parentIdAllArray = new JSONArray();
        for (Object contentObject : contentArray) {
            JSONObject infoObject = ((JSONObject) contentObject).getJSONObject("infos");
            String objId = null;
            if ("system_class".equals(className)) {
                JSONObject location = ((JSONObject) contentObject).getJSONObject("location");
                parentIdAllArray.addAll(JSONArray.parseArray(JSON.toJSONString(location.values())));
            } else if ("equip_class".equals(className)) {
                objId = infoObject.getString("EquipID");
                JSONObject location = ((JSONObject) contentObject).getJSONObject("location");
                parentIdAllArray.addAll(JSONArray.parseArray(JSON.toJSONString(location.values())));
                if(spaceRelationMap.containsKey(objId)){
                    parentIdAllArray.add(spaceRelationMap.get(objId));
                }
            } else if ("space_class".equals(className)) {
                JSONObject location = ((JSONObject) contentObject).getJSONObject("location");
                parentIdAllArray.addAll(JSONArray.parseArray(JSON.toJSONString(location.values())));
            }
        }

        Map<String,String> idNameMap = getObjIdNameMap(projectId,parentIdAllArray);

        for (Object contentObject : contentArray) {
            JSONObject resultObject = new JSONObject();
            JSONObject infoObject = ((JSONObject) contentObject).getJSONObject("infos");
            String objId = null;
            String objName = null;
            String objType = null;
            JSONArray parentIdArray = null;
            if ("system_class".equals(className)) {
                objId = infoObject.getString("SysID");
                objName = infoObject.getString("SysLocalName");
                objType = "system";
                JSONObject location = ((JSONObject) contentObject).getJSONObject("location");
                parentIdArray = JSONArray.parseArray(JSON.toJSONString(location.values()));
            } else if ("equip_class".equals(className)) {
                objId = infoObject.getString("EquipID");
                objName = infoObject.getString("EquipLocalName");
                objType = "equip";
                JSONObject location = ((JSONObject) contentObject).getJSONObject("location");
                parentIdArray = JSONArray.parseArray(JSON.toJSONString(location.values()));
                if(spaceRelationMap.containsKey(objId)){
                    parentIdArray.add(spaceRelationMap.get(objId));
                }
            } else if ("space_class".equals(className)) {
                objId = infoObject.getString("RoomID");
                objName = infoObject.getString("RoomLocalName");
                objType = "space";
                JSONObject location = ((JSONObject) contentObject).getJSONObject("location");
                parentIdArray = JSONArray.parseArray(JSON.toJSONString(location.values()));
            }

         //   JSONArray parentNameArray = getObjNamesByIds(projectId,parentIdArray);
            JSONArray parentNameArray = getObjNamesByIds(parentIdArray,idNameMap);
            JSONObject parentObject = new JSONObject();
            parentObject.put("parent_ids",parentIdArray);
            parentObject.put("parent_names",parentNameArray);
            JSONArray parents = new JSONArray();
            parents.add(parentObject);

            resultObject.put("obj_id", objId);
            resultObject.put("obj_name", objName);
            resultObject.put("obj_type", objType);
            resultObject.put("parents", parents);
            resultArray.add(resultObject);
        }
        return resultArray;
    }

    private JSONArray querySpaceByCode(String projectId, String spaceCode) throws Exception{
        JSONArray spaceIdSet = new JSONArray();
//        String requestURL = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_query_by_info, projectId, projectCache.getProjectSecretById(projectId));
        String requestURL = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_query_by_info);
        JSONObject criteria = new JSONObject();
        criteria.put("type", JSONArray.parseArray("[\"Sp\"]"));
        criteria.put("infos", JSONArray.parseArray("[{\"ProjRoomFuncType\":\"" + spaceCode + "\"}]"));
  //      criteria.put("infos", new JSONArray());
        JSONObject requestParam = new JSONObject();
        requestParam.put("criteria", criteria);
        requestParam.put("projectId", projectId);
//        String response = httpPostRequest(requestURL, requestParam.toJSONString());
        String response = httpPostRequestDataPlatform(requestURL, requestParam.toJSONString());
        JSONObject responseObject = JSONObject.parseObject(response);
        if ("success".equals(responseObject.getString("Result"))) {
            JSONArray contentArray = responseObject.getJSONArray("Content");
            if (CollectionUtils.isEmpty(contentArray)) {
                return new JSONArray();
            }
           /* JSONArray subSpaceCodeArray = getAllSpaceCode(spaceCode);
            for (Object temp : contentArray) {
                JSONObject contentObject = (JSONObject)temp;
                if(subSpaceCodeArray.contains(contentObject.getJSONObject("infos").getString("ProjRoomFuncType"))){
                    spaceIdSet.add(contentObject.getString("id"));
                }
            }*/
            for (Object spaceObject : contentArray) {
                spaceIdSet.add(((JSONObject)spaceObject).getString("id"));
            }
        }
        return queryDataPlatObjectBatchQuery(projectId, spaceIdSet);
    }

    private JSONArray getAllSpaceCode(String spaceCode) throws Exception{
        String requestURL = getDataPlatDictPath(DataRequestPathUtil.dataPlat_dict_query, "space");
//        String response = httpGetRequest(requestURL);
        String response = httpPostRequestDataPlatform(requestURL,"{}");
        JSONObject responseObject = JSONObject.parseObject(response);
        JSONArray result = new JSONArray();
        result.add(spaceCode);

        if ("success".equals(responseObject.getString("Result"))) {
            JSONObject spaceCodeObject = getSpaceCodeObject(responseObject.getJSONArray("Content"),spaceCode);
            if(spaceCodeObject!=null){
                getAllSubSpaceCode(spaceCodeObject.getJSONArray("content"), result);
            }
        }
        return result;
    }

    private JSONObject getSpaceCodeObject(JSONArray spaceCodeArray, String spaceCode) throws Exception{
        if(CollectionUtils.isEmpty(spaceCodeArray)){
            return null;
        }
        for(Object temp:spaceCodeArray){
            JSONObject spaceCodeObject=(JSONObject) temp;
            if(spaceCode.equals(spaceCodeObject.getString("code"))){
                return spaceCodeObject;
            }
            JSONObject subSpaceObject = getSpaceCodeObject(spaceCodeObject.getJSONArray("content"),spaceCode);
            if(subSpaceObject!=null) {
                return spaceCodeObject;
            }
        }
        return null;
    }

    /**
     * @description
     * @param spaceCodeObjectArray content数组
     * @param spaceCodeArray 空间code集合
     * @author feng
     * @date 16:45 2018/5/24
     */
    private void getAllSubSpaceCode(JSONArray spaceCodeObjectArray, JSONArray spaceCodeArray) throws Exception {
        if (CollectionUtils.isEmpty(spaceCodeObjectArray)) {
            return;
        }
        for (Object temp : spaceCodeObjectArray) {
            JSONObject spaceCodeObject = (JSONObject) temp;
            spaceCodeArray.add(spaceCodeObject.getString("code"));
            getAllSubSpaceCode(spaceCodeObject.getJSONArray("content"), spaceCodeArray);
        }
    }

    @Override
    public JSONArray filterEquipmentInSpace(String projectId, String spaceCode, JSONArray equipmentArray, Map<String, String> spaceRelationMap) throws Exception {
        JSONArray spaceArray = this.querySpaceByCode(projectId, spaceCode);
        return filterEquipmnetInSpaceArray(projectId, spaceArray, equipmentArray, spaceRelationMap);
    }

    private JSONArray filterEquipmnetInSpaceArray(String projectId, JSONArray spaceArray, JSONArray equipmentArray, Map<String, String> spaceRelationMap) throws Exception {
        if (CollectionUtils.isEmpty(spaceArray) || CollectionUtils.isEmpty(equipmentArray)) {
            return new JSONArray();
        }
        Set<String> spaceIdSet = new HashSet<>();
        for (Object contentObject : spaceArray) {
            spaceIdSet.add(((JSONObject) contentObject).getString("id"));
        }
    //    Map<String, String> spaceRelationMap = getSpaceRelation(projectId);
        Set<String> equipmentIdSet = new HashSet<>();
        for (Map.Entry<String, String> entity : spaceRelationMap.entrySet()) {
            if (spaceIdSet.contains(entity.getValue())) {
                equipmentIdSet.add(entity.getKey());
            }
        }

        if(CollectionUtils.isEmpty(equipmentIdSet)){
            return new JSONArray();
        }

        JSONArray resultArray = new JSONArray();
        for (Object equipment : equipmentArray) {
            JSONObject equipmentTemp = (JSONObject) equipment;
            if (equipmentIdSet.contains(equipmentTemp.getString("obj_id"))) {
                resultArray.add(equipment);
            }
        }

        return resultArray;
    }


    /**
     * @description
     * @param projectId
     * @return java.util.Map<java.lang.String,java.lang.String> {"设备id":"空间id"}
     * @author feng
     * @date 14:43 2018/5/21
     */
    @Override
    public Map<String, String> getSpaceRelation(String projectId) throws Exception {
        // 查询设备与指定空间的关系
        // 1.请求路径
//        String requestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_relation_relation_instance_query, projectId, projectCache.getProjectSecretById(projectId));
        String requestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_relation_relation_instance_query);
        // 2.图实例id
        String graph_id = graphCache.getGraphIdByProjectIdAndGraph(projectId, "EquipinSpace");
        // 3.请求参数
        JSONObject jsonParam = new JSONObject();
        JSONObject criteria = new JSONObject();
        criteria.put("graph_id", graph_id);
        criteria.put("rel_type", "1");
        jsonParam.put("criteria", criteria);
        jsonParam.put("projectId", projectId);
//        String queryResult = httpPostRequest(requestUrl, jsonParam.toJSONString());
        String queryResult = httpPostRequestDataPlatform(requestUrl, jsonParam.toJSONString());

        Map<String, String> resultMap = new HashMap<>();
        if (null != queryResult && queryResult.contains(Result.SUCCESS)) {
            JSONObject resultJsonObj = JSONObject.parseObject(queryResult);
            JSONArray contentData = resultJsonObj.getJSONArray(Result.CONTENT);
            if (null != contentData && !contentData.isEmpty()) {
                for (int i = 0; i < contentData.size(); i++) {
                    JSONObject item = contentData.getJSONObject(i);
                    resultMap.put(item.getString("from_id"), item.getString("to_id"));
                }
            }
        }
        return resultMap;
    }
    private JSONArray queryDataPlatObjectBatchQuery(String projectId, JSONArray idArray) throws Exception{
//        String requestURL = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query, projectId, projectCache.getProjectSecretById(projectId));
        String requestURL = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query);
        JSONObject requestParam = new JSONObject();
        JSONArray criteriaArray = new JSONArray();
        for (Object idObject : idArray) {
            JSONObject criteriaObject = new JSONObject();
            criteriaObject.put("id", idObject);
            criteriaArray.add(criteriaObject);
        }
        requestParam.put("criterias",criteriaArray);
        requestParam.put("projectId", projectId);
//        String response = httpPostRequest(requestURL, requestParam.toJSONString());
        String response = httpPostRequestDataPlatform(requestURL, requestParam.toJSONString());
        JSONObject responseObject = JSONObject.parseObject(response);
        if ("success".equals(responseObject.getString("Result"))) {
            return responseObject.getJSONArray("Content");
        }
        return new JSONArray();
    }

    // 根据id 获取name
    private JSONArray getObjNamesByIds(String projectId, JSONArray idArray) throws Exception {
        JSONArray resultArray = new JSONArray();
        Map<String, String> idNameMap = getObjIdNameMap(projectId, idArray);
        for (Object id : idArray) {
            resultArray.add(idNameMap.get(id.toString()));
        }
        return resultArray;
    }

    private JSONArray getObjNamesByIds(JSONArray idArray, Map<String,String> idNameMap) {
        if (null == idArray){
            return null;
        }
        JSONArray resultArray = new JSONArray();
        for (Object id : idArray) {
            resultArray.add(idNameMap.get(id.toString()));
        }
        return resultArray;
    }

    private Map<String, String> getObjIdNameMap(String projectId, JSONArray idArray) throws Exception {
        JSONArray contentArray = queryDataPlatObjectBatchQuery(projectId, idArray);
        if (CollectionUtils.isEmpty(contentArray)) {
            return new HashMap<>();
        }
        Map<String, String> idNameMap = new HashMap<>();

        for (Object content : contentArray) {
            String id = ((JSONObject) content).getString("id");
            JSONObject infos = ((JSONObject) content).getJSONObject("infos");
            if (id.startsWith("Bd")) {
                idNameMap.put(id, infos.getString("BuildLocalName"));
            } else if (id.startsWith("Fl")) {
                idNameMap.put(id, infos.getString("FloorLocalName"));
            } else if (id.startsWith("Sp")) {
                idNameMap.put(id, infos.getString("RoomLocalName"));
            } else if (id.startsWith("Sy")) {
                idNameMap.put(id, infos.getString("SystemLocalName"));
            }
        }
        return idNameMap;
    }

    @Override
    public JSONArray filterSapceInFloor(String projectId, String floorId, JSONArray spaceArray) throws Exception{
        if(CollectionUtils.isEmpty(spaceArray)){
            return new JSONArray();
        }
        JSONArray floorArray = queryFloorById(projectId,floorId);
        if(CollectionUtils.isEmpty(floorArray)){
            return new JSONArray();
        }

        JSONArray querySpaceArray = querySpaceInFloor(projectId,floorArray);
        if(CollectionUtils.isEmpty(querySpaceArray)){
            return new JSONArray();
        }
        Set<String> spaceIdSet = new HashSet<>();
        for(Object querySpace:querySpaceArray){
            spaceIdSet.add(((JSONObject)querySpace).getString("id"));
        }

        JSONArray resultArray = new JSONArray();
        for(Object space:spaceArray){
            JSONObject spaceObject = (JSONObject)space;
            if(spaceIdSet.contains(spaceObject.getString("obj_id"))){
                resultArray.add(space);
            }
        }
        return resultArray;
    }

    @Override
    public JSONArray filterSapceByFloorIdentity(String projectId, String floorIdentityCode, JSONArray spaceArray) throws Exception{
        if(CollectionUtils.isEmpty(spaceArray)){
            return new JSONArray();
        }
        JSONArray floorArray = queryFloorByIdentityCode(projectId,floorIdentityCode);
        if(CollectionUtils.isEmpty(floorArray)){
            return new JSONArray();
        }

        JSONArray querySpaceArray = querySpaceInFloor(projectId,floorArray);
        if(CollectionUtils.isEmpty(querySpaceArray)){
            return new JSONArray();
        }
        Set<String> spaceIdSet = new HashSet<>();
        for(Object querySpace:querySpaceArray){
            spaceIdSet.add(((JSONObject)querySpace).getString("id"));
        }

        JSONArray resultArray = new JSONArray();
        for(Object space:spaceArray){
            JSONObject spaceObject = (JSONObject)space;
            if(spaceIdSet.contains(spaceObject.getString("obj_id"))){
                resultArray.add(space);
            }
        }
        return resultArray;
    }


    @Override
    public JSONArray filterEquipmentInFloor(String projectId, String floorId, JSONArray equipmentArray, Map<String, String> spaceRelationMap) throws Exception {
        if(CollectionUtils.isEmpty(equipmentArray)){
            return new JSONArray();
        }

        JSONArray floorArray = queryFloorById(projectId,floorId);
        if(CollectionUtils.isEmpty(floorArray)){
            return new JSONArray();
        }

        JSONArray spaceArray = querySpaceInFloor(projectId,floorArray);
        if(CollectionUtils.isEmpty(spaceArray)){
            return new JSONArray();
        }
        return filterEquipmnetInSpaceArray(projectId, spaceArray, equipmentArray, spaceRelationMap);
    }

    @Override
    public JSONArray filterEquipmentByFloorIdentity(String projectId, String floorIdentityCode, JSONArray equipmentArray, Map<String, String> spaceRelationMap) throws Exception{
        if(CollectionUtils.isEmpty(equipmentArray)){
            return new JSONArray();
        }

        JSONArray floorArray = queryFloorByIdentityCode(projectId, floorIdentityCode);
        if(CollectionUtils.isEmpty(floorArray)){
            return new JSONArray();
        }

        JSONArray spaceArray = querySpaceInFloor(projectId,floorArray);
        if(CollectionUtils.isEmpty(spaceArray)){
            return new JSONArray();
        }
        return filterEquipmnetInSpaceArray(projectId, spaceArray, equipmentArray,spaceRelationMap);
    }

    private JSONArray queryFloorById(String projectId, String floorId) throws Exception {
        JSONArray idArray = new JSONArray();
        idArray.add(floorId);
        return queryDataPlatObjectBatchQuery(projectId,idArray);
    }

    private JSONArray queryFloorByIdentityCode(String projectId, String floorCode) throws Exception {
//        String requestURL = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_query_by_info, projectId, projectCache.getProjectSecretById(projectId));
        String requestURL = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_query_by_info);
        JSONObject criteria = new JSONObject();
        criteria.put("type", JSONArray.parseArray("[\"Fl\"]"));
        // 楼层信息点编码
        criteria.put("infos", JSONArray.parseArray("[{\"FloorIdentity\":\"" + floorCode + "\"}]"));
        JSONObject requestParam = new JSONObject();
        requestParam.put("criteria", criteria);
        requestParam.put("projectId", projectId);
//        String response = httpPostRequest(requestURL, requestParam.toJSONString());
        String response = httpPostRequestDataPlatform(requestURL, requestParam.toJSONString());
        JSONObject responseObject = JSONObject.parseObject(response);
        if ("success".equals(responseObject.getString("Result"))) {
            return responseObject.getJSONArray("Content");
        }
        return new JSONArray();
    }

    private JSONArray querySpaceInFloor(String projectId, JSONArray floorArray) throws Exception {
        if(CollectionUtils.isEmpty(floorArray)){
            return new JSONArray();
        }
//        String requestURL = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query, projectId, projectCache.getProjectSecretById(projectId));
        String requestURL = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
        JSONArray resultArray = new JSONArray();
        for(Object floor:floorArray){
            JSONObject criteria = new JSONObject();
            criteria.put("id", ((JSONObject) floor).getString("id"));
            criteria.put("type", JSONArray.parseArray("[\"Sp\"]"));
            JSONObject requestParam = new JSONObject();
            requestParam.put("criteria", criteria);
            requestParam.put("projectId", projectId);
//            String response = httpPostRequest(requestURL, requestParam.toJSONString());
            String response = httpPostRequestDataPlatform(requestURL, requestParam.toJSONString());
            JSONObject responseObject = JSONObject.parseObject(response);
            if ("success".equals(responseObject.getString("Result"))) {
                JSONArray contentArray = responseObject.getJSONArray("Content");
                if(CollectionUtils.isNotEmpty(contentArray)){
                    resultArray.addAll(contentArray);
                }
            }
        }
        return resultArray;
    }

	@Override
	public String queryObjById(String objId,String projectId) throws Exception {
		
		String jsonQueryStr = "{\"projectId\":\""+ projectId +"\", \"criterias\":[{\"id\":\""+ objId+"\"}],\"valid\":null}";
//		String requestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query_post, projectId, null);
		String requestUrl = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_batch_query_post);
//	    String queryResult = httpPostRequest(requestUrl, jsonQueryStr);
	    String queryResult = httpPostRequestDataPlatform(requestUrl, jsonQueryStr);
		return queryResult;
	}
	
	@Override
	public String queryFloorInfoPointByCode(String infoPointCode) throws Exception {
        if ("FloorIdentity".equals(infoPointCode)) {
            //获取楼层编码数据源
            JSONArray jsonArray = dictionaryService.queryDataSourceById(CommonConst.JsonToData.Flooridentity);
            return ToolsUtil.successJsonMsg(jsonArray);
        }
		// 1.调用数据平台获取楼层信息点方法 http://localhost:8080/data-platform-3/infocode/query/floor
		String infoUrl = this.getDataPlatDictPath(DataRequestPathUtil.dataPlat_infoPoint_query_floor, null);

//		String queryInfoResult = httpPostRequest(infoUrl, "");
		String queryInfoResult = httpPostRequestDataPlatform(infoUrl, "{}");

		JSONObject queryInfoJson = JSONObject.parseObject(queryInfoResult);
		if (Result.FAILURE.equals(queryInfoJson.getString(Result.RESULT))) {
			return queryInfoResult;
		}
		// 2.找到FloorIdentity信息点，取他的dataSource，返回给前端
		JSONArray queryInfoContents = queryInfoJson.getJSONArray(Result.CONTENT);
		JSONObject result = new JSONObject();
		JSONArray dataSources = new JSONArray();
		if (queryInfoContents != null && queryInfoContents.size() > 0) {
			JSONObject queryInfoContent;
			for (int i = 0; i < queryInfoContents.size(); i++) {
				queryInfoContent = queryInfoContents.getJSONObject(i);
				if (!infoPointCode.equals(queryInfoContent.getString("infoPointCode"))) {
					continue;
				}
				// 信息点名称
				// String info_name = queryInfoContent.getString("infoPointName");
				dataSources = queryInfoContent.getJSONArray("dataSource");
				if (dataSources != null) {
					break;
				}
			}
			result.put(Result.RESULT, "success");
			result.put(Result.CONTENT, dataSources);
			result.put(Result.COUNT, dataSources.size());
			queryInfoResult = result.toJSONString();
		}
		return queryInfoResult;
	}

	@Override
	public String queryBuildFuncType() throws Exception {
		
		String infoUrl = getDataPlatDictPath(DataRequestPathUtil.dataPlat_dict_query, "building");
//		String resultStr = httpPostRequest(infoUrl, "");
		String resultStr = httpPostRequestDataPlatform(infoUrl, "{}");
		JSONObject resultJson = JSONObject.parseObject(resultStr);
		if (Result.FAILURE.equals(resultJson.getString(Result.RESULT))) {
			return resultStr;
		}
		String contentStr = resultJson.getString(Result.CONTENT);
		contentStr = contentStr.replaceAll("code", "obj_id");
		contentStr = contentStr.replaceAll("name", "obj_name");
		JSONArray content = JSONArray.parseArray(contentStr);
		resultJson.put(Result.CONTENT, content);
		resultJson.put(Result.COUNT, content.size());
		return resultJson.toJSONString();
	}

	@Override
	public String queryShaftFuncType() throws Exception {
		String shaftFuncType = queryShaftInfoPointDataSourceByCode("ShaftFuncType");
		shaftFuncType = shaftFuncType.replaceAll("code", "obj_id");
		shaftFuncType = shaftFuncType.replaceAll("name", "obj_name");
		JSONArray shaftFuncTypeArr = JSONArray.parseArray(shaftFuncType);
		return ToolsUtil.successJsonMsg(shaftFuncTypeArr);
	}

	@Override
	public String queryProFuncType() throws Exception {
		String infoUrl = getDataPlatDictPath(DataRequestPathUtil.dataPlat_dict_query, "building");
		String resultStr = httpPostRequestDataPlatform(infoUrl, "{}");
		JSONObject resultJson = JSONObject.parseObject(resultStr);
		if (Result.FAILURE.equals(resultJson.getString(Result.RESULT))) {
			return resultStr;
		}
		JSONArray content = resultJson.getJSONArray(Result.CONTENT);
		JSONObject proFuncType ;
		for (Object object : content) {
			proFuncType = (JSONObject)object;
			proFuncType.put("obj_id", proFuncType.getString("code"));
			proFuncType.put("obj_name", proFuncType.getString("name"));
			proFuncType.remove("content");
			proFuncType.remove("code");
			proFuncType.remove("name");
		}
		resultJson.put(Result.COUNT, content.size());
		resultJson.put(Result.CONTENT, content);
		return resultJson.toJSONString();
	}
	
	@Override
	public String queryRootProjFuncTypeById(String projectId) throws Exception {
    	//查询出项目的功能类型
		String projFuncType = queryProjFuncTypeById(projectId);
		String infoUrl = getDataPlatDictPath(DataRequestPathUtil.dataPlat_dict_query, "building");
		String resultStr = httpPostRequestDataPlatform(infoUrl, "{}");
		JSONObject resultJson = JSONObject.parseObject(resultStr);
		JSONArray contents = resultJson.getJSONArray(Result.CONTENT);
		Map<String, String> code2rootCode = new HashMap<>();
		for (Object object : contents) {
			JSONObject content = (JSONObject) object;
			String code = content.getString("code");
			code2rootCode.put(code, code);
			getCode2firstCodeMap(code2rootCode, code, content.getJSONArray("content"));
		}
		return code2rootCode.get(projFuncType);
	}
	
	
	private void getCode2firstCodeMap(Map<String, String> code2rootCode, String rootCode, JSONArray contents) {
		for (int i = 0; i < contents.size(); i++) {
			JSONObject node = contents.getJSONObject(i);
			code2rootCode.put(node.getString("code"), rootCode);
			if (!StringUtil.isEmptyList(node, "content")) {
				getCode2firstCodeMap(code2rootCode, rootCode, node.getJSONArray("content"));
			}
			
		}
	}

	private String queryProjFuncTypeById(String projectId) throws Exception {
		String ids = "[\"" + projectId + "\"]";
		String resultStr = queryBatchObj(ids, projectId, true);
		JSONObject resultJson = JSONObject.parseObject(resultStr);
		if (Result.SUCCESS.equals(resultJson.getString(Result.RESULT))
				&& resultJson.getJSONArray(Result.CONTENT).size() > 0) {
			JSONObject jsonObject = resultJson.getJSONArray(Result.CONTENT).getJSONObject(0);
			String ProjFuncType = jsonObject.getJSONObject("infos").getString("ProjFuncType");
			return ProjFuncType;
		}
		return "";
	}

	@Override
	public String convertClassToObject(JSONObject jsonObject) throws Exception {
		String projectId = jsonObject.getString("project_id");
		JSONArray clazzs = jsonObject.getJSONArray("convert_class");//待实例化类
		JSONObject past = jsonObject.getJSONObject("past"); // 已实例化的对象
		past = past == null ? new JSONObject() : past;
		Integer frequency = past.getInteger("frequency"); // 实例化次数
		frequency = null == frequency ? 0 : frequency;
		JSONObject rule = jsonObject.getJSONObject("rule");         //实例化规则
		
		JSONObject reusltJson = new JSONObject();
		JSONObject convertObject = new JSONObject();
		reusltJson.put("past", past);
		reusltJson.put("convert_object", convertObject);
		
		//====================1.实例化每个类=============
		for (Object object : clazzs) {
			JSONObject clazz = (JSONObject)object;
			String objId = clazz.getString("obj_id");
			String objType = clazz.getString("obj_type");
			boolean containScopeFlag = false;
			if (CommonConst.data_type_equip_class.equals(objType) && !StringUtil.isEmptyList(clazz, "space_scope")) {
				JSONObject spaceClazz = clazz.getJSONArray("space_scope").getJSONObject(0);
				containScopeFlag = true;
				objId = spaceClazz.getString("obj_id");
				objType = spaceClazz.getString("obj_type");
			}
			if (convertObject.containsKey(objId) || convertObject.containsKey(objId + "*" + clazz.getString("obj_id"))) {
				continue;
			}
			JSONArray objsArr = querySpaceOrEquipByType(projectId, objId, objType);
			if (objsArr == null || objsArr.size() == 0) {
				continue;
			}
			JSONArray pastTemp = past.getJSONArray(objId);
			pastTemp = pastTemp == null ? new JSONArray() : pastTemp;
			past.put(objId, pastTemp);
			objsArr = filterObjByRule(projectId, objsArr, rule, pastTemp, frequency);
			
			if (containScopeFlag) {
				objsArr = queryEquipByScope(projectId, clazz.getString("obj_id"), objsArr);
				convertObject.put(objId + "*" + clazz.getString("obj_id"), objsArr);
			} else {
				convertObject.put(objId, objsArr);
			}
		}
		past.put("frequency", frequency+1);
		return reusltJson.toJSONString();
	}

	/**
	 * 
	 * Description: 获取空间内的设备对象
	 * @param projectId
	 * @param equipType
	 * @param spaceObjs
	 * @return
	 * @throws Exception JSONArray
	 * @author yuecaipu
	 * @since 2018年10月26日: 下午5:52:27
	 * Update By yuecaipu 2018年10月26日: 下午5:52:27
	 */
	private JSONArray queryEquipByScope(String projectId, String equipType, JSONArray spaceObjs) throws Exception {
		
		JSONArray equips = queryEquipByType(projectId, equipType);
		JSONArray needEquipIds = new JSONArray();
		JSONObject id2equip = new JSONObject();
		for (Object object : equips) {
			JSONObject equip = (JSONObject) object;
			id2equip.put(equip.getString("obj_id"), equip);
		}
		String graphId = graphCache.getGraphIdByProjectIdAndGraph(projectId, CommonConst.graph_type_equip_in_space);
		for (Object object : spaceObjs) {
			JSONObject space = (JSONObject) object;
			String spaceId = space.getString("obj_id");
			JSONObject relations = queryRelation(projectId, null, null, spaceId, graphId, "1");
			if (Result.SUCCESS.equals(relations.getString(Result.RESULT))) {
				JSONArray content = relations.getJSONArray(Result.CONTENT);
				for (Object object2 : content) {
					JSONObject relation = (JSONObject) object2;
					needEquipIds.add(relation.getString("from_id"));
				}
			}
		}

		JSONArray result = new JSONArray();
		for (Object object : needEquipIds) {
			if (!result.contains(id2equip.getJSONObject((String) object))) {
				result.add(id2equip.getJSONObject((String) object));
			}
		}
		return result;
	}

	private JSONArray querySpaceOrEquipByType(String projectId, String id , String type) throws Exception {
		if (CommonConst.data_type_equip_class.equals(type)) {
			return queryEquipByType(projectId, id);
		}else if (CommonConst.data_type_space_class.equals(type)) {
			return querySpaceByType(projectId, id);
		}
		return new JSONArray();
	}
	
	@Override
	public JSONArray querySpaceByType(String projectId, String roomFuncType) throws Exception {
		String requestURL = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_query_by_info);
		JSONObject criteria = new JSONObject();
		criteria.put("type", JSONArray.parseArray("[\"Sp\"]"));
		criteria.put("infos", JSONArray.parseArray("[{\"ProjRoomFuncType\":\"" + roomFuncType  + "\"}]"));
		JSONObject requestParam = new JSONObject();
		requestParam.put("criteria", criteria);
		requestParam.put("projectId", projectId);
		String resultStr = httpPostRequestDataPlatform(requestURL, requestParam.toJSONString());
		JSONObject resultJson = JSONObject.parseObject(resultStr);
		JSONArray spaces = new JSONArray();
		if ("success".equals(resultJson.getString("Result")) && !StringUtil.isEmptyList(resultJson, "Content")) {
			JSONArray content = resultJson.getJSONArray("Content");
			JSONObject space, spaceObject, infos;
			for (Object object : content) {
				spaceObject = (JSONObject) object;
				infos = spaceObject.getJSONObject("infos");
				space = new JSONObject();
				space.put("obj_id", spaceObject.getString("id"));     
				space.put("obj_name", infos.getString("RoomLocalName"));   
				space.put("obj_serial", infos.getString("RoomSerial"));   //空间序号 可能为空
				space.put("obj_type", "space");
				space.put("obj_code", infos.getString("RoomLocalID"));
				spaces.add(space);
			}
		}
		return spaces;
	}


	@Override
	public JSONArray queryEquipByType(String projectId, String equipType) throws Exception {
		String url = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
		String resultStr = httpPostRequestDataPlatform(url, "{\"projectId\":\"" + projectId + "\",\"criteria\":{\"type\":[\"" + equipType + "\"]}}");
		JSONObject resultJson = JSONObject.parseObject(resultStr);
		JSONArray equips = new JSONArray();
		if (Result.SUCCESS.equals(resultJson.getString(Result.RESULT)) && !StringUtil.isEmptyList(resultJson, "Content")) {
			JSONArray content = resultJson.getJSONArray(Result.CONTENT);
			JSONObject equip, equipObject, infos;
			for (Object object : content) {
				equipObject = (JSONObject) object;
				infos = equipObject.getJSONObject("infos");
				equip = new JSONObject();
				equip.put("obj_id", equipObject.getString("id"));
				equip.put("obj_name", infos.getString("EquipLocalName"));
				equip.put("obj_serial", infos.getString("EquipSerial"));     //设备序号 可能为空
				equip.put("obj_type", "equip");
				equip.put("obj_code", infos.getString("EquipLocalID")); //设备本地编码
				equips.add(equip);
			}
		}
		return equips;
	}
	
	/**
	 * 
	 * Description: 根据实例化规则过滤对象
	 * @param projectId
	 * @param objsArr   需要过滤的对象集合
	 * @param rule      实例化规则
	 * @param past      已经实例化过的对象
	 * @return
	 * @throws Exception JSONArray
	 * @author yuecaipu
	 * @param frequency 
	 * @since 2018年10月26日: 下午5:51:36 
	 * Update By yuecaipu 2018年10月26日: 下午5:51:36
	 */
	private JSONArray filterObjByRule(String projectId, JSONArray objsArr, JSONObject rule, JSONArray past, Integer frequency) throws Exception {
		if (objsArr.isEmpty() || rule == null || StringUtil.isNull(rule, "execute_all_obj_flag")
				|| "1".equals(rule.getString("execute_all_obj_flag"))) {
			return objsArr;
		}

		//===========获取对象的位置信息===============
		String objType = objsArr.getJSONObject(0).getString("obj_type");
		JSONArray objIds = new JSONArray();
		Map<String, JSONObject> id2obj = new HashMap<>();
		for (int i = 0; i < objsArr.size(); i++) {
			objIds.add(objsArr.getJSONObject(i).getString("obj_id"));
			id2obj.put(objsArr.getJSONObject(i).getString("obj_id"), objsArr.getJSONObject(i));
		}
		JSONArray objRelationship = querySpaceOrEquipNoHierarchy(projectId, objType, objIds);
		
		//==========根据scope 楼层编码筛选===========
		if (!StringUtil.isEmptyList(rule, "scope")) {
			JSONArray scope = rule.getJSONArray("scope");
			Set<String> floorIdentity = new HashSet<>();
			for (int i = 0; i < scope.size(); i++) {
				floorIdentity.add(scope.getJSONObject(i).getString("obj_id"));
			}
			
			for (int i = 0; i < objRelationship.size(); i++) {
				if (!floorIdentity.contains(objRelationship.getJSONObject(i).getString("floor_identity"))) {
					objIds.remove(objRelationship.getJSONObject(i).getString("obj_id"));
					id2obj.remove(objRelationship.getJSONObject(i).getString("obj_id"));
					objRelationship.remove(i);
					i--;
				}
			}
		}
		// ----------楼层与竖井序号加上建筑id前缀------------------
		String floor_sequence_id, shaft_sequence_id, build_id;
		for (int i = 0; i < objRelationship.size(); i++) {
			floor_sequence_id = objRelationship.getJSONObject(i).getString("floor_sequence_id");
			shaft_sequence_id = objRelationship.getJSONObject(i).getString("shaft_sequence_id");
			build_id = objRelationship.getJSONObject(i).getString("build_id");
			objRelationship.getJSONObject(i).put("floor_sequence_id", build_id + "_" + floor_sequence_id);
			objRelationship.getJSONObject(i).put("shaft_sequence_id", build_id + "_" + shaft_sequence_id);
		}
		
		//===========筛选======================
		String sequenceCode = getSequenceCode(rule.getString("order"), objType);
		objRelationship = JSONUtil.sortByStringField(objRelationship, sequenceCode, 1);
//		Map<String, JSONArray> sequence2obj  = sortBySequence(objRelationship, sequenceCode);
//		filterBySequence(sequence2obj,rule,past);
		objRelationship = filterBySequence(objRelationship, rule, past, objType,frequency);
		
		return objRelationship;
	}

	private JSONArray filterBySequence(JSONArray objRelationship, JSONObject rule, JSONArray past, String objType, Integer frequency) {
		String order = rule.getString("order");                      // 对象执行排序 1-楼层,2-竖井,3-空间/设备,4-随机序号
		boolean reset_random = rule.getBooleanValue("reset_random"); // 重新随机:当order=4时可选择
		String style = rule.getString("style");               // 实例化方式： 1-n次实例化完全部对象、2-每次实例化n个楼层/竖井、3-每次实例化n个对象
		Integer cycle = Integer.parseInt(rule.getString("cycle")); // 实例化周期： n次实例化完全部对象,style=1时有效
		Integer count = Integer.parseInt(rule.getString("count")); // 个数 style=2/3时有效
		String unit = rule.getString("unit");                      // 单位：1-个，2-%(百分比) style=3时有效
//		boolean loop_flag = true; //循环标识
//		Integer total = objRelationship.size();  //对象总数
//		if ("1".equals(style)) {
//			loop_flag = false;
//			count = (int) Math.ceil(total*1.0 / cycle);
//		}
//		String sequenceCode = getSequenceCode(order, objType);
//		TreeSet<String> sequenceIds = new TreeSet<>();
//		for (int i = 0; i < objRelationship.size(); i++) {
//			sequenceIds.add(objRelationship.getJSONObject(i).getString(sequenceCode));
//		}

		JSONArray result = new JSONArray();
//		JSONObject obj ;
		if ("1".equals(order)) {
			Map<String, JSONArray> sequence2obj = sortBySequence(objRelationship, "floor_sequence_id");
			if ("1".equals(style)) {
				JSONArray unpastObjRelationship = filterByPass(objRelationship, past, "obj_id");
				sortBySequence(unpastObjRelationship, "floor_sequence_id");
				Integer cycleTemp = cycle - (frequency % cycle);
				cycle = cycleTemp == 0 ? cycle : cycleTemp;
				count = (int) Math.ceil(unpastObjRelationship.size() * 1.0 / cycle);
				for (int i = 0; i < count; i++) {
					result.add(unpastObjRelationship.getJSONObject(i));
					past.add(unpastObjRelationship.getJSONObject(i).getString("obj_id"));
				}
			}else if ("2".equals(style)) {
	
				Set<String> keySet = sequence2obj.keySet();
				keySet = (TreeSet<String>) keySet;
				count = count > keySet.size() ? keySet.size() : count;
				for (String sequence : keySet) {
					if (!past.contains(sequence) && count > 0) {
						past.add(sequence);
						result.addAll(sequence2obj.get(sequence));
						count--;
					}
				}
				if (count > 0) {
					past.clear();
					for (String sequence : keySet) {
						if (!past.contains(sequence) && count > 0) {
							past.add(sequence);
							result.addAll(sequence2obj.get(sequence));
							count--;
						}
					}
				}
				
			}else {
				int total = objRelationship.size();
				if ("2".equals(unit)) {
					count = (int) Math.ceil(1.0 * total * count / 100);
				}
				count = count > total ? total : count;
				int startIndex = past.size();
				int endIndex = startIndex + count;
				endIndex = endIndex > total ? total : endIndex;
				for (int i = startIndex; i < endIndex; i++) {
					if (!past.contains(objRelationship.getJSONObject(i).getString("obj_id"))) {
						past.add(objRelationship.getJSONObject(i).getString("obj_id"));
						result.add(objRelationship.getJSONObject(i));
						count--;
					}
				}
				if (count>0) {
					past.clear();
					for (int i = 0; i < count; i++) {
						past.add(objRelationship.getJSONObject(i).getString("obj_id"));
						result.add(objRelationship.getJSONObject(i));
						count--;
					}
				}
			}
		}else if ("2".equals(order)) {
			Map<String, JSONArray> sequence2obj = sortBySequence(objRelationship, "sahft_sequence_id");
			if ("1".equals(style)) {
				JSONArray unpastObjRelationship = filterByPass(objRelationship, past, "obj_id");
				sortBySequence(unpastObjRelationship, "sahft_sequence_id");
				Integer cycleTemp = cycle - (frequency % cycle);
				cycle = cycleTemp == 0 ? cycle : cycleTemp;
				count = (int) Math.ceil(unpastObjRelationship.size() * 1.0 / cycle);
				for (int i = 0; i < count; i++) {
					result.add(unpastObjRelationship.getJSONObject(i));
					past.add(unpastObjRelationship.getJSONObject(i).getString("obj_id"));
				}
			}else if ("2".equals(style)) {
	
				Set<String> keySet = sequence2obj.keySet();
				keySet = (TreeSet<String>) keySet;
				count = count > keySet.size() ? keySet.size() : count;
				for (String sequence : keySet) {
					if (!past.contains(sequence) && count > 0) {
						past.add(sequence);
						result.addAll(sequence2obj.get(sequence));
						count--;
					}
				}
				if (count > 0) {
					past.clear();
					for (String sequence : keySet) {
						if (!past.contains(sequence) && count > 0) {
							past.add(sequence);
							result.addAll(sequence2obj.get(sequence));
							count--;
						}
					}
				}
				
			}else {
				int total = objRelationship.size();
				if ("2".equals(unit)) {
					count = (int) Math.ceil(1.0 * total * count / 100);
				}
				count = count > total ? total : count;
				for (int i = 0; i < objRelationship.size(); i++) {
					if (!past.contains(objRelationship.getJSONObject(i).getString("obj_id"))) {
						past.add(objRelationship.getJSONObject(i).getString("obj_id"));
						result.add(objRelationship.getJSONObject(i));
						count--;
					}
				}
				if (count > 0) {
					past.clear();
					for (int i = 0; i < count; i++) {
						past.add(objRelationship.getJSONObject(i).getString("obj_id"));
						result.add(objRelationship.getJSONObject(i));
						count--;
					}
				}
			}
		}else if ("3".equals(order)) {
			sortBySequence(objRelationship, "obj_serial");
			if ("1".equals(style)) {
				JSONArray unpastObjRelationship = filterByPass(objRelationship, past, "obj_id");
				sortBySequence(unpastObjRelationship, "obj_serial");
				Integer cycleTemp = cycle - (frequency % cycle);
				cycle = cycleTemp == 0 ? cycle : cycleTemp;
				count = (int) Math.ceil(1.0*unpastObjRelationship.size()/cycle);
				for (int i = 0; i < count; i++) {
					result.add(unpastObjRelationship.getJSONObject(i));
					past.add(unpastObjRelationship.getJSONObject(i).getString("obj_id"));
				}
			}else {
				if ("2".equals(unit)) {
					count = (int) Math.ceil(1.0*objRelationship.size()*count/100);
				}
				count = count > objRelationship.size() ? objRelationship.size() : count;
				for (int i = 0; i < objRelationship.size(); i++) {
					if (!past.contains(objRelationship.getJSONObject(i).getString("obj_id"))) {
						past.add(objRelationship.getJSONObject(i).getString("obj_id"));
						result.add(objRelationship.getJSONObject(i));
						count--;
					}
				}
				if (count > 0) {
					past.clear();
					for (int i = 0; i < count; i++) {
						if (!past.contains(objRelationship.getJSONObject(i).getString("obj_id"))) {
							past.add(objRelationship.getJSONObject(i).getString("obj_id"));
							result.add(objRelationship.getJSONObject(i));
							count--;
						}
					}
				}
			}
		}else {
			Collections.shuffle(objRelationship);
			if (reset_random) {
				past.clear();
			}
			if ("1".equals(style)) {
				JSONArray unpastObjRelationship = filterByPass(objRelationship, past, "obj_id");
				Integer cycleTemp = cycle - (frequency % cycle);
				cycle = cycleTemp == 0 ? cycle : cycleTemp;
				count = (int) Math.ceil(1.0*unpastObjRelationship.size()/cycle);
				for (int i = 0; i < count; i++) {
					result.add(unpastObjRelationship.getJSONObject(i));
					past.add(unpastObjRelationship.getJSONObject(i).getString("obj_id"));
				}
			}else {
				int total = objRelationship.size();
				if ("2".equals(unit)) {
					count = (int) Math.ceil(1.0*total*count/100);
				}
				count = count > total ? total : count;
				for (int i = 0; i < objRelationship.size(); i++) {
					if (!past.contains(objRelationship.getJSONObject(i).getString("obj_id"))) {
						past.add(objRelationship.getJSONObject(i).getString("obj_id"));
						result.add(objRelationship.getJSONObject(i));
						count--;
					}
				}
				if (count > 0) {
					past.clear();
					for (int i = 0; i < count; i++) {
						if (!past.contains(objRelationship.getJSONObject(i).getString("obj_id"))) {
							past.add(objRelationship.getJSONObject(i).getString("obj_id"));
							result.add(objRelationship.getJSONObject(i));
							count--;
						}
					}
				}
			}
		}
		return result;
	}

	private JSONArray filterByPass(JSONArray objRelationship, JSONArray past , String passField) {
		JSONObject object ;
		JSONArray result = new JSONArray();
		if (past.isEmpty()) {
			result.addAll(objRelationship);
		}else {
			for (int i = 0; i < objRelationship.size(); i++) {
				object = objRelationship.getJSONObject(i);
				if (!past.contains(object.getString(passField))) {
					result.add(objRelationship.getJSONObject(i));
				}
			}
			if (result.isEmpty()) {
				past.clear();
				result.addAll(objRelationship);
			}
		}
		return result;
	}

	private Map<String, JSONArray> sortBySequence(JSONArray objRelationship, String orderField) {

		Map<String, JSONArray> sequence2obj = new HashMap<>();
		JSONArray arr ;
		objRelationship = JSONUtil.sortByStringField(objRelationship, orderField, 1);
		for (int j = 0; j < objRelationship.size(); j++) {
			if (StringUtil.isNull(objRelationship.getJSONObject(j), orderField)) {
				objRelationship.remove(j);
				j--;
			}
			String orderField_value = objRelationship.getJSONObject(j).getString(orderField);
			arr = sequence2obj.getOrDefault(orderField_value, new JSONArray());
			arr.add(objRelationship.getJSONObject(j));
			sequence2obj.put(orderField_value, arr);
		}
		return sequence2obj;
	}
	
	private String getSequenceCode(String order,String objType) {
		String sequenceCode = null;
		if ("1".equals(order)) {
			sequenceCode = "floor_sequence_id";
		} else if ("2".equals(order)) {
			sequenceCode = "shaft_sequence_id";
		} else {
//			sequenceCode = objType.equals("space") ? "space_sequence_id" : "equip_sequence_id";
			sequenceCode = "obj_serial";
		}
		return sequenceCode;
	}

	/*根据空间id或设备id查关系详情（层级结构:建筑->楼层/竖井->空间->设备）*/
	private JSONArray querySpaceOrEquipTree(String projectId, String objType, JSONArray objIds) throws Exception {
		String url = getDataPlatformPath(DataRequestPathUtil.dataPlat_query_space_or_equip);
		JSONObject paramJson = new JSONObject();
		paramJson.put("projectId", projectId);
		paramJson.put("obj_type", objType);
		paramJson.put("obj_ids", objIds);
		String resultStr = httpPostRequestDataPlatform(url, paramJson.toJSONString());
		JSONObject resultJson = JSONObject.parseObject(resultStr);

		return resultJson.getJSONArray(Result.CONTENT);
	}
	/*根据空间id或设备id查关系详情（非层级结构）*/
	@Override
	public JSONArray querySpaceOrEquipNoHierarchy(String projectId, String objType, JSONArray objIds) throws Exception {
		String url = getDataPlatformPath(DataRequestPathUtil.dataPlat_query_space_or_equip_NoHierarchy);
		JSONObject paramJson = new JSONObject();
		paramJson.put("projectId", projectId);
		paramJson.put("obj_type", objType);
		paramJson.put("obj_ids", objIds);
		String resultStr = httpPostRequestDataPlatform(url, paramJson.toJSONString());
		JSONObject resultJson = JSONObject.parseObject(resultStr);
		JSONArray content = resultJson.getJSONArray(Result.CONTENT);
        if (content == null) {
            log.error("querySpaceOrEquipNoHierarchy查询失败:" + resultStr);
            return new JSONArray();
        }
		JSONObject obj ;
		for (Object object : content) {
			obj = (JSONObject)object;
			obj.put("obj_id", obj.getString(objType+"_id"));
			obj.put("obj_name", obj.getString(objType+"_name"));
			obj.put("obj_serial", obj.getString(objType+"_sequence_id"));
			obj.put("obj_type", objType);
			obj.put("obj_code", obj.getString("obj_code"));
			obj.remove(objType + "_id");
			obj.remove(objType + "_name");
		}
		return content;
	}
	
	@Override
	public JSONArray subsetQuery(String projectId, String id, String... type) throws Exception {
		String url = getDataPlatformPath(DataRequestPathUtil.dataPlat_object_subset_query);
		JSONObject param = new JSONObject();
		JSONObject criteria = new JSONObject();
		JSONArray types = new JSONArray();
		for (Object object : type) {
			types.add((String)object);
		}
		criteria.put("id", id);
		criteria.put("type", types);
		param.put("projectId", projectId);
		param.put("criteria", criteria);
		String reusltStr = httpPostRequestDataPlatform(url, param.toJSONString());
		JSONObject reusltObj = JSONObject.parseObject(reusltStr);
		JSONArray content = null;
		if (Result.SUCCESS.equals(reusltObj.getString(Result.RESULT))) {
			content = reusltObj.getJSONArray(Result.CONTENT);
		}else {
			log.error("数据平台"+url+"调用失败："+reusltStr);
		}
		content = content == null ? new JSONArray() : content;

		return content;
	}

	@Override
	public String getProFuncTypeNameById(String proFuncTypeId) throws Exception {
		
		String infoUrl = getDataPlatDictPath(DataRequestPathUtil.dataPlat_dict_query, "building");
		String resultStr = httpPostRequestDataPlatform(infoUrl, "{}");
		JSONObject resultJson = JSONObject.parseObject(resultStr);
		if (Result.FAILURE.equals(resultJson.getString(Result.RESULT))) {
			return "项目名-FAILURE";
		}
		JSONArray content = resultJson.getJSONArray(Result.CONTENT);
		JSONObject proFuncType ;
		for (Object object : content) {
			proFuncType = (JSONObject)object;
			if (proFuncTypeId.equals(proFuncType.getString("code"))) {
				return proFuncType.getString("name");
			}
		}
		return "项目名-NONE";
	}

    @Override
    public JSONArray queryCustomInfoPointList() {
        JSONObject jsonObject = new JSONObject();
        return queryCustomInfoPointList(jsonObject);
    }

    JSONArray queryCustomInfoPointList(JSONObject jsonObject){
        jsonObject.put("valid",true);
        String paramStr = JSONUtil.getCriteriaWithMajors(jsonObject, "valid","custom_info_point_id","custom_info_point_name").toJSONString();
        String resultStr = DBCommonMethods.queryRecordByCriteria(DBConst.TABLE_CUSTOM_INFO_POINT, paramStr);
        jsonObject = JSONObject.parseObject(resultStr);
        JSONArray content = (JSONArray)jsonObject.getOrDefault(Result.CONTENT, new JSONArray());
        for (int i = 0; i < content.size(); i++) {
            JSONObject node = content.getJSONObject(i);
            node.put("details", JSONObject.parseObject(node.getString("details")));
        }
        return (JSONArray)jsonObject.getOrDefault(Result.CONTENT,new JSONArray());
    }

    @Override
    public boolean addCustomInfoPoint(JSONObject jsonObject) {

	    //=========验证custom_info_point_name 重复
        JSONObject param = new JSONObject();
        param.put("custom_info_point_name", jsonObject.getString("custom_info_point_name"));
        JSONArray jsonArray = queryCustomInfoPointList(param);
        if (CollectionUtils.isNotEmpty(jsonArray)){
            return false;
        }

        //========添加数据
        jsonObject.put("custom_info_point_id", ToolsUtil.getUuid());
        jsonObject.put("valid", true);
        String nowTimeStr = DateUtil.getNowTimeStr();
        jsonObject.put("create_time", nowTimeStr);
        jsonObject.put("update_time", nowTimeStr);
        jsonObject = JSONUtil.getJsonObjectWithKeys(jsonObject,CommonMessage.table_column_custom_info_point);
        jsonObject = JSONUtil.prossesParamToJsonString(jsonObject, "details");
        String paramStr = JSONUtil.getAddParamJson(jsonObject).toJSONString();
        String resultStr = DBCommonMethods.insertRecord(DBConst.TABLE_CUSTOM_INFO_POINT, paramStr);
        jsonObject = JSONObject.parseObject(resultStr);

        return Result.SUCCESS.equals(jsonObject.getString(Result.RESULT));
    }

    @Override
    public boolean updateCustomInfoPoint(JSONObject jsonObject) {
        //======验证custom_info_point_name 重复
        JSONObject param = new JSONObject();
        param.put("custom_info_point_name", jsonObject.getString("custom_info_point_name"));
        JSONArray jsonArray = queryCustomInfoPointList(param);
        if (CollectionUtils.isNotEmpty(jsonArray)){
            String custom_info_point_id = jsonObject.getString("custom_info_point_id");
            for (int i = 0; i < jsonArray.size(); i++) {
                if (!custom_info_point_id.equals(jsonArray.getJSONObject(i).getString("custom_info_point_id"))){
                    return false;
                }
            }
        }

        //======更新数据
        jsonObject.put("update_time", DateUtil.getNowTimeStr());
        jsonObject = JSONUtil.getJsonObjectWithKeys(jsonObject,CommonMessage.table_column_custom_info_point);
        jsonObject = JSONUtil.prossesParamToJsonString(jsonObject, "details");
        String paramStr = JSONUtil.getUpdateParamJson(jsonObject,"custom_info_point_id").toJSONString();
        String resultStr = DBCommonMethods.updateRecord(DBConst.TABLE_CUSTOM_INFO_POINT, paramStr);
        jsonObject = JSONObject.parseObject(resultStr);

        return Result.SUCCESS.equals(jsonObject.getString(Result.RESULT));
    }

    @Override
    public boolean delelteCustomInfoPointById(JSONObject jsonObject) {

        //=====逻辑移除数据
        jsonObject.put("update_time", DateUtil.getNowTimeStr());
        jsonObject.put("valid", false);
        jsonObject = JSONUtil.getJsonObjectWithKeys(jsonObject,CommonMessage.table_column_custom_info_point);
        String paramStr = JSONUtil.getUpdateParamJson(jsonObject,"custom_info_point_id").toJSONString();
        String resultStr = DBCommonMethods.updateRecord(DBConst.TABLE_CUSTOM_INFO_POINT, paramStr);
        jsonObject = JSONObject.parseObject(resultStr);

        return Result.SUCCESS.equals(jsonObject.getString(Result.RESULT));
    }

}
